SET SQL_MODE = "NO_AUTO_VALUE_ON_ZERO";

CREATE TABLE `k8components` (
	`componentID` INT(10) NOT NULL AUTO_INCREMENT,
	`clientID` INT(10) NULL DEFAULT NULL,
	`componentnumber` VARCHAR(20) NULL DEFAULT NULL,
	`status` TINYINT(4) NULL DEFAULT '0',
	`text1` VARCHAR(50) NULL DEFAULT NULL,
	`text2` VARCHAR(50) NULL DEFAULT NULL,
	`textdimensions` TEXT NULL DEFAULT NULL,
	`descriptionlong` TEXT NULL DEFAULT NULL,
	`category` VARCHAR(20) NULL DEFAULT NULL,
	`baseunit` VARCHAR(10) NULL DEFAULT NULL,
	`salesunit` VARCHAR(10) NULL DEFAULT NULL,
	`vatclass` INT(11) NULL DEFAULT NULL,
	`conversionfactorsales` FLOAT NULL DEFAULT NULL,
	`servicefactor` DECIMAL(5,5) NULL,
	`price` FLOAT NULL DEFAULT NULL,
	`creatorID` INT(11) NULL DEFAULT NULL,
	`datecreated` DATETIME NULL DEFAULT NULL,
	PRIMARY KEY (`componentID`),
	INDEX `componentnumber` (`componentnumber`)
);

CREATE TABLE `k8documents` (
	`docID` INT(10) NOT NULL AUTO_INCREMENT,
	`clientID` INT(10) NULL DEFAULT NULL,
	`doctypeID` INT(11) NULL DEFAULT NULL,
	`docnumber` INT(10) NULL DEFAULT NULL,
	`docdate` DATE NULL DEFAULT NULL,
	`accountID` INT(11) NULL DEFAULT NULL,
	`partnernumber` VARCHAR(50) NULL DEFAULT NULL,
	`name1` VARCHAR(60) NULL DEFAULT NULL,
	`name2` VARCHAR(60) NULL DEFAULT NULL,
	`street` VARCHAR(60) NULL DEFAULT NULL,
	`code` VARCHAR(10) NULL DEFAULT NULL,
	`country` VARCHAR(10) NULL DEFAULT NULL,
	`city` VARCHAR(60) NULL DEFAULT NULL,
	`amount_gross` FLOAT NULL DEFAULT NULL,
	`creatorID` INT(11) NULL DEFAULT NULL,
	`datecreated` DATETIME NULL DEFAULT NULL,
	PRIMARY KEY (`docID`)
);

CREATE TABLE `k8documentitems` (
	`itemID` INT(10) NOT NULL AUTO_INCREMENT,
	`clientID` INT(10) NULL DEFAULT NULL,
	`docID` INT(11) NULL DEFAULT NULL,
	`position` INT(10) NULL DEFAULT NULL,
	`componentID` INT(11) NULL DEFAULT NULL,
	`componentnumber` VARCHAR(50) NULL DEFAULT NULL,
	`text1` VARCHAR(50) NULL DEFAULT NULL,
	`quantity` FLOAT NULL DEFAULT NULL,
	`pricesingle` FLOAT NULL DEFAULT NULL,
	`pricetotal` FLOAT NULL DEFAULT NULL,
	PRIMARY KEY (`itemID`)
);


CREATE TABLE `er_customer` (
	`accountID` INT(10) NOT NULL AUTO_INCREMENT,
	`clientID` INT(10) NOT NULL,
	`accountnumber` INT(10) NOT NULL,
	`name1` VARCHAR(50) NULL DEFAULT NULL,
	`name2` VARCHAR(50) NULL DEFAULT NULL,
	`street` VARCHAR(50) NULL DEFAULT NULL,
	`country` VARCHAR(10) NULL DEFAULT NULL,
	`code` VARCHAR(10) NULL DEFAULT NULL,
	`city` VARCHAR(50) NULL DEFAULT NULL,
	`creatorID` INT(10) NOT NULL,
	PRIMARY KEY (`accountID`)
);

CREATE TABLE `er_deliveryaddress` (
	`addressID` INT(10) NOT NULL AUTO_INCREMENT,
	`clientID` INT(10) NOT NULL,
	`accountID` INT(10) NOT NULL,
	`name1` VARCHAR(50) NULL DEFAULT NULL,
	`name2` VARCHAR(50) NULL DEFAULT NULL,
	`street` VARCHAR(50) NULL DEFAULT NULL,
	`country` VARCHAR(10) NULL DEFAULT NULL,
	`code` VARCHAR(10) NULL DEFAULT NULL,
	`city` VARCHAR(50) NULL DEFAULT NULL,
	PRIMARY KEY (`addressID`)
);

CREATE TABLE `er_employee` (
	`employeeID` INT(10) NOT NULL AUTO_INCREMENT,
	`clientID` INT(10) NOT NULL,
	`accountID` INT(10) NOT NULL,
	`gender` VARCHAR(10) NULL DEFAULT NULL,
	`firstname` VARCHAR(50) NULL DEFAULT NULL,
	`lastname` VARCHAR(50) NULL DEFAULT NULL,
	`departement` VARCHAR(50) NULL DEFAULT NULL,
	`phone` VARCHAR(50) NULL DEFAULT NULL,
	`email` VARCHAR(50) NULL DEFAULT NULL,
	PRIMARY KEY (`employeeID`)
);


CREATE TABLE `TPareas` (
	`areaID` INT(10) NOT NULL AUTO_INCREMENT,
	`clientID` INT(10) NOT NULL,
	`projectID` INT(10) NOT NULL,
	`areaname` VARCHAR(50) NOT NULL,
	PRIMARY KEY (`areaID`)
);

CREATE TABLE `TPpoints` (
	`pointID` INT(10) NOT NULL AUTO_INCREMENT,
	`clientID` INT(10) NOT NULL,
	`surfaceID` INT(10) NOT NULL,
	`at` VARCHAR(10) NULL DEFAULT NULL,
	`x` INT(10) NULL DEFAULT NULL,
	`y` INT(10) NULL DEFAULT NULL,
	PRIMARY KEY (`pointID`)
);

CREATE TABLE `TPprojects` (
	`projectID` INT(10) NOT NULL AUTO_INCREMENT,
	`clientID` INT(10) NOT NULL,
	`projectname` VARCHAR(50) NOT NULL,
	`creatorID` INT(10) NOT NULL,
	PRIMARY KEY (`projectID`),
	INDEX `Schl�ssel 2` (`projectname`)
);

CREATE TABLE `TPsurfaces` (
	`surfaceID` INT(10) NOT NULL AUTO_INCREMENT,
	`clientID` INT(10) NOT NULL,
	`areaID` INT(10) NOT NULL,
	`surfacename` VARCHAR(50) NOT NULL,
	`type` SMALLINT(6) NOT NULL DEFAULT '0',
	PRIMARY KEY (`surfaceID`)
);


CREATE TABLE `hrhelprequest` (
	`requestID` INT(10) NOT NULL AUTO_INCREMENT,
	`clientID` INT(10) NOT NULL,
	`title` VARCHAR(50) NOT NULL,
	`status` TINYINT(4) NULL DEFAULT NULL,
	`categoryID` INT(11) NULL DEFAULT NULL,
	`descriptionshort` VARCHAR(255) NOT NULL,
	`descriptionlong` TEXT NOT NULL,
	`frequencymode` TINYINT(4) NOT NULL,
	`frequencytext` VARCHAR(50) NULL DEFAULT NULL,
	`startdatetime` DATETIME NOT NULL,
	`enddatetime` DATETIME NULL DEFAULT NULL,
	`latitude` INT(11) NULL DEFAULT NULL,
	`longitude` INT(11) NULL DEFAULT NULL,
	`city` VARCHAR(50) NOT NULL,
	`partoftown` VARCHAR(50) NOT NULL,
	`creatorID` INT(10) NOT NULL,
	`datetimecreated` DATETIME NOT NULL,
	PRIMARY KEY (`requestID`)
);

CREATE TABLE `hrhelpoffer` (
	`offerID` INT(10) NOT NULL AUTO_INCREMENT,
	`clientID` INT(10) NOT NULL,
	`requestID` INT(10) NOT NULL,
	`message` VARCHAR(500) NOT NULL,
	`creatorID` VARCHAR(500) NOT NULL,
	`datetimecreated` DATETIME NOT NULL,
	PRIMARY KEY (`offerID`)
);