// K8 Web Construction Kit, 2021-08-25 Copyright Klaus Eisert
//"use strict";

(function($){
$.fn.myPlugin = function(options) {
    // support multiple elements
    if (this.length > 1){
        this.each(function(){ 
            $(this).myPlugin(options);
        });
        return this;
    }

    // private variables
    var pOne = '1';
    var pTwo = '2';
    // ...

    // private methods
    var foo = function() {
        // do something ...
    };
    // ...

    // public methods        
    this.initialize = function() {
        // do something ...
        return this;
    };

    this.bar = function() {
        console.log('bar');
    };
    return this.initialize();
};
})(jQuery);


/*  --------------- customizeMenuItem
var menu=[
  {
    "ID":"0",
    "url":"index.php?page=Home",
    "target":"",
    "title":"Home",
    "condition":"jscode für eval",
    "children":[]
  },
  {
    "ID":"1",
    "url":"index.php?page=Belege",
    "target":"",
    "title":"Belege",
    "condition":"",
    "children":[
      {
        "ID":"2",
        "url":"index.php?page=dddd",
        "target":"",
        "title":"dddd",
        "condition":"jscode für eval",
        "children":[
        ]
      }
    ]
  }
];

// mode -1=entfernen, 0=ersetzen, 1=anfügen
var changes=[
  {
    "IDreference":"2",
    "mode":0,
    "menu":[{
      "ID":"1001",
      "url":"index.php?page=BelegeNeu",
      "target":"",
      "title":"Belege Neu",
      "condition":"jscode für eval",
      "children":[]
    }]
  }  
];
customizeMenu(menu,changes);
console.log(menu);
*/

function customizeMenu(menu,changes){
  for(var i=0;i<changes.length;i++){
    customizeMenuItem(menu,changes[i]);
  }
}

function customizeMenuItem(menu,item){
  var prop=item['IDreference'];
  var i=0;
  while(i<menu.length){
    if(menu[i]['ID']==prop){
      switch(item['mode']){
        case -1: //delete
          delete(menu[i]);
          break;
        case 0: //replace
          menu[i]=item['menu'][0];
          break;
        default: //append
          for(var n=0;n<item['menu'].length;n++){
            menu.splice(i+1,0,item['menu'][n]);
            i++;
          }
      }
    }else{
      if(menu[i]['children']){
        customizeMenuItem(menu[i]['children'],item)
      }
    }
    i++;
  }
}

/*  --------------- arraySortByArray
var array=[
        {title:"Name", field:"name", editor:"input"},
        {title:"Gender", field:"gender", width:95, editor:"select", editorParams:{values:["male", "female"]}},
        {title:"Rating", field:"rating", formatter:"star", hozAlign:"center", width:100, editor:true},
        {title:"Driver", field:"car", width:90,  hozAlign:"center", formatter:"tickCross", sorter:"boolean", editor:true},
    ];
var array_order=["car","gender","name","rating"];
array=arraySortByArray(array,"field",array_order);
console.log(array);
*/
function arraySortByArray(array,prop,array_order){
	return array.sort(function (a, b){
    if(array_order.indexOf(a[prop])>array_order.indexOf(b[prop])){
        return 1;
    }else{
        return -1;
    }
    return 0;
  });
}

function getArrayIndexfromValue(arr,field,value){
    var index=-1;
    if(Array.isArray(arr)){
        for(var i=0;i<arr.length;i++){
            if(isset(arr[i],field)){
                if(arr[i][field]==value){
                    index=i;
                    break;
                }
            }
        }
    }
    return index;
}

/* examples
var o={"number":4511,"items":[
    {"position":1,"times":[
        {"ID":1,"time":"10:00"},
        {"ID":2,"time":"10:00"}
      ]
    }
  ]
};
var fullname="items[0][position]";
var indexes=["items",0,"position"];
var o_sub=getObjectValuefromIndexArray(o,indexes);
console.log(o_sub);
//delete(o_sub);
//console.log(o);
console.log(getIndexArrayfromName(fullname));
console.log(getObjectValuefromName(o,fullname));
*/

function getObjectValuefromName(obj,fullname){
  var indexes=getIndexArrayfromName(fullname);
  //console.log(indexes);
  return getObjectValuefromIndexArray(obj,indexes);
}

function getObjectValuefromIndexArray(obj,indexes){
  //indexes=["items",0,"position"];
  var i=0;
  var onew=[];
  onew[i]=obj;
  //console.log(indexes)
  indexes.forEach(function(prop){
      i++;
      if(onew[i-1]){
        if(onew[i-1][prop]=='undefined'){
          return;
        }else{
          onew[i]=onew[i-1][prop];
        }
      }
  });
  return onew[i];
}

function getIndexArrayfromName(fullname){
  //items[0][itemID]
  var indexes=[];
  
  while(fullname.length>0){
    var pos1=fullname.indexOf('[');
    if(pos1>=0){
      var part1;
      if(pos1==0){
        var pos2=fullname.indexOf(']');
        part1=fullname.slice(pos1+1,pos2);
        fullname=fullname.substr(pos2+1);
    }else{
        var pos2=fullname.indexOf('[');
        part1=fullname.slice(0,pos2);
        fullname=fullname.substr(pos2);
      }
      indexes.push(part1);
    }else{
      fullname='';
    }
  }
  return indexes;
}

function getIndexPairs(el_rec_lfd){
  var indexes={};
  do{
      var el_rec_contlfd=$(el_rec_lfd).parents('.js_rec_container')[0];
      var indexlfd=Number(el_rec_lfd.dataset.rec_index);
      var arrayname=el_rec_contlfd.dataset.rec_object;
      indexes[arrayname]=indexlfd;
      el_rec_lfd=$(el_rec_contlfd).parents('.js_rec_record')[0];
  }while(typeof(el_rec_lfd)!=="undefined")
  return indexes;
}

function getIndexesfrom(el_rec_lfd){
  var index_arr=[];
  do{
      var el_rec_contlfd=$(el_rec_lfd).parents('.js_rec_container')[0];
      var indexlfd=Number(el_rec_lfd.dataset.rec_index);
      index_arr.push(indexlfd);
      var arrayname=el_rec_contlfd.dataset.rec_object;
      index_arr.push(arrayname);
      el_rec_lfd=$(el_rec_contlfd).parents('.js_rec_record')[0];
  }while(typeof(el_rec_lfd)!=="undefined")
  return index_arr;
}

function replaceElWith(el,html){
  var mydiv = document.createElement("div");
  mydiv.innerHTML = html;
  if(mydiv.childNodes.length>0){
    var myChild=mydiv.childNodes[0];
    el.parentNode.replaceChild(myChild,el);
    return myChild;
  }else{
    return el;
  }
}

var k8pagetimer={
    interval:5000,
    maxtime:1000*60*20,
    idtimer:"pagetimer",
    format:"mm:ss", /*"hh:mm:ss",*/
    url_logout:"",
    url_login:"",
    mytime:0,
    el_timer:0,
    init:function(options){
        if(options.interval)this.interval=options.interval;
        if(options.maxtime)this.maxtime=options.maxtime;
        if(options.idtimer)this.idtimer=options.idtimer;
        if(options.format)this.format=options.format;
        if(options.url_logout){
            this.url_logout=options.url_logout;
        }else{
            console.log("url_logout not set!");
            return;
        }
        if(options.url_login){
            this.url_login=options.url_login;
        }else{
            console.log("url_login not set!");
            return;
        }
        this.mytime=this.maxtime;
        this.el_timer=document.getElementById(this.idtimer);
        if(this.el_timer)this.display();
    },
    reset:function(){
        this.mytime=this.maxtime;
        if(this.el_timer)this.display();
    },
    display:function(){
        var hours = Math.floor(this.mytime /(1000 * 60 * 60));
        var minutes = Math.floor((this.mytime % (1000 * 60 * 60)) / (1000 * 60));
        var seconds = Math.floor((this.mytime % (1000 * 60)) / 1000);
        var temp=this.format.replace('hh',String(hours).padStart(2, '0'));
        temp=temp.replace('mm',String(minutes).padStart(2, '0'));
        temp=temp.replace('ss',String(seconds).padStart(2, '0'));
        this.el_timer.innerHTML = temp;
    }
};

var k8tabulator={
    accessor:function(value, data, type, params, column, row){
	//value - original value of the cell
	//data - the data for the row
	//type - the type of access occurring  (data|download|clipboard)
	//params - the accessorParams object passed from the column definition
	//column - column component for the column this accessor is bound to
	//row - row component for the row
        if(value==null){
            value="";
        }else if(column.getDefinition().formatter=="money"){
            var params=column.getDefinition().formatterParams;
            if(params.precision==undefined){
                value=value.toString();
            }else{
                value=Number(value).toFixed(params.precision);
            }
            /*
            if(params.decimal!=undefined){
                value=value.replace(".",",");
            }
            if(params.thousand!=undefined){
                var thousand=getfromArray(params,"thousand",",");
                value=value.replace(/(\d)(?=(\d{3})+(?!\d))/g, '$1'+thousand);
            }
            */
           return Number(value);
        }else if(column.getDefinition().formatter=="datetime"){
            var formatterParams=column.getDefinition().formatterParams;
            var inputFormat = formatterParams.inputFormat || "YYYY-MM-DD hh:mm:ss";
            var outputFormat = formatterParams.outputFormat || "DD/MM/YYYY hh:mm:ss";
            var invalid = typeof formatterParams.invalidPlaceholder !== "undefined" ? formatterParams.invalidPlaceholder : "";

            var newDatetime = moment(value, inputFormat);

            if (newDatetime.isValid()) {
                    return formatterParams.timezone ? newDatetime.tz(formatterParams.timezone).format(outputFormat) : newDatetime.format(outputFormat);
            } else {

                    if (invalid === true) {
                            return value;
                    } else if (typeof invalid === "function") {
                            return invalid(value);
                    } else {
                            return invalid;
                    }
            }
        }else{
            //value=k8tabulator.utf8decode(value);
        }
	return value;  //Math.floor(value); //return the new value for the cell data.
    },
    utf8encode : function (string) {
        string = string.replace(/\r\n/g,"\n");
        var utftext = "";
        for (var n = 0; n < string.length; n++) {
            var c = string.charCodeAt(n);
            if (c < 128) {
                utftext += String.fromCharCode(c);
            }
            else if((c > 127) && (c < 2048)) {
                utftext += String.fromCharCode((c >> 6) | 192);
                utftext += String.fromCharCode((c & 63) | 128);
            }
            else {
                utftext += String.fromCharCode((c >> 12) | 224);
                utftext += String.fromCharCode(((c >> 6) & 63) | 128);
                utftext += String.fromCharCode((c & 63) | 128);
            }
        }
        return utftext;
    },
    utf8decode : function (s) {
        /*
        var arr=s.split("");
        for(var i=0;i<arr.length;i++){
            //console.log(s.substr(i,1)+":"+s.charCodeAt(i));
            console.log(arr[i]+":"+arr[i].charCodeAt(0));
        }
        */
        return "s";
    }       
};


function checkdatadef(obj){
    if(isset(obj,"jsonform","schema")){
        for(prop in obj.jsonform.schema){
            if(obj.jsonform.schema.hasOwnProperty(prop)){
                console.log(prop)
                var field=obj.jsonform.schema[prop];
                if(field.hasOwnProperty("enum")){
                    var myenum=field.enum;
                    for(var i=0;i<myenum.length;i++){
                        myenum[i]=myenum[i].toString();
                    }
                }
            }            
        }
    }
}

function filter2url(headerfilters,selects,multiselect){
    if (window.history.replaceState) {
        var baseurl=window.location.href.split('?')[0];
        var baseqry="";
        //var objqry={};
        var obj=Array_GET();
        for(var prop in obj){
            if(obj.hasOwnProperty(prop)){
                if(prop.substring(0,8)!=="filters["){
                    baseqry+='&'+prop+'='+obj[prop];
                }
            }
        }
        obj.selects=selects;
        var qry=filter2querystring(headerfilters);
        //if(!gbnull(qry)){
            var url=baseurl+'?'+baseqry.substr(1)+qry;
            window.history.replaceState(null, document.title, url);
        //}
    }        
}

function filter2querystring(filters){
    var qs="";
    for(var i=0;i<filters.length;i++){
        qs+='&filters['+i+'][field]='+filters[i]['field']+'&filters['+i+'][type]='+filters[i]['type']+'&filters['+i+'][value]='+filters[i]['value'];
    }
    return qs;
}

Date.prototype.asString = function(generalformat){
    generalformat= typeof generalformat !== 'undefined' ? generalformat : 0;
    var year = this.getFullYear();
    var month = '0' + (this.getMonth() + 1);
    month = month.slice(-2, (month.length - 2) + 3);
    var day = '0' + this.getDate();
    day = day.slice(-2, (day.length - 2) + 3);
    //var generalformat=1;    
    
    if(generalformat==1){
        return day + '.' + month + '.' + year;
    }else{
        return year + '-' + month + '-' + day;
    }
}

Date.prototype.asTime = function(nformat){
    var minutes = '0' + (this.getMinutes());
    minutes = minutes.slice(-2, (minutes.length - 2) + 3);
    var hours = '0' + (this.getHours());
    hours = hours.slice(-2, (hours.length - 2) + 3);
    
    return hours + ':' + minutes;
}

Date.prototype.add = function(count,format){
    // format:
    // 0 Millisekunden
    // 1 Sekunden
    // 2 Minuten
    // 3 Stunden
    // 4 Tage
    // 5 Wochen
    // 6 später Monate
    // 7 später Jahre
    switch(format){
    case 0:
        var milliseconds=count;
        break;
    case 1:
        var milliseconds=count*1000;
        break;
    case 2:
        var milliseconds=count*60*1000;
        break;
    case 3:
        var milliseconds=count*60*60*1000;
        break;
    case 4:
        var milliseconds=count*24*60*60*1000;
        break;
    case 5:
        var milliseconds=count*7*24*60*60*1000;
        break;
    default:
        var milliseconds=0;
    }
    //alert(milliseconds.toString()+'/'+count.toString()+'/'+format.toString());
    return this.setTime(this.getTime()+milliseconds);
}

Date.prototype.addtime = function(timestring){
    // timestring: 10:00
    var milliseconds=0;
    if(timestring.indexOf(':')>0){
        var arr=timestring.split(':');
        milliseconds=arr[0]*60*60*1000 + arr[1]*60*1000;
    }
    return this.setTime(this.getTime()+milliseconds);
}

Date.prototype.setDaytime = function(timestring){
    // timestring: 10:00
    var milliseconds=0;
    if(timestring.indexOf(':')>0){
        var arr=timestring.split(':');
    }
    var newdate=new Date(this.getFullYear(),this.getMonth(),this.getDate(),arr[0],arr[1],0,0);
    return this.setTime(newdate.getTime());
}

Date.prototype.difference = function(mydate,format,bint,ndec){
    // format:
    // 0 Millisekunden
    // 1 Sekunden
    // 2 Minuten
    // 3 Stunden
    // 4 Tage
    // 5 Wochen
    // 6 später Monate
    // 7 später Jahre
    bint= typeof bint !== 'undefined' ? bint : 0;
    //ndec= typeof ndec !== 'undefined' ? ndec : 9;
    
    var result=0;
    var milliseconds=mydate-this;
    //document.getElementById("output").innerHTML="from / to / milliseconds: " + mydate.asString(1) + " / " + this.asString(1) + " / " + milliseconds;

    switch(format){
    case 0:
        result= milliseconds;
        break;
    case 1:
        //result=Math.round(milliseconds/1000);
        //result=parseInt(milliseconds/1000);
        result=(milliseconds/1000);
        break;
    case 2:
        //result=Math.round(milliseconds/(60*1000));
        //result=parseInt(milliseconds/(60*1000));
        result=(milliseconds/(60*1000));
        break;
    case 3:
        //result=Math.round(milliseconds/(60*60*1000));
        //result=parseInt(milliseconds/(60*60*1000));
        result=(milliseconds/(60*60*1000));
        break;
    case 4:
        //result=Math.round(milliseconds/(24*60*60*1000));
        //+1 Stunde, wegen Sommerzeit 3600000
        //result=parseInt((milliseconds+3600000)/(24*60*60*1000));
        result=((milliseconds+3600000)/(24*60*60*1000));
        break;
    case 5:
        //result=Math.round(milliseconds/(7*24*60*60*1000));
        //+1 Stunde, wegen Sommerzeit 3600000
        //result=parseInt((milliseconds+3600000)/(7*24*60*60*1000));
        result=((milliseconds+3600000)/(7*24*60*60*1000));
        break;
    }
    if(bint){
        result=parseInt(result);
    }
    if(typeof ndec !== 'undefined'){
        result=ground(result,ndec);
    }
    return result;
}

JSONForm.fieldTypes['htmlsnippet'] = {
    template: '<%=node.value%>'
};

function conditional_output(el){
  el_conditions=$(el).find('*[data-v_if]');
  for(var i=0;i<el_conditions.length;i++){
    var str=el_conditions[i].dataset.v_if;
    //console.log("str=" + str); 
   try{
      if(!eval(str)){
        //$(el_conditions[i]).hide();
        //el_conditions[i].remove();
        $(el_conditions[i]).empty();
      }
    }
    catch(e){
      // error
      console.log('error by expression: '+str);
    }
  }
}        

function ground(value, dec, mode) {
    // mode 0=kaufmännisch, 1=aufrunden, 2=abrunden
    dec= typeof dec !== 'undefined' ? dec : 0;
    mode= typeof mode !== 'undefined' ? mode : 0;
    if(isNaN(value)){
        mydec=0;
    }else{
        if(mode==1){
            value=value+.4999999*Math.pow(10,-dec)
        }else if(mode==2){
            value=value-.5*Math.pow(10,-dec)
        }
        mydec=Math.round(value*Math.pow(10,dec))/Math.pow(10,dec);
    }
    return mydec;
}

function array2Options(arr){
    var html="";
    for(var i=0;i<arr.length;i++){
      var attributes="";
      /*
      if (typeof arr[i] === 'string'){
        html+='<option>'+arr[i]+'</option>';
      }else{
      */
      if (typeof arr[i] === 'object'){
        var obj=arr[i];
        for(prop in obj){
          if(obj.hasOwnProperty(prop)){
            if(prop=="selected"){
              if(obj[prop])attributes+=" selected";
            }else if(prop=="text"){
              // look beneath
            }else{
              attributes+=" "+prop+"=\""+obj[prop]+"\"";
            }
          }
        }
        html+='<option{{attributes}}>'.replace('{{attributes}}',attributes)+getfromArray(arr[i],"text")+'</option>';
      }else{
        html+='<option>'+arr[i]+'</option>';
      }
    }
    return html;
}

function options2Select(el,arr){
    $(el).empty(); // remove old options
    for(var i=0;i<arr.length;i++) {
        if(arr[i]){
            $(el).append($("<option></option>")
               .attr("value", arr[i].value).text(arr[i].text));
            /*
            if(arr[i]['ID']){
                $(el).append($("<option></option>")
                   .attr("value", arr[i].ID).text(arr[i].displayname));
            }else{
                $(el).append($("<option></option>")
                   .attr("value", arr[i].value).text(arr[i].text));
            }
            */
       }
    }
}


function displayDropdownHTML(options){
    // under construction
    //https://getbootstrap.com/docs/3.3/components/
    var html="";
    if(obj['items']){
        var obj=$.extend(true,{'class_ul':'dropdown-menu'},options);
        var class_str_li="";
        if(obj['class_li']){
            var class_str_li=' class="'+obj['class_li']+'"';
        }
        
        // ------------- button
        var label='please select';
        if(obj['value_selected']){
            for(var i=0;i<obj['items'].length;i++){
                if(obj['items'][i]['value']==obj['value_selected']){
                    label=getfromArray(obj,'pretext')+obj['items'][i]['label'];
                }
            }
        }
        html+='<a class="btn btn-primary dropdown-toggle" data-toggle="dropdown">'+label+' <span class="caret"></span></a>';
        
        // ----------- ul
        html+='<ul class="'+obj.class_ul+'">';
        for(var i=0;i<obj['items'].length;i++){
            if(obj['items'][i]['value']!==obj['value_selected']){
                html+='<li'+class_str_li+'><a data-value="'+obj['items'][i]['value']+'" href="'+obj['items'][i]['link']+'">'+obj['items'][i]['label']+'</a></li>';
            }
        }
        html+='</ul>';
    }
    return html;
}

function displayDropdownel(options){
    var obj=$.extend(true,{
        'button':{
            'text':'please select',
            'carettype':1,
        },
        'class_ul':'dropdown-menu'},options);
    if(obj['items']){
        var el_dd=obj.el_dd;
        el_dd.classList.add('dropdown');
        var class_str_li="";
        if(obj['class_li'])class_str_li=' class="'+obj['class_li']+'"';
        var label=obj.button.text;
        if(obj['value_selected']){
            for(var i=0;i<obj['items'].length;i++){
                if(obj['items'][i]['value']==obj['value_selected']){
                    label=getfromArray(obj.button,'pretext')+obj['items'][i]['label'];
                }
            }
        }else if(isset(obj,"button","text")){
            label=obj.button.text;
        }
        var caret='';
        if(obj.button.carettype==1){
            caret=' <span class="caret"></span>';
        }
        $('<a class="btn btn-default dropdown-toggle" data-toggle="dropdown">'+label+caret+'</a>').appendTo(el_dd);
        
        // ----------- ul
        el_ul=$('<ul class="'+obj.class_ul+'">').appendTo(el_dd)[0];
        for(var i=0;i<obj['items'].length;i++){
            if(obj['items'][i]['value']!==obj['value_selected']){
                el_li=$('<li'+class_str_li+'><a class="'+getfromArray(obj['items'][i],'class_a')+'"'+
                    ' data-value="'+obj['items'][i]['value']+'" href="'+getfromArray(obj['items'][i],'href','#',true)+'">'+obj['items'][i]['label']+'</a></li>').appendTo(el_ul);
            }
        }
    }
}

function getl(word){
    // text, textnew
    if(typeof text=='undefined'){
        return word;
    }else if(text.hasOwnProperty(word)){
        return text[word];
    }else{
        if(typeof textnew!=='undefined'){
            textnew[word]=word;
        }
        return word;
    }
}

function form2obj(el_form){
  var obj={};
  for(var n=0;n<el_form.elements.length;n++){
    var el=el_form.elements[n];
    //var type=typeof el.type !== "undefined" ? "" : el.type;
    var type=el.type;
    if(el.length){
      if(el.type=="select-multiple"){
        var prop=el.name.replace('[]','');
        obj[prop]=[];
        for(var i=0;i<el.length;i++){
          var el_opt=el[i];
          if(el_opt.selected){
            obj[prop].push(el_opt.value);
          }
        }
      }else if(el.type=="select-one"){
        obj[el.name]=el.value;
      }else{
        console.log(el.name+' not supported');
      }
    }else if(type=="checkbox"){
        if(el.checked){
          obj[el.name]=el.value;
        }else{
          //obj[el.name]=null;
          obj[el.name]=0;
        }
    }else if(type=="radio"){
        if(el.checked){
          obj[el.name]=el.value;
        }else if(!obj[el.name]){
          obj[el.name]=null;
        }
    }else{
      obj[el.name]=el.value;
    }
  }
  return obj;
}

function obj2form(obj,el_form,bonlyadd){
  bonlyadd=typeof bonlyadd!=='undefined' ? bonlyadd : false;        
  if(bonlyadd){
    for(var prop in obj){
        var name=prop;
        el=el_form.elements.namedItem(name);
        if(el!=undefined){
            if(el.length){
                var type=el[el.length-1].type;
                if(type=="checkbox"){
                    el=el[el.length-1];
                    if(Number(obj[prop])){
                        el.checked=true;
                    }else{
                        el.checked=false;
                    }
                }else if(type=="radio"){
                    $(el_form).find("input[name='"+name+"'][value='"+obj[prop]+"']").prop('checked', true);
                }else{
                    //console.log('fill out form, new type='+type);
                    $(el).val(obj[prop]);
                }
            }else{
                if(el.disabled){
                    el.disabled=false;
                    //el.value=obj[prop];
                    gFormatinputfordisplay(el,obj[prop]);
                    el.disabled=true;
                }else{
                    //el.value=obj[prop];
                    gFormatinputfordisplay(el,obj[prop]);
                }
            }
        }else{
            //console.log('element: '+name+ " don't exist!"); 
        }
    }
  }else{
    for(var n=0;n<el_form.elements.length;n++){
      var el=el_form.elements[n];
      var prop=el.name;
      if(prop.indexOf('[')>=0 && prop.indexOf('[]')<0){
        var value=getObjectValuefromName(obj,prop);
        if(value!=undefined){
          el.value=value;
        }else{
          el.value="";
        }
      }else{
        if(el.tagName=="BUTTON" || el.type=="BUTTON" || el.type=="submit"){
          // nothing
        }else if(el.tagName=="SELECT"){
            //console.log(el.type);
            if(el.name.indexOf('[]')>-1){
              prop=prop.replace('[]','');
              if(obj.hasOwnProperty(prop)){
                if(Array.isArray(obj[prop])){
                  for(var i=0;i<el.length-1;i++){
                    var el_opt=el[i];
                    if(obj[prop].indexOf(el_opt.value)>-1){
                      el_opt.selected=true;
                    }else{
                      el_opt.selected=false;
                    }
                  }
                }else{
                  el.value=obj[prop];
                }
              }else{
                el.value="";
              }                  
            }else{
              if(obj.hasOwnProperty(prop)){
                el.value=obj[prop];
              }else{
                el.value=null;
              }
            }
        }else{
          if(obj.hasOwnProperty(prop)){
            if(el.type=="checkbox"){
              if(gbnull(obj[prop])){
                el.checked=false;
              }else{
                //el.value=obj[prop];
                el.checked=true;
              }
            }else if(el.type=="radio"){
              el.checked=false;
              if(obj[prop]==el.value)el.checked=true;
            }else{
              gFormatinputfordisplay(el,obj[prop]);
            }
          }else{
            if(el.type=="checkbox"){
              el.checked=false;
            }else{
              //el.value=null;
              el.value="";
            }
          }
        }
     }
   }
 }
}

function gFormatinputfordisplay(el,value){
    if(el.type=="number"){
        if(el.step){
            var arr=el.step.split('.');
            if(arr.length>1){
                var dp=arr[1].length;
                value=Number(value).toFixed(dp);
                if(navigator.userAgent.indexOf('Firefox')>-1 && GLOBALS_decimal_point==','){
                    value=value.replace('.',',');
                }
            }
        }
        //console.log('gFormatinputfordisplay '+el.name+": "+value);
    }
    el.value=value;
}

//default data formatters, tabulator.modules.format.js
var k8formatter = {
    "format":function(obj,value){
        var formatterParams=obj.formatterParams;
        switch(obj.formatter){
            case "money":
                value=parseFloat(value);
                
		var decimalSym = formatterParams.decimal || ".";
		var thousandSym = formatterParams.thousand || ",";
		var symbol = formatterParams.symbol || "";
		var after = !!formatterParams.symbolAfter;
		var precision = typeof formatterParams.precision !== "undefined" ? formatterParams.precision : 2;
                
		if (isNaN(value)) {
                    return this.emptyToSpace(this.sanitizeHTML(value));
		}

		var number = precision !== false ? value.toFixed(precision) : value;
		number = String(number).split(".");

		var integer = number[0];
		var decimal = number.length > 1 ? decimalSym + number[1] : "";

		var rgx = /(\d+)(\d{3})/;

		while (rgx.test(integer)) {
			integer = integer.replace(rgx, "$1" + thousandSym + "$2");
		}

		return after ? integer + decimal + symbol : symbol + integer + decimal;
                
                break;
            case "datetime":
		var inputFormat = formatterParams.inputFormat || "YYYY-MM-DD hh:mm:ss";
		var outputFormat = formatterParams.outputFormat || "DD/MM/YYYY hh:mm:ss";
		var invalid = typeof formatterParams.invalidPlaceholder !== "undefined" ? formatterParams.invalidPlaceholder : "";

		var newDatetime = moment(value, inputFormat);

		if (newDatetime.isValid()) {
			return formatterParams.timezone ? newDatetime.tz(formatterParams.timezone).format(outputFormat) : newDatetime.format(outputFormat);
		} else {

			if (invalid === true) {
				return value;
			} else if (typeof invalid === "function") {
				return invalid(value);
			} else {
				return invalid;
			}
		}
            default:
                return value;
        }
    },
    "sanitizeHTML":function (value) {
		if (value) {
			var entityMap = {
				'&': '&amp;',
				'<': '&lt;',
				'>': '&gt;',
				'"': '&quot;',
				"'": '&#39;',
				'/': '&#x2F;',
				'`': '&#x60;',
				'=': '&#x3D;'
			};

			return String(value).replace(/[&<>"'`=\/]/g, function (s) {
				return entityMap[s];
			});
		} else {
			return value;
		}
	},
	"emptyToSpace": function (value) {
		return value === null || typeof value === "undefined" || value === "" ? "&nbsp;" : value;
	}
};

var k8={
    "property1":0,
    "mes":function(text){
          alert(text);
    },
    "displayImage":function(options){
        var el_main;
        var my=$.extend(true,
            {
                el_base:document,
                selector:'.pic_ph',
                basetype:'',
                baseID:0,
                data:[],
                mode:0,         /* 0=single, 1=multiple image */
                loaddata:0,
                "parent_rightuser_update":0,
                "script_depth":0,
                "showtext":false,
                html:{
                    upload_blank:'<div style="height: 140px; border: 1px solid #bbb"><p class="text-center" style="padding: 10px; position: relative; top: 40px">upload image not yet possible</p></div>',
                    upload_dropzone:'<form action="" class="dropzone"> <input type="hidden" name="basetype" value=""> <input type="hidden" name="baseID" value=""> <input type="hidden" name="type" value="image"></form>',
                    upload_1_container:'<div class="js_rec_container" data-rec_object="k8references" data-rec_indexmax="-1"> <div class="js_rec_record" data-keyvalue="{{image_ID}}" style="position: relative"> <!--<div class="k8-checkbox"><input type="checkbox" class="js_img_delete"></div>--> <button type="button" class="btn btn-default js_img_delete k8-iamge-btn-delete">#ls#Delete#</button> <div class="k8-box-square k8-margin-bottom-normal"> <div class="k8-box-content"> <img class="k8-image-{{image_orientation}}" src="{{image_file}}"> </div> </div> </div></div>',
                    upload_m_blank:"<div class='k8-images'> <div class='js_rec_container rec_container k8-padding-6' data-rec_object='k8references' data-rec_indexmax='-1'> <div style='display: flex;'> <div><h3>"+getl('Images')+"</h3></div> <div style='flex: 1 1 30%;text-align: right; padding-top: 10px;'></div> </div> <div id='picutes' class='k8-margin-bottom-normal' style='min-height: 150px; border: 2px solid rgba(0, 0, 0, 0.3);'> <p style='text-align: center; margin: 2em 0'>upload image not yet possible</p> </div> <div class='row js_rec_records'></div> </div></div>",
                    /*upload_m_container:"<div class='k8-images'> <div class='js_rec_container rec_container k8-padding-6' data-rec_object='k8references' data-rec_indexmax='-1'> <div style='display: flex;'> <div><h3>"+getl('Images')+"</h3> </div> <div style='flex: 1 1 30%;text-align: right; padding-top: 10px;'> <button type='button' class='btn btn-primary js_DeleteSelected'>#ls#Delete#</button> </div> </div> <div class='dropzone-wrapper'> </div> <div class='row js_rec_records'> </div> </div></div>",
                    upload_m_record:"<div id='image_{{image_ID}}' class='js_rec_record col-sm-4' data-rec_index='' style='position: relative'> <div class='k8-checkbox'> <input type='checkbox' class='js_selected'> </div> <div class='k8-box-square k8-margin-bottom-normal'> <div class='k8-box-content'> <img class='k8-image-{{image_orientation}}' src='{{image_file}}'> </div> </div></div>"*/
                    upload_m_container:"<div class='k8-images'> <div class='js_rec_container rec_container k8-padding-6' data-rec_object='k8references' data-rec_indexmax='-1'> <div style='display: flex;'> <div><h3>"+getl('Images')+"</h3> </div> <div style='flex: 1 1 30%;text-align: right; padding-top: 10px;'> <button type='button' class='btn btn-primary js_DeleteSelected'>#ls#Delete#</button> </div> </div> <div class='dropzone-wrapper'> </div> <div class='row js_rec_records'> </div> </div></div>",
                    upload_m_record:"<div id='image_{{image_ID}}' class='js_rec_record' data-keyvalue='{{image_ID}}' data-rec_index='' style='margin-left: 1.5%; margin-right: 1.5%; width: 30.33%; float: left; position: relative'> <div class='k8-checkbox'> <input type='checkbox' class='js_selected'> </div> <div class='k8-box-square k8-margin-bottom-normal'> <div class='k8-box-content'> <img class='k8-image-{{image_orientation}}' src='{{image_file}}'><div class='k8-top-centered js_text' style='display: none;'>{{image_filename}}</div></div> </div></div>"
                },
                url_readfilter:"masterdata/ProcessData.php",
                url_save: "masterdata\/ProcessData.php?datadefID=8&process_action=Save",
                url_del:'masterdata/ProcessData.php?datadefID=8&process_action=Del',
                data_readfilter:{datadefID:8,process_action:"ReadFilter"},
                dropzone:{
                    init: function() {
                        var $this = this;
                        $(el_main).find("button#clear-dropzone").click(function() {
                            $this.removeAllFiles(true);
                        }),
                        this.on("complete", function (file) {
                            if (this.getUploadingFiles().length === 0 && this.getQueuedFiles().length === 0) {
                              console.log('finished upload');
                              if(my.dataAfterUpload){
                                  my.dataAfterUpload();
                              }
                              reloadData();
                            }
                        });
                    },
                    error: function(e,error) {
                        alert("Error"+error);
                    },
                    paramName: "file",
                    maxFilesize: 5,
                    maxFiles : 5,
                    autoProcessQueue : true
                }
            }, options);
        el_main=my.el_base.querySelector(my.selector);
        if(!el_main){console.log(
            my.selector+' not valid!');
            return 0;
        }
        if(my.basetype==''){console.log('basetype not valid');}

        //catalog
        var el_rec_container;
        var el_records;
        var path='../'.repeat(my.script_depth);
        
        init();
        
        function init(){
            if(my.mode==0){ 
                // single image
                my.dropzone.maxFiles=1;
                if(my.baseID==0){
                    el_main.innerHTML=ReplacePlaceholder(my.html.upload_blank);
                }else if(my.data.length==0){
                    if(my.loaddata){
                        my.data_readfilter.filters=[{"field":"basetype","type":"=","value":my.basetype},
                                {"field":"baseID","type":"=","value":my.baseID},
                                {"field":"type","type":"=","value":"image"}
                            ];
                        var url=path+my.url_readfilter;    
                        $.getJSON(url,my.data_readfilter, function(oJson) {
                            showImageSingle(oJson);
                        })
                        .fail(function(jqxhr, textStatus, error ) {
                            var err = url+", Request Failed, "+ textStatus + ", " + error;
                            console.log(err);
                        });			
                    }else{
                        insertDropzone(el_main);
                    }
                }else{
                    showImageSingle(my.data);
                }
            }else{
                if(my.baseID==0){
                    el_main.innerHTML=my.html.upload_m_blank;
                }else{
                    el_main.innerHTML=ReplacePlaceholder(my.html.upload_m_container);
                    el_rec_container=$(el_main).find('.js_rec_container')[0];
                    el_records=$(el_main).find('.js_rec_records')[0];

                    //console.log(my.data.length);
                    if(my.data.length>0){
                        showImageCatalog(my.data);
                    }else if(my.loaddata){
                        //ajax
                        my.data_readfilter.filters=[{"field":"basetype","type":"=","value":my.basetype},
                                {"field":"baseID","type":"=","value":my.baseID},
                                {"field":"type","type":"=","value":"image"}
                            ];
                        var url=path+my.url_readfilter;    
                        $.getJSON(url,my.data_readfilter, function(oJson) {
                            showImageCatalog(oJson);
                        })
                        .fail(function(jqxhr, textStatus, error ) {
                            var err = url+", Request Failed, "+ textStatus + ", " + error;
                            console.log(err);
                        });			
                    }else{
                        showImageCatalog(my.data);
                    }
                } 
                return el_main;
            }
        }
        
        function reloadData(){
            my.data_readfilter.filters=[{"field":"basetype","type":"=","value":my.basetype},
                    {"field":"baseID","type":"=","value":my.baseID},
                    {"field":"type","type":"=","value":"image"}
                ];
            var url=path+my.url_readfilter;    
            $.getJSON(url,my.data_readfilter, function(oJson) {
                my.data=oJson;
                //console.log(my.data);
                init();
            })
            .fail(function(jqxhr, textStatus, error ) {
                var err = url+", Request Failed, "+ textStatus + ", " + error;
                console.log(err);
            });			
        }
        function showImageSingle(data){
            if(data.length==0){
                if(my.parent_rightuser_update){
                    insertDropzone(el_main);
                }else{
                    el_main.innerHTML=ReplacePlaceholder(my.html.upload_1_container);
                }
            }else{
                el_main.innerHTML=ReplacePlaceholder(my.html.upload_1_container,data[0],2,path);
                if(my.parent_rightuser_update){
                    // ----------- delete
                    $(el_main).on("click",".js_img_delete",function(){
                        if(!$(this).hasClass('js_disabled')){
                            if(confirm(getl('delete')+'?')){
                                var el_rec_record=$(this).parents('.js_rec_record')[0];
                                var index=el_rec_record.dataset.rec_index;
                                var keyvalue=el_rec_record.dataset.keyvalue;
                                var o={}
                                o['ID']=keyvalue;
                                $.getJSON(path+my.url_del,o, function(oJson) {
                                    if(oJson.bok){
                                        insertDropzone(el_main);
                                        if(my.dataAfterDelete){
                                            my.dataAfterDelete();
                                        }
                                    }else{
                                        console.log('error by delete: '+oJson.error);
                                    }
                                })
                                .fail(function(jqxhr, textStatus, error ) {
                                    var err = url+", Request Failed, "+ textStatus + ", " + error;
                                    console.log(err);
                                });			

                            }
                        }
                    });
                }else{
                    $(el_main).find('.js_img_delete').hide();
                }
            }
        }
        function insertDropzone(el){
            if(my.parent_rightuser_update){
                el.innerHTML=my.html.upload_dropzone;
                el_dropzone_form=el.querySelector(".dropzone");
                el_dropzone_form.setAttribute("action", path+my.url_save);
                el_dropzone_form.elements.namedItem('basetype').value=my.basetype;
                el_dropzone_form.elements.namedItem('baseID').value=my.baseID;
                $(el_dropzone_form).dropzone(my.dropzone);
            }else{
                el.innerHTML=my.html.upload_blank;
            }
        }

        function showImageCatalog(data){
            el=$(el_main).find('.dropzone-wrapper')[0];
            if(el){
                if(data.length>0){
                    if(my.parent_rightuser_update){
                        insertDropzone(el);
                    }
                }else{
                    insertDropzone(el);
                }
            }
            
            // ----------------- delete button
            var el_btndelete=$(el_rec_container).find('.js_DeleteSelected');
            if(my.parent_rightuser_update && data.length>0){
                $(el_btndelete).on('click',function(){
                  var el_checked=$(el_rec_container).find('input:checked');
                  if(el_checked.length>0){
                    if(confirm(getl('delete')+'?')){
                        for(var n=0;n<el_checked.length;n++){
                          var el_record=$(el_checked[n]).parents('.js_rec_record')[0];
                          var o={};
                          o['ID']=el_record.dataset.keyvalue;
                          $.getJSON(path+my.url_del,o, function(oJson) {
                              if(oJson.bok){
                                var el_record=$(el_rec_container).find('.js_rec_record[data-keyvalue="'+oJson.bok+'"]')[0];
                                el_record.remove();
                                if(my.dataAfterDelete){
                                    my.dataAfterDelete();
                                }
                              }else{
                                  console.log('error by delete: '+oJson.error);
                              }
                          });
                        }
                    }
                }else{
                    alert(getl('please select images!'));
                }
                });
            }else{
                //$(el_btndelete).prop("disabled", true);
                $(el_btndelete).hide();
            }
            
            for(var i=0;i<data.length;i++){
                var line=ReplacePlaceholder(my.html.upload_m_record,data[i],2,path);

                $(el_records).append(line);
                var el_rec_record=$(el_records).children().last()[0];
                el_rec_record.dataset['rec_index']=i;
                if(my.showtext)$(el_rec_record).find(".js_text").show();

                /*
                if(settings.rightcheck){
                    if(!data[i]['rightuser_delete'])$(el_rec_record).find('.js_rec_delete').hide();
                    if(!data[i]['my.rightuser_update'])$(el_rec_record).find('.js_rec_edit').hide();
                }
                */
            }
            el_rec_container.dataset.rec_indexmax=i;

            // disable checkbox
            if(!my.parent_rightuser_update){
                $(el_rec_container).find(':checkbox').hide();
            }else{
                $(el_records).find('.js_rec_record').css('cursor','all-scroll');
                $(el_records).sortable({
                    update: function(event, ui) {
                        var arr = $(this).sortable('toArray');
                        var url=path+"masterdata/ProcessData.php?datadefID=8&process_action=sort";
                        $.getJSON(url,{"arr":arr,prefix:"image_"}, function(oJson) {
                            if(oJson.bok){
                                if(my.dataSortUpdate){
                                    my.dataSortUpdate();
                                }
                            }else{
                                console.log(oJson.error);
                            }
                          })
                          .fail(function(jqxhr, textStatus, error ) {
                              var err = url+", Request Failed, "+ textStatus + ", " + error;
                              console.log(err);
                        });			
                    }
                });
            }
        }
    },
    
/* k8form    */
    "formcollection":{},
    "formoptions":{},
    "initFormfields":function(options,first){
      first=typeof first!=='undefined' ? first : true;        
      if(first)this.formoptions=options;
      var fields=options.fields;
      var containers=getfromArray(options,'containers',[]);
      if(fields){
        for(var i=0;i<fields.length;i++){
          //inputgroup
          if(true){
            var itemname=getfromArray(fields[i],"identifier",getfromArray(fields[i],"name"));
            if(!gbnull(itemname))this.formcollection[itemname]=fields[i];
          }
        }
      }
      if(containers){
        for(var i=0;i<containers.length;i++){
          var itemname=getfromArray(containers[i],"identifier",getfromArray(containers[i],"name"));
          if(!gbnull(itemname))this.formcollection[itemname]=containers[i];
          this.initFormfields(containers[i],false);
        }
      }
    },
    
    "getFormfield":function(options,fieldname){
      var formfield={};
      var fields=options.fields;
      var containers=getfromArray(options,'containers',[]);
      if(fields){
        for(var i=0;i<fields.length;i++){
          //inputgroup
          if(getfromArray(fields[i],'name')==fieldname){
            formfield=fields[i];
            return formfield;
            break;
          }
        }
      }
      if(containers){
        for(var i=0;i<containers.length;i++){
          formfield=this.getFormfield(containers[i],fieldname);
          if(Object.keys(formfield).length>0){
            break;
          }
        }
      }
      return formfield;
    },
  
  "createform":function(options){
    options=typeof options!=='undefined' ? options : this.formoptions;        

    /* example object 2021-06-22
    var fields=options.fields=[
        {"fieldname":"year","label":"year","figure":1,"operator":"=","tagName":"input"},
        {"fieldname":"month","label":"month","figure":1,"operator":"=","tagName":"input"},
        {"fieldname":"employeeID","label":"emplyoee","figure":1,"operator":"=","tagName":"input"}
    ]
    */
   
    /* form attributes */
    // name, id, method, action, class, form_attributes
    var form_attributes="";
    if(!options.form)options.form={};
    form_attributes=gsclauseand(form_attributes,'name="'+getfromArray(options.form,"name")+'"',isset(options.form,'name')," ");
    form_attributes=gsclauseand(form_attributes,'id="'+getfromArray(options.form,"id")+'"',isset(options.form,'id')," ");
    form_attributes=gsclauseand(form_attributes,'method="'+getfromArray(options.form,"method")+'"',isset(options.form,'method')," ");
    form_attributes=gsclauseand(form_attributes,'action="'+getfromArray(options.form,"action")+'"',isset(options.form,'action')," ");
    form_attributes=gsclauseand(form_attributes,'class="'+getfromArray(options.form,"class")+'"',isset(options.form,'class')," ");
    form_attributes=gsclauseand(form_attributes,getfromArray(options.form,"form_attributes"),isset(options.form,'form_attributes')," ");
    if(!gbnull(form_attributes))form_attributes=" "+form_attributes;
    options.form_attributes=form_attributes;
    
    var GET={};
    var method=getfromArray(options,'method','POST');
    if(method=="GET")GET=Array_GET();
    var id_preset=getfromArray(options,'id_preset');
    //  name="{{formname}}" method="{{method}}" action="{{action}}" class="form-horizontal masterdata-form"
    
    var fieldwraptemplatedefault='<div class="form-group">{{labelelement}}<div class="{{fieldwrapclass}}">{{fieldelement}}</div></div>';
    var fieldwrapclassdefault='controls col-sm-10';
    var labelclassdefault="control-label label-left col-sm-2";
    var labeltemplate='<label class="{{labelclass}}" for="{{id}}">{{label}}</label>';
    var fieldclassdefault='form-control';
    
    // checkbox
    var fieldwraptemplatedefault_checkbox='<div class="row mb-3"><div class="{{fieldwrapclass}}"><div class="form-check">{{fieldelement}}{{labelelement}}</div></div></div>';
    var fieldwrapclassdefault_checkbox='col-sm-10 offset-sm-2';

    // radio
    var fieldwraptemplatedefault_radio='';
    var labeltemplate_radio='';
    var texttemplate='';
    var fieldradiotemplate='';
    var labelclassdefault_radio='';
    var fieldwrapclassdefault_radio='';
    var fieldclassdefault_radio='';
    var textclassdefault_radio='';
    
    var enabledArray=getfromArray(options,'enabledArray',[]);
    switch(options.templatetype){
        case 'filterform':
            //template='<form name="{{formname}}" class="js_filterform form-horizontal masterdata-form"> <div class="row"> <div class="col-md-6"> {{innerHTML}} <div class="form-group text-right"> <div class="col-sm-offset-2 col-sm-10"> <button type="button" class="js_replacedata btn btn-default">Go</button> </div> </div> </div> <div class="col-md-6 k8-margin-bottom-normal"> <div class="row"> <div class="col-xs-4 text-center"> <button type="button" class="js-download-csv">Download CSV</button> </div> <div class="col-xs-4 text-center"> <button type="button" class="js-download-xlsx">Download Excel</button> </div> <div class="col-xs-4 text-center"> <button type="button" class="js-download-pdf">Download PDF</button> </div> </div> </div> </div></form>';                
            options.template='<form name="{{formname}}" class="js_filterform form-horizontal masterdata-form"> <div class="row"> <div class="col-md-6"> {{innerHTML}} <div class="form-group text-right"> <div class="col-sm-offset-2 col-sm-10"> <input type="submit" class="js_replacedata btn btn-default" value="Go"> </div> </div> </div> <div class="col-md-6 k8-margin-bottom-normal"> <div class="row"> <div class="col-xs-4 text-center"> <button type="button" class="js-download-csv">Download CSV</button> </div> <div class="col-xs-4 text-center"> <button type="button" class="js-download-xlsx">Download Excel</button> </div> <div class="col-xs-4 text-center"> <button type="button" class="js-download-pdf">Download PDF</button> </div> </div> </div> </div></form>';                
            break;
        case 'masterform':    /* bootstrap 3 horizontal */
            //template=getfromArray(options,'template','{{innerHTML}} <div class="text-right"> <input type="submit" name="submit" class="btn btn-primary" value="Save" /> <button type="button" class="btn btn-default js_cancel">Cancel</button> </div>');
            options.template=getfromArray(options,'template','{{innerHTML}}<div class="row"> <div class="col-xs-1 js_dirty"></div> <div class="col-xs-5 js_middle"></div> <div class="col-xs-6"> <div class="text-right"><input type="submit" name="submit" class="btn btn-primary " value="Save"> <button type="button" class="btn btn-default js_cancel">Cancel</button> </div> </div> </div>');

            fieldwraptemplatedefault=getfromArray(options,'fieldwraptemplate','<div class="form-group">{{labelelement}}<div class="{{fieldwrapclass}}">{{fieldelement}}</div></div>');
            fieldwrapclassdefault=getfromArray(options,'fieldwrapclass','controls col-sm-10');
            labelclassdefault=getfromArray(options,'labelclass',"control-label label-left col-sm-2");
            labeltemplate=getfromArray(options,'labeltemplate','<label class="{{labelclass}}" for="{{id}}">{{label}}</label>');
            fieldclassdefault=getfromArray(options,'fieldclass','form-control');

            fieldwraptemplatedefault_checkbox=getfromArray(options,'fieldwraptemplate_checkbox','<div class="form-group"><div class="{{fieldwrapclass}}"><div class="checkbox"><label>{{fieldelement}} {{label}}</label></div></div></div>');
            fieldwrapclassdefault_checkbox=getfromArray(options,'fieldwrapclass_checkbox','col-sm-10 col-sm-offset-2');

            // radio
            fieldwraptemplatedefault_radio=getfromArray(options,'fieldwraptemplate_radio','<div class="form-group">{{labelelement}}<div class="{{fieldwrapclass}}">{{fieldradiotemplates}}</div></div>');
            labeltemplate_radio=getfromArray(options,'labeltemplate_radio','<label class="{{labelclass}}" for="{{id}}">{{label}}</label>');
            texttemplate='';
            fieldradiotemplate=getfromArray(options,'fieldradiotemplate_radio','<div class="radio"><label>{{fieldelement}}{{text}}</label></div>');   
            
            labelclassdefault_radio=getfromArray(options,'labelclass_radio', "control-label label-left col-sm-2");  // "form-label pt-0";
            fieldwrapclassdefault_radio=getfromArray(options,'fieldwrapclass_radio', 'col-sm-10');
            fieldclassdefault_radio=getfromArray(options,'fieldclass_radio', "radio");
            textclassdefault_radio=getfromArray(options,'textclass_radio', "form-check-label");
       
            break;
        case 'bootstrap5standard':
            options.template=getfromArray(options,'template','<form{{form_attributes}}> {{innerHTML}} <div class="text-end"> <input type="submit" name="submit" class="btn btn-primary me-4" value="Save" /> <button type="button" class="btn btn-light js_cancel">Cancel</button> </div></form>');
            fieldwraptemplatedefault='<div class="{{fieldwrapclass}}">{{labelelement}}{{fieldelement}}</div>';
            fieldwrapclassdefault='mb-3';
            labelclassdefault="form-label";
            labeltemplate='<label class="{{labelclass}}" for="{{id}}">{{label}}</label>';
            fieldclassdefault='form-control';
            
            fieldwraptemplatedefault_checkbox=getfromArray(options,'fieldwraptemplate_checkbox','<div class="form-check">{{fieldelement}}{{labelelement}}</div>');
            fieldwrapclassdefault_checkbox=getfromArray(options,'fieldwrapclass_checkbox');

            fieldwraptemplatedefault_radio='<div class="mb-3">{{labelelement}}{{fieldradiotemplates}}</div>';
            labeltemplate_radio='<label class="{{labelclass}}" for="{{id}}">{{label}}</label>';
            texttemplate='<label class="{{textclass}}" for="{{id}}">{{text}}</label>';
            fieldradiotemplate='<div class="form-check">{{fieldelement}}{{textelement}}</div>';
            
            fieldwrapclassdefault_radio='';
            labelclassdefault_radio=labelclassdefault;  // "form-label pt-0";
            fieldclassdefault_radio="form-check-input";
            textclassdefault_radio="form-check-label";

            break;
        case 'bootstrap5horizontal':
            options.template=getfromArray(options,'template','<form{{form_attributes}}>{{innerHTML}}<div class="text-end"> <input type="submit" name="submit" class="btn btn-primary me-4" value="Save" /> <button type="button" class="btn btn-light js_cancel">Cancel</button> </div></form>');
            fieldwraptemplatedefault='<div class="row mb-3">{{labelelement}}<div class="{{fieldwrapclass}}">{{fieldelement}}</div></div>';            
            fieldwrapclassdefault='controls col-sm-10';
            labelclassdefault="col-sm-2 col-form-label";
            labeltemplate='<label class="{{labelclass}}" for="{{id}}">{{label}}</label>';
            fieldclassdefault='form-control';

            fieldwraptemplatedefault_checkbox=getfromArray(options,'fieldwraptemplate_checkbox','<div class="row mb-3"><div class="{{fieldwrapclass}}"><div class="form-check">{{fieldelement}}{{labelelement}}</div></div></div>');
            fieldwrapclassdefault_checkbox=getfromArray(options,'fieldwrapclass_checkbox','col-sm-10 offset-sm-2');

            fieldwraptemplatedefault_radio='<fieldset class="row mb-3">{{labelelement}}<div class="{{fieldwrapclass}}">{{fieldradiotemplates}}</div></fieldset>';
            fieldradiotemplate='<div class="form-check">{{fieldelement}}{{textelement}}</div>';
            labeltemplate_radio='<legend class="col-form-label col-sm-2 pt-0">Radios</legend>';
            texttemplate='<label class="{{textclass}}" for="{{id}}">{{text}}</label>';
            
            labelclassdefault_radio="form-label col-sm-2 pt-0";
            fieldwrapclassdefault_radio='col-sm-10';
            fieldclassdefault_radio="form-check-input";
            textclassdefault_radio="form-check-label";

            break;
        default:
            options.template=getfromArray(options,'template','<form> {{innerHTML}} <div class="text-right"> <input type="submit" name="submit" class="btn btn-primary" value="Save" /> <button type="button" class="btn btn-default js_cancel">Cancel</button> </div></form>');
    }
    fieldwrapclassdefault=getfromArray(options,'fieldwrapclass',fieldwrapclassdefault);
    fieldwraptemplatedefault=getfromArray(options,'fieldwraptemplate',fieldwraptemplatedefault);
    labeltemplate=getfromArray(options,'labeltemplate',labeltemplate);
    var html=ReplacePlaceholder(options.template,Object.assign(options,{"innerHTML":executeArrays(options)}),2);

    //html=ReplacePlaceholder(options.template,{"innerHTML":html,"formname":"filterform"},2);  // options, method ,.....
    if(options.selector){
      var el;
      switch (options.selector.substr(0,1)){
        case '#':
          el=document.getElementById(options.selector.substr(1));
          break;
        case '.':
          el=document.getElementsByClassName(options.selector.substr(1))[0];
          break;
        default:
          el=document.getElementsByTagName(options.selector.substr(1))[0];
          break;
      }
      if(el){
        if(options.form){
          for(attribute in options.form){
            if(options.form.hasOwnProperty(attribute)){
              if(attribute=="class"){
                el.classList.add(options.form[attribute]);
              }else{
                el.setAttribute(attribute,options.form[attribute]);
              }
            }
          }
        }
      }else{
        console.log("selector: "+options.selector+" not found!");
      }
      el.innerHTML=html;
      //$(options.selector).html(html);
    }
    return html;
    
    function executeArrays(options){
      var html="";
      var fieldwraptemplatelevel=getfromArray(options,'fieldwraptemplate',fieldwraptemplatedefault);
      var labelclasslevel=getfromArray(options,'labelclass',labelclassdefault);
      var fieldwrapclasslevel=getfromArray(options,'fieldwrapclass',fieldwrapclassdefault);
      var fields=options.fields;
      var containers=getfromArray(options,'containers',[]);
      if(fields){
        for(var i=0;i<fields.length;i++){
          var identifier=getfromArray(fields[i],'identifier',getfromArray(fields[i],"name"));
          var active=getfromArray(fields[i],"active",true);
          var bok=active;
          if(enabledArray.length>0 && gbnull(identifier)){
            bok=false;
          }else if(enabledArray.length>0 && !gbnull(identifier)){
            bok=(enabledArray.indexOf(identifier)>=0);
          }
          if(bok){
            if(getfromArray(fields[i],'type')=="hidden"){
                html+=createfield(fields[i]);
            }else{
              var fieldelement;
              var fieldwraptemplate=getfromArray(fields[i],"fieldwraptemplate",fieldwraptemplatelevel);
              var labelclass=getfromArray(fields[i],"fieldwraptemplate",labelclasslevel);
              var fieldwrapclass=getfromArray(fields[i],"fieldwraptemplate",fieldwrapclasslevel);
              
              fieldwraptemplate=ReplacePlaceholder(fieldwraptemplate,options.html,2);
              
              if(isset(fields[i],'inputgroup')){
                var inputgroup=fields[i]['inputgroup'];
                var fieldelements={};
                var field;
                for(var j=0;j<inputgroup.fields.length;j++){
                  field=setField(inputgroup.fields[j]);
                  fieldelements['field'+j]=createfield(field);
                }
                var objlabel=Object.assign(inputgroup,{"labelclass":labelclass});
                objlabel['label']=getfromArray(inputgroup,'label',field.label);
                //id
                var labelelement=ReplacePlaceholder(labeltemplate,objlabel,2);
                var template_inputgroup=getfromArray(inputgroup,'template','{{field0}}');
                fieldelement=ReplacePlaceholder(template_inputgroup,fieldelements,2);

                fieldwrapclass=getfromArray(inputgroup,"fieldwrapclass",fieldwrapclass);
                html+=ReplacePlaceholder(fieldwraptemplate,{"fieldwrapclass":fieldwrapclass,"fieldelement":fieldelement,"labelelement":labelelement},2);
              }else if(getfromArray(fields[i],'figure',0)==2){
                // from to
                var field=setField(fields[i]);
                var labelelement=ReplacePlaceholder(labeltemplate,Object.assign(field,{"labelclass":labelclass}),2);
                fieldelement=createfield(field,"from");
                fieldelement+=createfield(setField(fields[i]),"to");
                var fieldwrapclass=gsclauseand(fieldwrapclassdefault,'k8-flex-row',true," ");
                html+=ReplacePlaceholder(fieldwraptemplate,{"fieldwrapclass":fieldwrapclass,"fieldelement":fieldelement,"labelelement":labelelement},2);
              }else{
                var field;
                if(fields[i]["type"]=="radio"){
                  field=setField(fields[i],fieldclassdefault_radio);
                  field.labelclass=getfromArray(field,"labelclass",labelclassdefault_radio);
                  field.textclass=getfromArray(field,"textclass",textclassdefault_radio);
                  var labelelement=ReplacePlaceholder(labeltemplate_radio, field, 2);
                  fieldelement=createfield(field);
                  html+=ReplacePlaceholder(fieldwraptemplatedefault_radio,{"fieldwrapclass":fieldwrapclassdefault_radio,"fieldradiotemplates":fieldelement,"labelelement":labelelement},2);
                }else{
                  field=setField(fields[i],fieldclassdefault);
                  if(field.type=="checkbox"){
                    field.fieldclass="form-check-input";
                    fieldwraptemplate=fieldwraptemplatedefault_checkbox;
                    fieldwrapclass=fieldwrapclassdefault_checkbox;
                    labelclass=getfromArray(field,"labelclass","form-check-label");
                  }                
                  var labelelement=ReplacePlaceholder(labeltemplate,Object.assign(field,{"labelclass":labelclass}),2);
                  fieldelement=createfield(field);
                  fieldwrapclass=getfromArray(field,"fieldwrapclass",fieldwrapclass);
                  html+=ReplacePlaceholder(fieldwraptemplate,Object.assign(field,{"fieldwrapclass":fieldwrapclass,"fieldelement":fieldelement,"labelelement":labelelement}),2);
                }
              }
            }
          }
        }
      }
      for(var i=0;i<containers.length;i++){
        var identifier=getfromArray(containers[i],'identifier',getfromArray(containers[i],"name"));
        var active=getfromArray(containers[i],"active",true);
        var bok=active;
        if(enabledArray.length>0 && gbnull(identifier)){
          bok=false;
        }else if(enabledArray.length>0 && !gbnull(identifier)){
          bok=(enabledArray.indexOf(identifier)>=0);
        }
        if(bok){
          if(gbnull(getfromArray(containers[i],'template'))){
              containers[i]['template']='{{innerHTML}}';
          }
          if(!gbnull(id_preset) && !containers[i]['id_preset'])containers[i]['id_preset']=id_preset;
          containers[i]['method']=method;
          html+=ReplacePlaceholder(containers[i]['template'],Object.assign(containers[i],{"innerHTML":executeArrays(containers[i])}),2);
        }
      }
      return html;
    }

    function setField(field,fieldclass){
      fieldclass=typeof fieldclass!=='undefined' ? fieldclass : fieldclassdefault;        
      var blanguage=true;
      
      if(!isset(field,'name'))field['name']=field['fieldname'];
      if(!isset(field,'fieldclass'))field['fieldclass']=fieldclass;
      if(!isset(field,'type'))field['type']='text';
      if(!isset(field,'id'))field['id']=id_preset+field['name'];
      if(!isset(field,'tags'))field['tags']='';
      //if(!isset(field,'value'))field.value="";
      if(blanguage){
        if(isset(field,'label')){
          field.label=getl(field.label);
        }else{
          field.label=getl(field.name);
        }
      }else{
        if(!isset(field,'label'))field.label=field.name;
      }
      
      if(!isset(field,'figure'))field.figure=1;
      if(isset(GET,field.name))field.value=GET[field.name];
      return field;
    }

    function createfield(field,name_ext){
        var obj=JSON.parse(JSON.stringify(field));
        var fieldtemplate;
        var html='';
        if(!obj.tagName && !obj.fieldtemplate){
            obj.tagName="input";
        }
        if(typeof(name_ext)!=='undefined'){
            obj.name=obj.name+name_ext;
            obj.id=obj.id+name_ext;
        }
        if(obj.type=="hidden"){
          html='<input type="hidden" name="'+obj.name+'">';
        }else{
          switch(obj.tagName){
              case "input":
                  var input_attributes="";
                  fieldtemplate='<input{{input_attributes}}>';
                  if(obj.type=="radio"){
                    var html_radio="";
                    for(var k=0;k<obj.options.length;k++){
                      //create field
                      var option=obj.options[k];
                      var obj_radio={};
                      obj_radio['name']=obj.name;
                      obj_radio['type']=obj.type;
                      obj_radio['fieldclass']=obj.fieldclass;
                      obj_radio['textclass']=obj.textclass; // bootstrap 5 "form-check-label"
                      obj_radio['id']=obj.id+k;
                      obj_radio['value']=option.value;
                      obj_radio['text']=option.text;
                      obj_radio['checked']=getfromArray(option,"checked",false);
                      
                      input_attributes="";
                      /*
                      input_attributes=gsclauseand(input_attributes,'class="'+getfromArray(obj_radio,"fieldclass")+'"',isset(obj_radio,'fieldclass')," ");
                      input_attributes=gsclauseand(input_attributes,'type="'+obj_radio.type+'"',isset(obj_radio,'type')," ");
                      input_attributes=gsclauseand(input_attributes,'name="'+getfromArray(obj_radio,"name")+'"',isset(obj_radio,'name')," ");
                      input_attributes=gsclauseand(input_attributes,'id="'+getfromArray(obj_radio,"id")+'"',isset(obj_radio,'id')," ");
                      input_attributes=gsclauseand(input_attributes,'value="'+getfromArray(obj_radio,"value")+'"',isset(obj_radio,'value')," ");
                      input_attributes=gsclauseand(input_attributes,'checked',(obj_radio['checked'])," ");
                      */
                      var standard_attributes=createAttributes(obj_radio);
                      input_attributes=gsclauseand(input_attributes,standard_attributes,!gbnull(standard_attributes),' ');
                      if(!gbnull(input_attributes))input_attributes=' '+input_attributes;
                      obj_radio.input_attributes=input_attributes
                      obj_radio['fieldelement']=ReplacePlaceholder(fieldtemplate,obj_radio,2);
                      
                      obj_radio['textelement']=ReplacePlaceholder(texttemplate,obj_radio,2);
                      html_radio+=ReplacePlaceholder(fieldradiotemplate,obj_radio,2);
                    }
                    html=html_radio;
                  }else{
                    if(obj.type=="checkbox"){
                      //input_attributes=gsclauseand(input_attributes,'checked',isset(obj,'checked')," ");
                    }else{
                      //input_attributes=gsclauseand(input_attributes,'class="'+getfromArray(obj,"fieldclass")+'"',isset(obj,'fieldclass')," ");
                    }
                    /*
                    input_attributes=gsclauseand(input_attributes,'type="'+obj.type+'"',isset(obj,'type')," ");
                    input_attributes=gsclauseand(input_attributes,'step="'+getfromArray(obj,"step")+'"',isset(obj,'step')," ");
                    input_attributes=gsclauseand(input_attributes,'value="'+getfromArray(obj,"value")+'"',isset(obj,'value')," ");
                    input_attributes=gsclauseand(input_attributes,'maxlength="'+getfromArray(obj,"maxlength")+'"',isset(obj,'maxlength'),' ');
                    input_attributes=gsclauseand(input_attributes,'placeholder="'+getfromArray(obj,"placeholder")+'"',isset(obj,"placeholder"),' ');
                    */
                    var standard_attributes=createAttributes(obj);
                    input_attributes=gsclauseand(input_attributes,standard_attributes,!gbnull(standard_attributes),' ');
                    if(!gbnull(input_attributes))input_attributes=' '+input_attributes;
                    obj['input_attributes']=input_attributes;
                    html=ReplacePlaceholder(fieldtemplate,obj,2);
                  }
                  break;
              case "select":
                  if(obj.options){
                    if(Array.isArray(obj.options)){
                      obj.options=array2Options(obj.options);
                    }
                  }
                  //fieldtemplate='<select class="{{fieldclass}}" name="{{name}}" id="{{id}}" {{tags}}>{{options}}</select>';
                  var standard_attributes=createAttributes(obj);
                  input_attributes=gsclauseand(input_attributes,standard_attributes,!gbnull(standard_attributes),' ');
                  if(!gbnull(input_attributes))input_attributes=' '+input_attributes;
                  obj['input_attributes']=input_attributes;
                  fieldtemplate='<select{{input_attributes}}>{{options}}</select>';
                  html=ReplacePlaceholder(fieldtemplate,obj,2);
                  break;
              case "textarea":
                  /*
                  if(!gbnull(input_attributes))input_attributes=' '+input_attributes;
                  obj['input_attributes']=input_attributes;
                  if(!isset(field,'value'))obj.value="";
                  fieldtemplate='<textarea class="{{fieldclass}}" name="{{name}}" id="{{id}}" {{tags}}{{input_attributes}}>{{value}}</textarea>';
                  html=ReplacePlaceholder(fieldtemplate,obj,2);
                  */
                  var standard_attributes=createAttributes(obj);
                  input_attributes=gsclauseand(input_attributes,standard_attributes,!gbnull(standard_attributes),' ');
                  if(!gbnull(input_attributes))input_attributes=' '+input_attributes;
                  obj['input_attributes']=input_attributes;
                  if(!isset(obj,'value'))obj.value="";
                  fieldtemplate='<textarea{{input_attributes}}>{{value}}</textarea>';
                  html=ReplacePlaceholder(fieldtemplate,obj,2);
                  break;
              default:
                  if(obj.fieldtemplate){
                    input_attributes=createAttributes(obj);
                    if(!gbnull(input_attributes))input_attributes=' '+input_attributes;
                    obj['input_attributes']=input_attributes;
                    fieldtemplate=obj.fieldtemplate;
                    html=ReplacePlaceholder(fieldtemplate,obj,2);
                  }
          }
        }
        return html;
    }
    function createAttributes(obj,tagName,type){
      var input_attributes="";
      /*
      input_attributes=gsclauseand(input_attributes,'name="'+getfromArray(obj,"name")+'"',isset(obj,'name')," ");
      input_attributes=gsclauseand(input_attributes,'id="'+getfromArray(obj,"id")+'"',isset(obj,'id')," ");
      input_attributes=gsclauseand(input_attributes,'class="'+getfromArray(obj,"fieldclass")+'"',isset(obj,'fieldclass')," ");
      input_attributes=gsclauseand(input_attributes,'style="'+getfromArray(obj,"style")+'"',isset(obj,'style')," ");
      input_attributes=gsclauseand(input_attributes,getfromArray(obj,"input_attributes"),isset(obj,"input_attributes"),' ');
      input_attributes=gsclauseand(input_attributes,getfromArray(obj,"tags"),isset(obj,"tags"),' ');
      input_attributes=gsclauseand(input_attributes,'required',getfromArray(obj,"required",false),' ');
      input_attributes=gsclauseand(input_attributes,'readonly',getfromArray(obj,"readonly",false),' ');
      input_attributes=gsclauseand(input_attributes,'disabled',getfromArray(obj,"disabled",false),' ');
      input_attributes=gsclauseand(input_attributes,'aria-disabled=true',getfromArray(obj,"disabled",false),' ');
      */
      var decimals=getfromArray(obj,"decimals",0);
      if(obj.type=="number" && decimals!=0){
          if(!obj.step){
              obj.step="0."+"0".repeat(obj.decimals-1)+'1';
          }
          //input_attributes=gsclauseand(input_attributes,'step="'+obj.step+'"',!gbnull(obj.step),' ');
      }
     
      for(prop in obj){
        if(obj.hasOwnProperty(prop) && (",identifier,active,figure,label,tagName,decimals,labelclass,fieldtemplate,template,input_attributes,operator,options,").indexOf(","+prop+",")==-1){
          if(prop=='fieldclass'){
            input_attributes=gsclauseand(input_attributes,'class="'+getfromArray(obj,"fieldclass")+'"',isset(obj,'fieldclass')," ");
          }else if((",required,readonly,disabled,checked,").indexOf(","+prop+",")>-1){
            input_attributes=gsclauseand(input_attributes,prop,obj[prop],' ');
          }else if(prop=="value"){
            if(gbnull(getfromArray(obj,"step"))){
              input_attributes=gsclauseand(input_attributes,prop+'="'+obj[prop]+'"',true,' ');
            }else{
              var arr=obj.step.split('.');
              var value=obj[prop];
              if(arr.length>1){
                var dp=arr[1].length;
                value=Number(value).toFixed(dp);
              }
              input_attributes=gsclauseand(input_attributes,prop+'="'+value+'"',true,' ');
            }
          }else{
            input_attributes=gsclauseand(input_attributes,prop+'="'+obj[prop]+'"',true,' ');
          }
        }
      }
      return input_attributes;
    }
  },
  
    /*
    "createform":function(options){
        var GET={};
        var method=getfromArray(options,'method','POST');
        if(method=="GET")GET=Array_GET();
        var fields=options.fields;
        var id_preset=getfromArray(options,'id_preset');
        var containers=getfromArray(options,'containers',[]);
        var template=getfromArray(options,'template','<form name="{{formname}}" method="{{method}}" action="{{action}}" class="form-horizontal masterdata-form"> {{innerHTML}} <div class="text-right"> <input type="submit" name="submit" class="btn btn-primary" value="Save" /> <button type="button" class="btn btn-default js_cancel">Cancel</button> </div></form>');

        var fieldwrapclassdefault='controls col-sm-10';
        var labelclass="control-label label-left col-sm-2";
        var fieldwraptemplate='<div class="form-group">{{labelelement}}<div class="{{fieldwrapclass}}">{{fieldelement}}</div></div>';
        var labeltemplate='<label class="{{labelclass}}" for="{{id}}">{{label}}</label>';
        var fieldclassdefault='form-control';
        var html="";
      
        switch(options.templatetype){
            case 'filterform':
                //template='<form name="{{formname}}" class="js_filterform form-horizontal masterdata-form"> <div class="row"> <div class="col-md-6"> {{innerHTML}} <div class="form-group text-right"> <div class="col-sm-offset-2 col-sm-10"> <button type="button" class="js_replacedata btn btn-default">Go</button> </div> </div> </div> <div class="col-md-6 k8-margin-bottom-normal"> <div class="row"> <div class="col-xs-4 text-center"> <button type="button" class="js-download-csv">Download CSV</button> </div> <div class="col-xs-4 text-center"> <button type="button" class="js-download-xlsx">Download Excel</button> </div> <div class="col-xs-4 text-center"> <button type="button" class="js-download-pdf">Download PDF</button> </div> </div> </div> </div></form>';                
                template='<form name="{{formname}}" class="js_filterform form-horizontal masterdata-form"> <div class="row"> <div class="col-md-6"> {{innerHTML}} <div class="form-group text-right"> <div class="col-sm-offset-2 col-sm-10"> <input type="submit" class="js_replacedata btn btn-default" value="Go"> </div> </div> </div> <div class="col-md-6 k8-margin-bottom-normal"> <div class="row"> <div class="col-xs-4 text-center"> <button type="button" class="js-download-csv">Download CSV</button> </div> <div class="col-xs-4 text-center"> <button type="button" class="js-download-xlsx">Download Excel</button> </div> <div class="col-xs-4 text-center"> <button type="button" class="js-download-pdf">Download PDF</button> </div> </div> </div> </div></form>';                
                break;
            case 'masterform':
                //template=getfromArray(options,'template','{{innerHTML}} <div class="text-right"> <input type="submit" name="submit" class="btn btn-primary" value="Save" /> <button type="button" class="btn btn-default js_cancel">Cancel</button> </div>');
                template=getfromArray(options,'template','{{innerHTML}}<div class="row"> <div class="col-xs-1 js_dirty"><img src="masterdata/pic/icon_saved.png"></div> <div class="col-xs-5 js_middle"></div> <div class="col-xs-6"> <div class="text-right"><input type="submit" name="submit" class="btn btn-primary " value="Save"> <button type="button" class="btn btn-default js_cancel">Cancel</button> </div> </div> </div>');
                options.selector=".js_dataform";
            default:
        }
        fieldwrapclassdefault=getfromArray(options,'fieldwrapclass',fieldwrapclassdefault);
        labelclass=getfromArray(options,'labelclass',labelclass);
        fieldclassdefault=getfromArray(options,'fieldclass',fieldclassdefault);
        fieldwraptemplate=getfromArray(options,'fieldwraptemplate',fieldwraptemplate);
        labeltemplate=getfromArray(options,'labeltemplate',labeltemplate);
        
        if(fields){
            for(var i=0;i<fields.length;i++){
              if(getfromArray(field,'type')=="hidden"){
                  html=createfield(field);
              }else{
                var fieldelement;
                fieldwraptemplate=getfromArray(fields[i],"fieldwraptemplate",fieldwraptemplate);
                
                if(isset(fields[i],'inputgroup')){
                  var inputgroup=fields[i];
                  var fieldelements={};
                  for(var j=0;j<inputgroup.fields.length;j++){
                    var field=setField(fields[j]);
                    fieldelements['field'+j]=createfield(field);
                  }
                  var objlabel=Object.assign(inputgroup,{"labelclass":labelclass});
                  var labelelement=ReplacePlaceholder(labeltemplate,objlabel,2);
                  var template_inputgroup=getfromArray(inputgroup,'template','{{field0}}');
                  fieldelement=ReplacePlaceholder(template_inputgroup,fieldelements,2);

                  var fieldwrapclass=fieldwrapclassdefault;
                  html+=ReplacePlaceholder(fieldwraptemplate,{"fieldwrapclass":fieldwrapclass,"fieldelement":fieldelement,"labelelement":labelelement},2);
                }else if(getfromArray(fields[i],'figure',0)==2){
                  // from to
                  var field=setField(fields[i]);
                  var labelelement=ReplacePlaceholder(labeltemplate,Object.assign(field,{"labelclass":labelclass}),2);
                  fieldelement=createfield(field,"from");
                  fieldelement+=createfield(setField(fields[i]),"to");
                  var fieldwrapclass=gsclauseand(fieldwrapclassdefault,'k8-flex-row',true," ");
                  html+=ReplacePlaceholder(fieldwraptemplate,{"fieldwrapclass":fieldwrapclass,"fieldelement":fieldelement,"labelelement":labelelement},2);
                }else{
                  var field=setField(fields[i]);
                  var labelelement=ReplacePlaceholder(labeltemplate,Object.assign(field,{"labelclass":labelclass}),2);
                  fieldelement=createfield(field);
                  var fieldwrapclass=fieldwrapclassdefault;
                  html+=ReplacePlaceholder(fieldwraptemplate,{"fieldwrapclass":fieldwrapclass,"fieldelement":fieldelement,"labelelement":labelelement},2);
                }
              }
            }
        }
        
        for(var i=0;i<containers.length;i++){
            if(gbnull(getfromArray(containers[i],'template'))){
                containers[i]['template']='{{innerHTML}}'
            }
            if(!gbnull(id_preset) && !containers[i]['id_preset'])containers[i]['id_preset']=id_preset;
            containers[i]['method']=method;
            html+=this.createform(containers[i],method);
        }
        function setField(field){
          if(!isset(field,'name'))field['name']=field['fieldname'];
          if(!isset(field,'class'))field['class']=fieldclassdefault;
          if(!isset(field,'type'))field['type']='string';
          if(!isset(field,'id'))field['id']=id_preset+field['name'];
          if(!isset(field,'tags'))field['tags']='';
          //if(!isset(field,'value'))field.value="";
          if(!isset(field,'label'))field.label=field.name;
          if(!isset(field,'figure'))field.figure=1;
          if(isset(GET,field.name))field.value=GET[field.name];
          return field;
        }
        
        function createfield(field,name_ext){
            var obj=JSON.parse(JSON.stringify(field));
            var fieldtemplate;
            var html='';
            if(!obj.tagName && !obj.fieldtemplate){
                obj.tagName="input";
            }
            if(typeof(name_ext)!=='undefined'){
                obj.name=obj.name+name_ext;
                obj.id=obj.id+name_ext;
            }
            if(obj.type=="hidden"){
              html='<input type="hidden" name="'+obj.name+'">';
            }else{
              switch(obj.tagName){
                  case "input":
                      // maxlength
                      // placeholder
                      var input_attributes="";
                      var decimals=getfromArray(obj,"decimals",0);
                      if(obj.type=="number" && decimals!=0){
                          if(!obj.step){
                              obj.step="0."+"0".repeat(obj.decimals-1)+'1';
                          }
                          input_attributes=gsclauseand(input_attributes,'step="'+obj.step+'"',!gbnull(obj.step),' ');
                      }
                      input_attributes=gsclauseand(input_attributes,'type="'+obj.type+'"',isset(obj,'type')," ");
                      input_attributes=gsclauseand(input_attributes,'class="'+getfromArray(obj,"class")+'"',isset(obj,'class')," ");
                      input_attributes=gsclauseand(input_attributes,'name="'+getfromArray(obj,"name")+'"',isset(obj,'name')," ");
                      input_attributes=gsclauseand(input_attributes,'id="'+getfromArray(obj,"id")+'"',isset(obj,'id')," ");
                      input_attributes=gsclauseand(input_attributes,'step="'+getfromArray(obj,"step")+'"',isset(obj,'step')," ");
                      input_attributes=gsclauseand(input_attributes,'value="'+getfromArray(obj,"value")+'"',isset(obj,'value')," ");
                      input_attributes=gsclauseand(input_attributes,'maxlength="'+getfromArray(obj,"maxlength")+'"',isset(obj,'maxlength'),' ');
                      input_attributes=gsclauseand(input_attributes,'placeholder="'+getfromArray(obj,"placeholder")+'"',isset(obj,"placeholder"),' ');
                      input_attributes=gsclauseand(input_attributes,getfromArray(obj,"input_attributes"),isset(obj,"input_attributes"),' ');
                      input_attributes=gsclauseand(input_attributes,getfromArray(obj,"tags"),isset(obj,"tags"),' ');
                      input_attributes=' '+input_attributes;
                      fieldtemplate='<input{{input_attributes}}>';
                      obj['input_attributes']=input_attributes;
                      html=ReplacePlaceholder(fieldtemplate,obj,2);
                      break;
                  case "select":
                      fieldtemplate='<select class="{{class}}" name="{{name}}" id="{{id}}" {{tags}}>{{options}}</select>';
                      html=ReplacePlaceholder(fieldtemplate,obj,2);
                      break;
                  case "textarea":
                      fieldtemplate='<textarea class="{{class}}" name="{{name}}" id="{{id}}" {{tags}}>{{value}}</textarea>';
                      html=ReplacePlaceholder(fieldtemplate,obj,2);
                      break;
                  default:
                      if(obj.fieldtemplate){
                        fieldtemplate=obj.fieldtemplate;
                        html=ReplacePlaceholder(fieldtemplate,obj,2);
                      }
              }
            }
            return html;
        }
        
        html=ReplacePlaceholder(template,{"innerHTML":html,"formname":"filterform"},2);  // options, method ,.....
        if(options.selector){
          var el;
          switch (options.selector.substr(0,1)){
            case '#':
              el=document.getElementById(options.selector.substr(1));
              break;
            case '.':
              el=document.getElementsByClassName(options.selector.substr(1))[0];
              break;
            default:
              el=document.getElementsByTagName(options.selector.substr(1))[0];
              break;
          }
          el.innerHTML=html;
          //$(options.selector).html(html);
        }
        return html;
    },
*/
            
    "createbsmenu":function(options){
      var html_li_simple='<li{{li_attributes}}><a href="{{href}}"{{a_attributes}}>{{title}}</a></li>';
      var html_li_dropdown='<li{{li_attributes}}>'+
          '<a class="dropdown-toggle" data-toggle="dropdown" role="button" href="#" aria-haspopup="true" aria-expanded="false" {{a_attributes}}>{{title}} <span class="caret"></span></a>'+
          '<ul role="menu" class="dropdown-menu">'+
          '{{innerHTML}}'+
          '</ul></li>';
      var lis=getfromArray(options,"menu",[]);
      var selector=getfromArray(options,"selector",".mynavi .navbar-nav"); 
      options.html_li_simple=getfromArray(options,"html_li_simple",html_li_simple);
      options.html_li_dropdown=getfromArray(options,"html_li_dropdown",html_li_dropdown);
      options.li_class_active=getfromArray(options,"li_class_active","active");
      
      var html=this.createbslis(options,lis);
      $(selector).append(html);
    },
    "createbslis":function(options,lis){
      //' class="active"' :  '' ?>
      //'<li{{li_attr}}><a tabindex="-1" href="{{href}} target="{{target}}">{{title}}</a></li>'
      var pages=getfromArray(options,"pages",{});
      var html="";
      for(var i=0;i<lis.length;i++){
        var item=lis[i];
        var bvisible=true;
        var condition=getfromArray(item,"condition","true");
        try{
          bvisible=eval(condition);
        }
        catch(e){
          // error
          console.log('error by expression: '+condition);
        }
        if(bvisible){ //condition
          var bactive=false;
          item.target=getfromArray(item,"target");
          item.li_attributes=getfromArray(item,"li_attributes");
          item.a_attributes=getfromArray(item,"a_attributes");
          item.page=getfromArray(item,"page");
          var href="#";
          if(!gbnull(item.page)){
            if(isset(pages,item.page))href=getfromArray(pages[item.page],"url");
          }
          item.href=getfromArray(item,"href",href);
          item.active_by=getfromArray(item,"active_by","page");
          switch(item.active_by){
            case "page":
              if(!gbnull(page))bactive=(item.page==page);
              break;
            case "url":
              var url=window.location.href.replace(/.*\//, '');
              bactive=(item.href==url);
              break;
            case "basename":
              var url=window.location.href.replace(/.*\//, '');
              var basename=url.split('?')[0];
              bactive=(item.href==basename);
              break;
            case "none":
              break;
            default:
          }
          var li_class="";
          li_class=gsclauseand(li_class,options.li_class_active,bactive," ");
          var li_attributes="";
          li_attributes=gsclauseand(li_attributes,'class="'+li_class+'"',!gbnull(li_class)," ");
          li_attributes=gsclauseand(li_attributes,item.li_attributes,!gbnull(item.li_attributes)," ");
          item.li_attributes=gbnull(li_attributes) ? "" : " "+li_attributes;

          var a_attributes=item.a_attributes;
          a_attributes=gsclauseand(a_attributes,'target="'+item.target+'"',!gbnull(item.target)," ");
          item.a_attributes=gbnull(a_attributes) ? "" : " "+a_attributes;

          //onclick
          var children=getfromArray(item,"children",[]);
          if(children.length>0){
            var html_item=ReplacePlaceholder(options.html_li_dropdown,item,2);
            var innerHTML=this.createbslis(options,children);
            html+=html_item.replace('{{innerHTML}}',innerHTML);
          }else if(isset(item,'li_template')){
            html+=ReplacePlaceholder(item.li_template,item,2);
          }else{
            html+=ReplacePlaceholder(options.html_li_simple,item,2);
          }
        }
      }
      return html;
    }
};

var storage = new function () {
    var dataContainer = {};
    function linearize () {
            var string = "", name, value;
            for (name in dataContainer) {
                    value = encodeURIComponent(dataContainer[name]);
                    name = encodeURIComponent(name);
                    string += name + "=" + value + "&";
            }
            if (string != "") {
                    string = string.substring(0, string.length - 1);
            }
            return string;
    }
    function read () {
            if (window.name == '' || window.name.indexOf("=") == -1) {
                    return;
            }
            var pairs = window.name.split("&");
            var pair, name, value;
            for (var i = 0; i < pairs.length; i++) {
                    if (pairs[i] == "") {
                            continue;
                    }
                    pair = pairs[i].split("=");
                    name = decodeURIComponent(pair[0]);
                    value = decodeURIComponent(pair[1]);
                    dataContainer[name] = value;
            }
    }
    function write () {
            window.name = linearize();
    }

    /* --------- Public Methods --------- */
    this.set = function (name, value) {
            dataContainer[name] = value;
            write();
    };

    this.get = function (name) {
            var returnValue = dataContainer[name];
            return returnValue;
    };

    this.getAll = function () {
            return dataContainer;
    };

    this.remove = function (name) {
            if (typeof(dataContainer[name]) != undefined) {
                    delete dataContainer[name];
            }
            write();
    };

    this.removeAll = function () {
            dataContainer = {};
            write();
    };

    /* --------- Construction --------- */
    read();
};

function array2str(obj,delimiter){
    var str="";
    delimiter=typeof delimiter!=='undefined' ? delimiter : '&';        
    for(var prop in obj){
        str=gsclauseand(str,prop+'='+obj[prop],true,delimiter);
    }
    return str;
}

function isset(obj,prop1,prop2,prop3,prop4,prop5,prop6){
    try {
        if(typeof(prop6)!='undefined'){
            return obj[prop1][prop2][prop3][prop4][prop5].hasOwnProperty(prop6);
        }else if(typeof(prop5)!='undefined'){
            return obj[prop1][prop2][prop3][prop4].hasOwnProperty(prop5);
        }else if(typeof(prop4)!='undefined'){
            return obj[prop1][prop2][prop3].hasOwnProperty(prop4);
        }else if(typeof(prop3)!='undefined'){
            return obj[prop1][prop2].hasOwnProperty(prop3);
        }else if(typeof(prop2)!='undefined'){
            return obj[prop1].hasOwnProperty(prop2);
        }else if(typeof(prop1)!='undefined'){
            return obj.hasOwnProperty(prop1);
        }else if(typeof(obj)!='undefined'){
            return true;
        }
        return false;
    }
    catch(err) {
      return false;
    }    
}

function searchbox_search(el,datadefID,insertfunction,datadefinition,filters,bsc2){
    // under construction
    // masterdata.filters !!!
    insertfunction=typeof insertfunction!=='undefined' ? insertfunction:'searchBox_insert';        
    bsc2=typeof bsc2!=='undefined' ? bsc2:false;        
    var form=$(el).parents('form')[0];
    var el_rec_record=$(el).parents('.js_rec_record')[0];
    var inputgroup=$(el).parents('.js_searchbox_group')[0];
    var el_IDfield=$(inputgroup).find('input[type=hidden]')[0];
    var el_displayfield=$(inputgroup).find('input[type=text]')[0];
    if(el_IDfield && el_displayfield && datadefinition){
        //var clause;
        var qs='';
        if(bsc2){
          if(datadefinition.searchcolumn2){
            qs='&filters[0][field]='+datadefinition.searchcolumn2+'&filters[0][type]=like&filters[0][value]='+el.value;
          }else{
            console.log('datadefinition.searchcolumn2 not set!');
            return;
          }
        }else if(el_displayfield.value.substring(0,1)=='?' && datadefinition.searchcolumn2){
            //clause=(datadefinition.searchcolumn2+" like '%"+el_displayfield.value.substring(1)+"%'");
            qs='&filters[0][field]='+datadefinition.searchcolumn2+'&filters[0][type]=like&filters[0][value]='+el_displayfield.value.substring(1);
        }else if(datadefinition.searchcolumn1){
            //clause=(datadefinition.searchcolumn1+" like '%"+el_displayfield.value+"%'");
            qs='&filters[0][field]='+datadefinition.searchcolumn1+'&filters[0][type]=like&filters[0][value]='+el_displayfield.value;
        }else if(datadefinition.displaycolumn){
            //clause=(datadefinition.displaycolumn+" like '%"+el_displayfield.value+"%'");
            qs='&filters[0][field]='+datadefinition.displaycolumn+'&filters[0][type]=like&filters[0][value]='+el_displayfield.value;
        }else{
            console.log('displaycolumn not set!');
            return;
        }
        //var url="masterdata/ProcessData.php?process_action=ReadFilter&datadefID="+datadefID+"&clause="+clause;
        var url='../'.repeat(GLOBALS_script_depth)+"masterdata/ProcessData.php?process_action=ReadFilter&datadefID="+datadefID+qs;
        var data=filters;
        if(isset(datadefinition,'masterdata','url_readfilter')){
          url='../'.repeat(GLOBALS_script_depth)+datadefinition.masterdata.url_readfilter+'?'+qs;
          data=$.extend(true,data,datadefinition.masterdata.data_readfilter);
        }
        $.getJSON(url,data,function(ret) {
            var index=0;
            if(el_rec_record)index=Number(el_rec_record.dataset.rec_index);
            if(ret.length==1){
                // return object
                var obj={};
                obj.data=ret[0];
                obj.js_return={};
                obj.js_return.form=form;
                obj.js_return.index=index;
                obj.js_return.mydisplayfield=el_displayfield.name;
                obj.js_return.myIDfield=el_IDfield.name;
                
                obj.js_return.displaycolumn=datadefinition.displaycolumn;
                obj.js_return.key=datadefinition.key;
                
                if(typeof insertfunction === 'function') {
                    insertfunction(obj);
                }else{
                    var fn=window[insertfunction];
                    if(typeof fn === 'function') {
                      fn(obj);
                    }else{
                      console.log(func_name+' is not a function!');
                    }
                }
            }else{
                var initialHeaderFilter={};
                var obj={"function_name":insertfunction,"form":form};
                obj['index']=index;
                obj['myIDfield']=el_IDfield.name;
                obj['mydisplayfield']=el_displayfield.name;
                if(bsc2){
                  if(datadefinition.searchcolumn2){
                    initialHeaderFilter=[{"field":datadefinition.searchcolumn2,"type":"like","value":el.value}];
                  }else{
                    console.log('datadefinition.searchcolumn2 not set!');
                    return;
                  }
                }else if(el_displayfield.value.substring(0,1)=='?' && datadefinition.searchcolumn2){
                    initialHeaderFilter=[{"field":datadefinition.searchcolumn2,"type":"like","value":el_displayfield.value.substring(1)}];
                }else if(datadefinition.searchcolumn1){
                    initialHeaderFilter=[{"field":datadefinition.searchcolumn1,"type":"like","value":el_displayfield.value}];
                }else if(datadefinition.displaycolumn){
                    initialHeaderFilter=[{"field":datadefinition.displaycolumn,"type":"like","value":el_displayfield.value}];
                }else{
                    console.log('displaycolumn not set!');
                    return;
                }
                
                if(typeof datadefinition.tabulator=="undefined"){
                    if(typeof datadefID=="undefined"){
                        console.log('datadefID and datadefinition undefined!');
                    }else{
                        var url='masterdata/ProcessData.php?process_action=GetObject&datadefID='+datadefID;
                        displaySearchBox(url,obj,{'tabulator':{'initialHeaderFilter':initialHeaderFilter}});
                    }
                }else{
                    datadefinition['js_return']=obj;
                    datadefinition.tabulator.initialHeaderFilter=initialHeaderFilter;
                    $('body').searchbox(datadefinition);
                }
            }
        })
        .fail(function(jqxhr, textStatus, error ) {
            var err = url+", Request Failed, "+ textStatus + ", " + error;
            alert(err );
        });			
    }else{
        console.log('not set IDfield, displayfield or datadefinition');
    }
}  

function searchBox_open(el,datadefID,insertfunction,datadefinition,filters){ 
  //GLOBALS_script_depth
    if(!$(el).hasClass('js_disabled')){
        insertfunction=typeof insertfunction!=='undefined' ? insertfunction:'searchBox_insert';
        // getting parent record
        var form=$(el).parents('form')[0];
        var el_inputgroup=$(el).parents('.js_searchbox_group')[0];
        var el_IDfield=$(el_inputgroup).find('input[type=hidden]')[0];
        var el_displayfield=$(el_inputgroup).find('input[type=text]')[0];
        var el_next=$(el_inputgroup).next().find('input,select,textarea')[0];
        if(!el_next){
            var el_parent=$(el_inputgroup).parent()[0];
            var el_next=$(el_parent).next().find('input,select,textarea')[0];
            if(!el_next){
                var el_parent=$(el_parent).parent()[0];
                var el_next=$(el_parent).next().find('input,select,textarea')[0];
            }
        }
        if(el_IDfield && el_displayfield){
            var obj={"function_name":insertfunction,"form":form};
            obj['myIDfield']=el_IDfield.name;
            obj['mydisplayfield']=el_displayfield.name;
            if(el_next)obj['el_next']=el_next;
            if(typeof datadefinition=="undefined"){
                if(typeof datadefID=="undefined"){
                    console.log('datadefID and datadefinition undefined!');
                }else{
                    var url='../'.repeat(GLOBALS_script_depth)+'masterdata/ProcessData.php?process_action=GetObject&datadefID='+datadefID;
                    displaySearchBox(url,obj,{"masterdata":{"script_depth":GLOBALS_script_depth}});
                }
            }else{
                if(typeof filters!=='undefined'){
                    /*
                    if(datadefinition.masterdata.filters){
                        for(var i=0;i<filters.length;i++){
                            datadefinition.masterdata.filters.push(filters[i]);
                        }
                    }else{
                        datadefinition.masterdata.filters=filters;
                    }
                    console.log(datadefinition.masterdata.filters);
                    */
                    datadefinition.masterdata.filters=filters;
                }
                datadefinition['js_return']=obj;
                $('body').searchbox(datadefinition);
            }
        }else{
            console.log('el_IDfield or el_displayfield not found!');
        }
    }
}

function searchBox_insert(obj){
  var o={};
  var el_form=obj.js_return.form;
  el_form.elements.namedItem(obj.js_return.mydisplayfield).value=obj.data[obj.js_return.displaycolumn];
  el_form.elements.namedItem(obj.js_return.myIDfield).value=obj.data[obj.js_return.key];
  var el_inputgroup=$(el_form.elements.namedItem(obj.js_return.myIDfield)).parents('.js_searchbox_group')[0];
  if(el_inputgroup.dataset.fieldlist){
    var fields=el_inputgroup.dataset.fieldlist.split(',');
    for(var i=0;i<fields.length;i++){
      if(fields[i].indexOf('=')>-1){
          var map=fields[i].split('=');
          o[map[0]]=obj.data[map[1]];
          /*
          if(el_form.elements.namedItem(map[0])){
             el_form.elements.namedItem(map[0]).value=obj.data[map[1]];
          }*/
      }else{
          o[fields[i]]=obj.data[fields[i]];
          /*
          if(el_form.elements.namedItem(fields[i])){
             el_form.elements.namedItem(fields[i]).value=obj.data[fields[i]];
          }
          */
      }
    }
    obj2form(o,el_form,true);
  }
  if(obj.js_return.el_next)obj.js_return.el_next.focus();
}

function searchBox_delete(el){ 
    if(!$(el).hasClass('js_disabled')){
        var el_inputgroup=$(el).parents('.input-group')[0];
        var el_key=$(el_inputgroup).find('input[type=hidden]')[0];
        el_key.value=null;
        $(el_inputgroup).find('input[type=text]')[0].value=null;
        if(el_inputgroup.dataset.fieldlist){
            var el_form=el_key.form;
            var fields=el_inputgroup.dataset.fieldlist.split(',');
            for(var i=0;i<fields.length;i++){
                if(fields[i].indexOf('=')>-1){
                    var map=fields[i].split('=');
                    if(el_form.elements.namedItem(map[0])){
                        el_form.elements.namedItem(map[0]).value=null;
                    }
                }else{
                    if(el_form.elements.namedItem(fields[i])){
                       el_form.elements.namedItem(fields[i]).value=null;
                    }
                }
            }
        }
    }
}

function SetArrayAll(myarray,prop,value){
    for(var i=0;i<myarray.length;i++){
    	if(myarray[i][prop]){
            myarray[i][prop]=value;
       }else{
            myarray[i][prop]=value;
       }
    }
}

function Array_GET(){
    var GET = {};
    if(window.location.search.substr(1)){
        var parts = window.location.search.substr(1).split("&");
        for (var i = 0; i < parts.length; i++) {
            var temp = parts[i].split("=");
            GET[decodeURIComponent(temp[0])] = decodeURIComponent(temp[1]);
        }
    }
    return GET; //this is an object
}

function gsclauseand(sql,clause,condition,delimiter){
    sql=typeof sql!=='undefined' ? sql:"";        
    clause=typeof clause!=='undefined' ? clause:"";        
    condition=typeof condition!=='undefined' ? condition:true;        
    delimiter=typeof delimiter!=='undefined' ? delimiter:' and ';        
    if(condition){
        if(sql.length>0 && clause.length>0){
            return sql+delimiter+clause;
        }else{
            if(sql.length>0){
                return sql;
            }else{
                return clause;
            }
        }
    }else{
        return sql;
    }
}

function gbEmptyStructure(obj){
    for (var prop in obj) {
        if(typeof(obj[prop])=='object'){
            if(!gbEmptyStructure(obj[prop])){
                return false;
            }
        }else if(typeof(obj[prop])=='function'){
            // nothing
        }else if(!gbnull(obj[prop])){
            return false;
        }
    }
    return true;
}

function DeleteEmptyStructure(obj){
    for (var prop in obj) {
        if(typeof(obj[prop])=='object'){
            if(gbEmptyStructure(obj[prop])){
                delete obj[prop];
            }else{
                DeleteEmptyStructure(obj[prop]);
            }
        }else if(typeof(obj[prop])=='function'){
            // nothing
        }else if(!gbnull(obj[prop])){
            //return false;
        }
    }
    //return true;
}

function getobjectfromstr(namestr){
    /*
    var pos1=namestr.lastIndexOf('[');
    if(pos1>-1){
        var pos2=namestr.lastIndexOf(']');
        return namestr.slice(pos1+1,pos2);
    */
    var pos1=namestr.lastIndexOf(']');
    if(pos1>-1){
        return namestr.slice(pos1+1);
    }else{
       return namestr;
    }
}
function getobjectfromstrCatalog(namestr){
    var pos1=namestr.lastIndexOf('[');
    if(pos1>-1){
        var pos2=namestr.lastIndexOf(']');
        return namestr.slice(pos1+1,pos2);
    }else{
       return namestr;
    }
}


//function displayMasterData(sel,url,masterdata,oOverwrite){
function displayMasterData(sel,url,oOverwrite){
    var selector=sel;
    $.getJSON(url, function(ret) {
        if(ret.bok){
            oOverwrite=$.extend(true,ret['data'],oOverwrite);
            $(selector).masterdata(oOverwrite);
        }else{
            $(selector).html(ret.error);
        }
    })
    .fail(function(jqxhr, textStatus, error ) {
        var err = url+", Request Failed, "+ textStatus + ", " + error;
        alert(err );
    });			
}

function displaySearchBox(url,obj_return,oOverwrite){
    var overlay=document.getElementById('k8-overlay');
    if(!overlay){
        var selector="body";
        $.getJSON(url, function(ret) {
            if(ret.bok){
                var o=$.extend(true,ret['data'],oOverwrite);
                o['js_return']=obj_return;
                var masterform=$(selector).searchbox(ret['data']);
            }else{
                var masterform=$(selector).html(ret.error);
            }
        })
        .fail(function(jqxhr, textStatus, error ) {
            var err = url+", Request Failed, "+ textStatus + ", " + error;
            alert(err );
        });			
    }
}

function displayCatalog(sel,url,oOverwrite){
    var selector=sel;
    $.getJSON(url, function(ret) {
        if(ret.bok){
            var o=ret['data'];
            o=$.extend(true,o,oOverwrite);
            $(selector).masterdata(o);
        }else{
            $(selector).html(ret.error);
        }
    })
    .fail(function(jqxhr, textStatus, error ) {
        var err = url+", Request Failed, "+ textStatus + ", " + error;
        alert(err );
    });			
}

function getfromArray(arr,key,mydefault,bn){
    mydefault=typeof mydefault !== 'undefined' ? mydefault : '';        
    bn=typeof bn==="undefined" ? false : bn;
    var result;
    try {
        if(isNaN(key)){
            if(arr.hasOwnProperty(key)){
                if(gbnull(arr[key]) && bn){
                    result=mydefault;
                }else{
                    result=arr[key];
                }
            }else{
                result=mydefault;
            }
        }else{
            if(gbnull(arr[key]) && bn){
                result=mydefault;
            }else{
                result=arr[key];
            }
        }
    }
    catch(err) {
        result=mydefault;
    }
    return result;
}
function gbnull(v){
    return (typeof v=='undefined' || v==null || v=='' || v=='0' || v=='');
}

function objReplacePlaceholder(o,obj,mode,path){
    const iterate = (o) => {
        Object.keys(o).forEach(key => {
            console.log(`key: ${key}, value: ${o[key]}`)
            if (typeof o[key] === 'object') {
                iterate(o[key])
            }else if(typeof o[key] === 'string'){
                //${o[key]}=ReplacePlaceholder(${o[key]},obj,mode,path);
            }
        })
    }    
}

function nestedLoop(obj) {
    function recurse(obj, current) {
        for (const key in obj) {
            let value = obj[key];
            if(value != undefined) {
                if (value && typeof value === 'object') {
                    recurse(value, key);
                } else if(typeof value === 'string'){
                    var $identifier="#ls#";
                    var str=value;
                    while(str.indexOf($identifier)>=0){
                        var $pos_start=str.indexOf($identifier);
                        var $pos_ende=str.indexOf("#",$pos_start+$identifier.length+1);
                        if($pos_ende>0){
                            var $placeholder=str.substr($pos_start,$pos_ende-$pos_start+1);
                            var $temp=str.substr($pos_start+$identifier.length,$pos_ende-$identifier.length-$pos_start);
                            $temp=getl($temp);
                            str=str.replace($placeholder,$temp);
                        }else{
                            str=str.substr(0,$pos_start)+str.substr($pos_start+$identifier.length);
                        }
                    }
                    obj[key] = str;
                    //console.log(key);
                }
            }
        }
    }
    recurse(obj);
}

function ReplacePlaceholder(str,dat,mode,path,k8formatter,oformatter){
    dat=typeof dat !== 'undefined' ? dat : {};
    mode=typeof mode !== 'undefined' ? mode : 1;
    oformatter=typeof oformatter !== 'undefined' ? oformatter : [];
    for (var key in dat) {
        if (dat.hasOwnProperty(key)){
            
            var value=dat[key];
            if(typeof k8formatter !=='undefined'){
                var index=getArrayIndexfromValue(oformatter,'field',key);
                if(index>-1){
                    if(isset(oformatter[index])){
                        value=k8formatter.format(oformatter[index],value);
                    }   
                }
            }
            
            if(mode==1){
                str = replaceAll(str,"["+key+"]",value);
            }else if(mode==2){
                str = replaceAll(str,"{{"+key+"}}",value);
            }else if(mode==3){
                str = replaceAll(str,"{{"+key+"*}}",value);
                str = replaceAll(str,"["+key+"*]",value);
            }else{
                str = replaceAll(str,key,value);
            }
        }
    }
    var $identifier="#ls#";
    while(str.indexOf($identifier)>=0){
        var $pos_start=str.indexOf($identifier);
        var $pos_ende=str.indexOf("#",$pos_start+$identifier.length+1);
        if($pos_ende>0){
            var $placeholder=str.substr($pos_start,$pos_ende-$pos_start+1);
            var $temp=str.substr($pos_start+$identifier.length,$pos_ende-$identifier.length-$pos_start);
            $temp=getl($temp);
            str=str.replace($placeholder,$temp);
        }else{
            str=str.substr(0,$pos_start)+str.substr($pos_start+$identifier.length);
        }
    }
    
    if(typeof path!='undefined'){
        str = replaceAll(str,"uploads",path+'uploads');
        str = replaceAll(str,"masterdata/pic/",path+'masterdata/pic/');
    }
    return str;
}

/* Define functin to find and replace specified term with replacement string */
function replaceAll(str, term, replacement) {
  return str.replace(new RegExp(escapeRegExp(term), 'g'), replacement);
}
function escapeRegExp(string){
    return string.replace(/[.*+?^${}()|[\]\\]/g, "\\$&");
}

function isNumeric(n) {
  return !isNaN(parseFloat(n)) && isFinite(n);
}

function getSubName(type,fullname,index){
    index= typeof index !== 'undefined' ? index : 0;
    var pos1=fullname.lastIndexOf('[');
    switch(type){
    case 'name': // items.itemID
        var part1;
        var part2;
        if(pos1>=0){
            var pos2=fullname.lastIndexOf(']');
            part2=fullname.slice(pos1+1,pos2);
            var pos3=fullname.lastIndexOf('[',pos1-1);
            if(pos3>0){
                // erase number
                var rest=fullname.slice(0,pos3);
                var pos4=rest.lastIndexOf(']',pos1-1);
                if(pos4>=0){
                    var pos5=rest.lastIndexOf('[',pos4-1);
                    part1=fullname.slice(pos5+1,pos4);
                }else{
                    part1=rest;
                }
            }else{
                part1=fullname.slice(0,pos1);
            }
            //return fullname.slice(pos1+1,pos2);
        }else{
            return fullname;
        }
        if(gbnull(part2)){
            return part1;
        }else{
            return part1+'.'+part2;
        }
        break;
    case 'columnname':  // itemID
        if(pos1>=0){
	    var pos2=fullname.lastIndexOf(']');
    	    return fullname.slice(pos1+1,pos2);
        }
        break;
    case 'namestr':
        if(pos1>=0){
            return fullname.slice(0,pos1);
        }else{
            return '';
        }
        break;
    case 'namestr1':
        var pos1=fullname.indexOf(']');
        if(pos1>=0){
            return fullname.slice(0,pos1+1);
        }else{
            return '';
        }
        break;
    case 'namemain':
        if(pos1>=0){
            var namenew=fullname.slice(0,pos1);
            pos1=namenew.lastIndexOf('[');
            if(pos1>=0){
                return fullname.slice(0,pos1);
            }else{
                return '';
            }
        }else{
            return '';
        }
        break;
    case 'part':
        var arr=fullname.split('[');
        for(var i=1;i<arr.length;i++){
            arr[i]=arr[i].replace(']','');
        }
        return arr[index];
        break;
    }
}

    
    
    // NOT USED
    function object2input(el_record,dat){
        var el_form=$(el_record).parents('form')[0];
        for(var i=0;i<el_form.elements.length;i++){
            $(el_form.elements[i]).val(getfromArray(dat,el_form.elements[i].name));
        }
    }

(function($){
    $.fn.masterdata = function( options ) {
        var bselectable=false;
        var datadefID;
        var mymaster={};
        var mydefault={
            "tabulator":{
                height:205,
                movableColumns: true,
                headerFilterPlaceholder:"",
                ajaxFiltering:true,
                layout:"fitColumns"/*,
                selectableCheck:function(row){
                    return bselectable;
                },
                "selectable":true,
                "selectableRangeMode": "click"*/
            },
            "masterdata": {
                menuleft_options:true,
                bGETfilters:true,
                init_after_save:true,
                auto_save:false,
                window_mode:0,
                edittype:8,
                formmode:2, /* 1 html, 2 jsonform, 3 k8form */
                placeholder_mode:1,
                message_position:3,
                bresize:true,
                upload:{enabled:false,
                        singleimage:false
                },
                defaultvalues:{}
            },
            "return":{},
            "jsonform_conf":{
                "formtype":2,
                "formclass":"form-horizontal",
                "labelHtmlClass":"control-label label-left col-sm-3",
                "fieldWrapClass":"col-sm-9"
            }
        };
        if(options.hasOwnProperty('datadefID')){
            datadefID=options.datadefID;
            mymaster={'masterdata':{
                "url_new":  "index.php?page=form&page_mode=1&datadefID="+datadefID,
                "url_edit": "index.php?page=form&page_mode=1&process_action=Edit&datadefID="+datadefID,
                "url_getR": "masterdata\/ProcessData.php?process_action=getRecords&datadefID="+datadefID,
                "url_init": "masterdata\/ProcessData.php?process_action=Init&datadefID="+datadefID,
                "url_load": "masterdata\/ProcessData.php?process_action=Load&datadefID="+datadefID,
                "url_save": "masterdata\/ProcessData.php?process_action=Save&datadefID="+datadefID,
                "url_del":  "masterdata\/ProcessData.php?&process_action=Del&datadefID="+datadefID,
                "url_readfilter": "masterdata\/ProcessData.php",
                "data_readfilter": {
                    "datadefID": datadefID,
                    "process_action": "ReadFilter"
                    }
                }
            }
        }
        var settings = $.extend(true, mydefault, mymaster, options );
        
        var url='';
        var path='../'.repeat(settings.masterdata.script_depth);
        settings.masterdata.root=path;
        
        /*
        if(!settings.jsonform_conf){
            settings.jsonform_conf={"formtype":2,
                            "formclass":'form-horizontal',
                            "labelHtmlClass":'control-label label-left col-sm-3',
                            "fieldWrapClass":"col-sm-9"};
        }
        */
       
        if(settings.masterdata.bGETfilters){
            var GET=Array_GET();
            for(prop in GET){
                if(GET.hasOwnProperty(prop)){
                    if(prop=='reset_filter'){
                        if(GET[prop])settings.tabulator.initialHeaderFilter=[];
                    }
                }
            }
            for(prop in GET){
                if(GET.hasOwnProperty(prop)){
                    if(getArrayIndexfromValue(settings.tabulator.columns,'field',prop)>-1){
                        if(settings.tabulator.initialHeaderFilter){
                            settings.tabulator.initialHeaderFilter.push({field:prop,type:'=',value:GET[prop]});
                        }else{
                            settings.tabulator.initialHeaderFilter=[{field:prop,type:'=',value:GET[prop]}];
                        }
                    }
                }
            }
        }       
        if(settings.masterdata.heartbeat){
            setInterval(function(){
                $.getJSON('masterdata/ProcessData.php');
                //if(settings.masterdata.fninittimer)settings.masterdata.fninittimer();
                if(settings.masterdata.pagetimer)settings.masterdata.pagetimer.reset();
            }, settings.masterdata.heartbeat);
        }
        if(!settings.masterdata.url_readfilter){
            console.log('settings.masterdata.readfilter not set!');
        }
        var blanguages=true //typeof insertfunction!=='undefined' ? insertfunction:'searchBox_insert';        

        var notabulator=getfromArray(settings.masterdata,'notabulator',false);
        var bwithdirty=getfromArray(settings.masterdata,'bwithdirty',true);
        var bnoform=getfromArray(settings.masterdata,'bnoform',false);
        if(notabulator)settings.tabulator.selectable=false;
        
        var el_md;
        var el_form;
        var tableTab;
        var row_actual=0;
        var returnflag=Number(getfromArray(Array_GET(),'returnflag',0));
        var returnopener=Number(getfromArray(Array_GET(),'returnopener',0));
        
        if(settings.masterdata.clause){
            settings.masterdata.data_readfilter.clause=settings.masterdata.clause;
        }
        if(settings.masterdata.filters){
            settings.masterdata.data_readfilter.filters=settings.masterdata.filters;
        }
        if(isset(settings.masterdata,'datareadlimit')){
            settings.masterdata.data_readfilter.mytable_offset=0;
            settings.masterdata.data_readfilter.mytable_limit=settings.masterdata.datareadlimit;
        }
          
        var img_settings={};

        //return this.each(function(){
        //this.each(function(){
        if(this.length==1){
            // create listbox
            //el_md=this;
            el_md=this[0];
            $(el_md).off();
            img_settings={
                el_base:el_md,
                basetype:settings.table,
                mode:!settings.masterdata.upload.singleimage,
                script_depth:settings.masterdata.script_depth
            };
            if(settings.masterdata.upload.enabled){
                //"js_rec_container":"<div class='k8-images'>   <div class='js_rec_container rec_container k8-padding-6' data-rec_object='k8references' data-rec_indexmax='-1'>     <div style='display: flex;'>       <div>         <h3>Images</h3>       </div>       <div style='flex: 1 1 30%;text-align: right; padding-top: 10px;'>         <button type='button' class='btn btn-primary js_DeleteSelected'>Delete</button>       </div>     </div>         <div id='picutes'>       <form action='masterdata/ProcessData.php?process_action=Save&datadefID=8' name='dropzone' class='dropzone k8-margin-bottom-normal'>         <input type='hidden' name='basetype' value=''>         <input type='hidden' name='baseID' value=''>         <input type='hidden' name='type' value='image'>       </form>     </div>          <div class='row js_rec_records'>      </div>   </div> </div>"
                Dropzone.autoDiscover = false;
                img_settings=$.extend(true,img_settings,settings.masterdata.upload.settings);
            }

            $(this).addClass('masterdata');
            
            // ------------------------------------------ HTML -------------------------------------------
            var menulefthtml='';
            if(notabulator){
                if(isset(settings.masterdata,'menuleftformhtml')){
                    menulefthtml=settings.masterdata.menuleftformhtml;
                }
                settings.masterdata.menuleft_options=false;
            }else if(isset(settings.masterdata,'menulefthtml')){
                menulefthtml=settings.masterdata.menulefthtml;
            }
            if(gbnull(menulefthtml) && settings.masterdata.menuleft_options){
                menulefthtml='<div class="dropdown">'+
                    '<button type="button" class="btn btn-default dropdown-toggle" data-toggle="dropdown" aria-expanded="true" aria-haspopup="true">'+
                    '    <span class="glyphicon glyphicon-menu-hamburger" aria-hidden="true"></span>'+
                    '</button>'+
                    '<ul class="dropdown-menu" style="z-index: 10000000"><ul>'+
                    '</div>';
            }
            var headline='<div class="headline">' +
                            '<div>'+
                                (menulefthtml) +
                                '<h3 class="js_title">Master Data Form</h3></div>'+
                            '<div>'+
                                (settings.tabulator.selectable ? 'M <input type="checkbox" class="js_selectmode" style="margin-right:15px">' : '') +
                                '<button type="button" class="btn btn-primary js_rec_new">'+getl('New')+'</button>'+
                            '</div>'+
                         '</div>';
            if(settings.masterdata.hasOwnProperty('headline')){
                headline=settings.masterdata.headline;
            }
            //var formwrapper='<div class="form-wrapper">'+
            //            '<form class="'+(bnoform?"":"jsonform masterdata-form")+'"></form>'+
            //            '</div>';
            var formwrapper='<div class="form-wrapper">'+
                        '<form class="'+(bnoform?"":"masterdata-form js_dataform")+'"></form>'+
                        '</div>';
            if(settings.masterdata.hasOwnProperty('formwrapper')){
                formwrapper=settings.masterdata.formwrapper;
            }
            
            var footline='<div class="footline">'+
                            '<div></div>'+
                         '</div>';
            if(settings.masterdata.hasOwnProperty('footline')){
                footline=settings.masterdata.footline;
                if(gbnull(footline) && settings.masterdata.message_position==0){
                    settings.masterdata.message_position=2;
                }
            }
            
            // ------------------------------------------ filterform -------------------------------------------
            var filterform="";
            if(isset(settings,'html','filterform')){
                filterform=settings.html.filterform;
            //}else if(isset(settings,"masterdata","filterfields")){
            //    filterform=k8.createform({"templatetype":"filterform","method":"GET","fields":settings.masterdata.filterfields});
            //}
            }else if(isset(settings,"masterdata","filterobject")){
                var filterobject=settings.masterdata.filterobject;
                if(!filterobject.templatetype)filterobject.templatetype="filterform";
                if(!filterobject.method)filterobject.method="GET";
                if(!filterobject.fields){
                    console.log('masterdata.filterobject.fields not set!');
                }else{
                    filterform=k8.createform(filterobject);
                }
            }

            var html_tabulator="";
            if(settings.masterdata.tabcolumns){
              html_tabulator='<div style="display: flex; width:100%; border: 1px solid #ccc">'+
                '<div class="js_columnlist k8-padding-6" style="min-width: 250px;display: none; border: 1px solid #ccc">'+
                    '<div style="display: flex;">'+
                      '<div style="flex: 0 0 50%">'+
                        '<h4>Columns</h4>'+
                      '</div>            '+
                      '<div style="flex: 0 0 50%; text-align: right;">'+
                      '  <button class="btn btn-default" id="js_close_columnlist">Close</button>'+
                      '</div>            '+
                    '</div>'+
                    '  <form id="columnlist_form"></form>'+
                  '</div>'+
                  '<div style="width:100%" class="tabulator'+(settings.masterdata.bresize ? ' resize-s' : "")+'"></div>'+
              '</div>';
            }else{
              html_tabulator='<div class="tabulator'+(settings.masterdata.bresize ? ' resize-s' : "")+'"></div>';
            }
            var html=headline+
                    '<div class="maindata">'+
                        filterform+
                        html_tabulator+
                        formwrapper+
                    '</div>'+
                    footline+
                    '<div class="k8-browser-bottom" style="display: none;"><div class="container"></div></div>';
            
            $(el_md).html(html);
            el_menu=$(el_md).find('.dropdown-menu')[0];
            if(el_menu && settings.masterdata.menuleft_options){
                var menuleftoptions='<li class="dropdown-submenu"><a href="#">Options</a><ul class="dropdown-menu">';
                menuleftoptions+='<li><a class="js_menuleft js_export_csv" href="#">utf-8 CSV Export</a></li>';
                menuleftoptions+='<li><a class="js_menuleft js_export_xlsx" href="#">Excel Export</a></li>';
                menuleftoptions+='<li><a class="js_menuleft js_export_pdf" href="#">PDF Export</a></li>';
                menuleftoptions+='<li><a class="js_menuleft js_datareadlimit" href="#">Set read limt</a></li>';
                if(settings.masterdata.tabcolumns){
                  menuleftoptions+='<li><a class="js_menuleft js_choosecolumns" href="#">Choose columns</a></li>';
                  if(!gbnull(userID)){
                    menuleftoptions+='<li><a class="js_menuleft js_saveconfiguration" href="#">Save configuration</a></li>';
                    menuleftoptions+='<li><a class="js_menuleft js_resetconfiguration" href="#">Reset configuration</a></li>';
                  }
                }
                menuleftoptions+='</ul></li>';
                $(el_menu).append(menuleftoptions);
            }
            
            //message
            if(settings.masterdata.message_position==0){
                $(el_md).find('.footline div').addClass('js_message');
            }
            
            if(settings.masterdata.upload.enabled && !settings.masterdata.upload.singleimage){
               $(el_md).find('.maindata').append('<div class="pic_ph"></div>');
            }
            
            //var el_form=this.getElementsByClassName('jsonform')[0];
            //var table=this.getElementsByClassName('tabulator')[0];
            
            //el_form=el_md.getElementsByClassName('jsonform')[0];
            //el_form=el_md.getElementsByClassName('masterdata-form')[0];
            el_form=el_md.getElementsByClassName('js_dataform')[0];
            
            if(settings.masterdata.jsonformID){
                if(document.getElementById(settings.masterdata.jsonformID)){
                    el_form=document.getElementById(settings.masterdata.jsonformID);
                }else{
                    console.log(settings.materdata.jsonformID+' dont exist!');
                }
            }
            var table=el_md.getElementsByClassName('tabulator')[0];
            var o={};
            var dat={};
            var el_dirty;
            
            // ------------------------------------------ Masterdata -------------------------------------------
            $(el_form).addClass(getfromArray(settings.jsonform_conf,'formclass','form-vertical'))
            //$(el_md).find('.headline').find('h3').eq(0).html(getl(settings.name));
            $(el_md).find('.js_title').html(getl(settings.name));

            // ------------------------------------------ Filterform -------------------------------------------
            var el_filterform=$(el_md).find('.js_filterform')[0];
            if(el_filterform){
                if(settings.masterdata.filterobject.defaultvalues){
                    obj2form(settings.masterdata.filterobject.defaultvalues,el_filterform)  
                }
                //$(el_md).find('.js_replacedata').on('click',function(e){
                $(el_filterform).on('submit',function(e){
                    e.preventDefault();
                    var ff=[]; //[{"field":"year","type":"=","value":year},{"field":"effect","type":"&","value":effect}];
                    //var fields=settings.masterdata.filterfields;
                    var fields=settings.masterdata.filterobject.fields;
                    for(var i=0;i<fields.length;i++){
                        var name=getfromArray(fields[i],'name',getfromArray(fields[i],'fieldname'));
                        if(fields[i].figure==1){
                            var el=el_filterform.elements.namedItem(name);
                            if(el){
                                var value="";
                                if(el.value!=="undefined"){
                                    value=el.value;
                                    if(!gbnull(value)) ff.push({"field":name,"type":fields[i]['operator'],"value":value});
                                }
                            }else{
                                console.log(name+' dont exist!');
                            }
                        }else if(fields[i].figure==2){
                            var el=el_filterform.elements.namedItem(name+'from');
                            if(el){
                                var value="";
                                if(el.value!=="undefined"){
                                    value=el.value;
                                    if(!gbnull(value)) ff.push({"field":name,"type":">=","value":value});
                                }
                            }else{
                                console.log(name+'from dont exist!');
                            }
                            var el=el_filterform.elements.namedItem(name+'to');
                            if(el){
                                var value="";
                                if(el.value!=="undefined"){
                                    value=el.value;
                                    if(!gbnull(value)) ff.push({"field":name,"type":"<=","value":value});
                                }
                            }else{
                                console.log(name+'to dont exist!');
                            }
                        }
                    }
                    /*
                    effect=el_filterform.elements.namedItem('effect').value;
                    year=el_filterform.elements.namedItem('year').value;
                    var ff=[{"field":"year","type":"=","value":year},{"field":"effect","type":"&","value":effect}];
                    */
                    url=path+settings.masterdata.url_readfilter;
                    //var filters=$.extend(settings.masterdata.data_readfilter,{"filters":ff},true);
                    //tableTab.setData(url,filters);
                    settings.masterdata.data_readfilter=$.extend(settings.masterdata.data_readfilter,{"filters":ff},true);
                    tableTab.setData(url,settings.masterdata.data_readfilter);
                });
                if(el_md.getElementsByClassName("js-download-csv").length>0){
                    el_md.getElementsByClassName("js-download-csv")[0].addEventListener("click", function(){
                        tableTab.download("csv", "data.csv",{"delimiter":";","decimal":","});
                    });
                }
                if(el_md.getElementsByClassName("js-download-json").length>0){
                    el_md.getElementsByClassName("js-download-json")[0].addEventListener("click", function(){
                        tableTab.download("json", "data.json");
                    });
                }
                if(el_md.getElementsByClassName("js-download-xlsx").length>0){
                    el_md.getElementsByClassName("js-download-xlsx")[0].addEventListener("click", function(){
                        tableTab.download("xlsx", "data.xlsx", {decimal:",",sheetName:"My Data"});
                    });
                }

                if(el_md.getElementsByClassName("js-download-pdf").length>0){
                    el_md.getElementsByClassName("js-download-pdf")[0].addEventListener("click", function(){
                        tableTab.download("pdf", "data.pdf", {
                            orientation:"portrait", //set page orientation to portrait
                            title:settings.name //add title to report
                        });
                    });
                }
            }
            
            // --------------- selectmode ---------------
            $(el_md).find('.headline .js_selectmode').on('click',function(e){
                var el=e.target;
                bselectable=el.checked;
                if(bselectable){
                    if(row_actual){
                        row_actual.toggleSelect();
                        row_actual=0;
                        $(el_md).find('.row_selected').removeClass('row_selected');
                    }
                }else{
                    var selected=tableTab.getSelectedRows();
                    if(selected.length>0){
                        row_actual=selected[0];
                        var count=selected.length;
                        for(var i=0;i<selected.length;i++){
                            //tableTab.deselectRow(selected[i][settings.key]);
                            tableTab.deselectRow(selected[i].getIndex());
                        }
                        $(row_actual.getElement()).addClass("row_selected");
                        if(count!=1){
                            o=row_actual.getData();
                            if(!bnoform){
                                if(bwithdirty)el_dirty.src=path+'masterdata/pic/icon_saved.png';
                                display_record(o);
                            }else{
                                if(settings.masterdata.dataLoad) {
                                    settings.masterdata.dataLoad(el_md,o,settings);
                                }
                            }
                        }                        
                        
                    }
                }
            });
            
            // --------------- New ---------------
            if(notabulator || settings.masterdata.edittype==0){
                $(el_md).find('.headline .js_rec_new').hide();
            }else{
                if(settings.rightcheck!=0 && !settings.masterdata.rightuser_create){
                    $(el_md).find('.headline .js_rec_new').prop("disabled", true);
                }else{
                    $(el_md).find('.headline .js_rec_new').on('click',function(e){
                        row_actual=0;	// delete tabulator record pointer 
                        $(table).find(".row_selected").removeClass("row_selected");
                        if(bnoform){
                            if(settings.masterdata.url_new){
                                executeControl(0);
                                /*
                                var url=path+settings.masterdata.url_new+'&returnflag=2';
                                row_stack=0;
                                var w=window.open(url,"Edit");
                                if(w){
                                    w.focus();
                                }else{
                                    alert("sorry can not open new window!");
                                }
                                */
                            }else{
                                alert('pleae set url_new');
                            }
                        }else{
                            newRecord(el_md);
                        }
                    });
                }
            }
            
            if(notabulator){
            }else{
                // ------------------------------------------ Tabulator -------------------------------------------
                var bdelclicked=false;
                var keyfield=settings['key'];
                var otable=$.extend(
                    settings.tabulator,
                    {
                        rowClick:function(e, row){ //trigger an alert message when the row is clicked
                            if(bdelclicked){
                                tableTab.deselectRow(row.id);
                            }else{
                                //console.log("Row " + row.getPosition() +' ID='+row.getData().ID + " Clicked");
                                row_actual=row;
                                o=row.getData();
                                //o=JSON.parse(JSON.stringify(row.getData()));
                                //o={"userID":45,"username":"Leif","email":"ee@dd.de","password":"Leif"};
                                $(table).find(".row_selected").removeClass("row_selected");
                                //$(".row_selected").removeClass("row_selected");
                                if(bselectable){
                                }else{
                                    tableTab.deselectRow(row.id);
                                    $(row.getElement()).addClass("row_selected");
                                }
                                if(!bnoform){
                                    if(bwithdirty)el_dirty.src=path+'masterdata/pic/icon_saved.png';
                                    //display_record(row.getData());
                                    display_record(o);
                                }else{
                                    if(settings.masterdata.dataLoad) {
                                        settings.masterdata.dataLoad(el_md,o,settings);
                                    }
                                }
                            }
                            bdelclicked=false;
                            
                            if(settings.masterdata.url_ping){
                                // ping
                                url=path+settings.masterdata.url_ping;
                                $.getJSON(url,function(oJson){
                                    //if(settings.masterdata.fninittimer)settings.masterdata.fninittimer();
                                    if(settings.masterdata.pagetimer)settings.masterdata.pagetimer.reset();
                                })
                                .fail(function(jqxhr, textStatus, error ) {
                                    var err = textStatus + ", " + error;
                                    console.log("Ping Failed: " + err );
                                });			
                            }                            
                        },
                        dataFiltering:function(filters){
                            //console.log('filters');
                            //console.log(filters);
                        },
                        dataFiltered:function(filters,rows){
                            //console.log("dataFiltered");
                            if(1){
                                // selected
                            }
                            //if(settings.masterdata.fninittimer)settings.masterdata.fninittimer();
                            if(settings.masterdata.pagetimer)settings.masterdata.pagetimer.reset();
                            //if(pagetimer)pagetimer.reset();
                            row_actual=0;
                            var selects="";
                            if(tableTab)filter2url(tableTab.getHeaderFilters(),selects);
                            initForm(settings.masterdata.defaultvalues);
                        }
                    }
                );
                
                //-------------------------------- Define Table Columns --------------------------------
                //otable.columns=settings.tabulator.columns;
                
                /* -------- language support ----------- */
                if(blanguages){
                    for (var property in otable.columns) {
                      if (otable.columns.hasOwnProperty(property)) {
                        if(otable.columns[property].hasOwnProperty('title')){
                            //console.log(otable.columns[property]['title']);
                            otable.columns[property]['title']=getl(otable.columns[property]['title']);
                        }
                      }
                    }                
                }
                if(otable.columns){
                  settings.masterdata.tabulator_columnsbackup=JSON.parse(JSON.stringify(otable.columns));
                }
                
                if(settings.masterdata.tabcolumns){
                  if(!_.isEmpty(settings.masterdata.tabcolumns)){
                    for (var i=0;i<otable.columns.length;i++) {
                      if(settings.masterdata.tabcolumns.hasOwnProperty(otable.columns[i]['field'])){
                        otable.columns[i].width=settings.masterdata.tabcolumns[otable.columns[i]['field']]['width'];
                      }else{
                        otable.columns[i]['visible']=false;
                      }
                    }
                    //delete(settings.masterdata.tabcolarr);
                    settings.masterdata.tabcolarr=[];
                    settings.masterdata.tabcolumns
                    for(prop in settings.masterdata.tabcolumns){
                      if(settings.masterdata.tabcolumns.hasOwnProperty(prop)){
                        settings.masterdata.tabcolarr.push(prop);
                      }
                    }
                    otable.columns=arraySortByArray(otable.columns,"field",settings.masterdata.tabcolarr)
                  }                    
                }else if(settings.masterdata.tabcolarr){
                    /* -------- tabcolarr ----------- */
                    for (var i=0;i<otable.columns.length;i++) {
                      if (settings.masterdata.tabcolarr.indexOf(otable.columns[i]['field'])<0){
                          delete otable.columns[i];
                      }
                    }
                    otable.columns=arraySortByArray(otable.columns,"field",settings.masterdata.tabcolarr)                    
                }

                tabulatorAddControls();
                
                tableTab = new Tabulator(table, otable);
                //tableTab.setHeaderFilterFocus("text1");

                //-------------------------------- tabledata
                var filters=[];
                if(settings.masterdata.filters){
                    filters=settings.masterdata.filters;
                }
                if(settings.tabulator.initialHeaderFilter){
                    filters=filters.concat(settings.tabulator.initialHeaderFilter);
                }
                //if(filters.length>0){
                    filters=$.extend(settings.masterdata.data_readfilter,{"filters":filters},true);
                    settings.masterdata.data_readfilter=$.extend(settings.masterdata.data_readfilter,{"filters":filters},true);
                //}
                
                //tableTab.setData(url,settings.masterdata.data_readfilter);
                url=path+settings.masterdata.url_readfilter;
                //tableTab.setData(url,filters);
                tableTab.setData(url,settings.masterdata.data_readfilter);
                //$(this).find('.resize-s').resizable({handles:"s"});
            }

            function tabulatorAddControls(){
              if(settings.masterdata.edittype>0){
                  //custom formatter definition

                  /*var titleIcon = function(cell, formatterParams, onRendered){
                      return settings.masterdata.menulefthtml;
                  }*/

                  // ----------------- delete ----------------
                  var printIcon = function(cell, formatterParams, onRendered){ //plain text value
                      var rightuser_delete=true;
                      var rightuser_update=false;
                      if(settings.rightcheck!=0){
                          rightuser_update=Number(getfromArray(cell.getData(),'rightuser_update',false));
                          rightuser_delete=Number(getfromArray(cell.getData(),'rightuser_delete',false));
                      }
                      var html="";
                      if(rightuser_delete)html+='<img src="'+getfromArray(settings.masterdata,'root')+'masterdata/pic/icon_delete.png" alt="'+getl('Delete')+'" title="'+getl('Delete')+'">  ';
                      if(settings.rightcheck!=0){
                          if(rightuser_update){
                              //html+='<img src="'+getfromArray(settings.masterdata,'root')+'masterdata/pic/icon_edit.png" alt="edit" title="edit">';
                          }else{
                              html+='<img src="'+getfromArray(settings.masterdata,'root')+'masterdata/pic/icon_no_edit.png" alt="'+getl('Edit')+'" title="'+getl('no edit')+'">';
                          }
                      }
                      return html;
                  };

                  if(otable.columns){
                    //otable.columns.unshift({"headerSort":false,"titleFormatter":titleIcon, "formatter":printIcon, "width":50, "align":"center", 
                    otable.columns.unshift({"headerSort":false,"download":false,"formatter":printIcon, "width":50, "align":"center", 
                        "cellClick":function(e, cell){
                            //console.log('event.delete');
                            if((settings.rightcheck!=0 && Number(getfromArray(cell.getData(),'rightuser_delete',false))) || settings.rightcheck==0){
                                if(confirm(getl('Delete')+'?')){
                                    bdelclicked=true;
                                    o={};
                                    o[keyfield]=cell.getData()[keyfield];
                                    url=path+settings.masterdata.url_del;
                                    $.getJSON(url,o, function(oJson) {
                                        //if(settings.masterdata.fninittimer)settings.masterdata.fninittimer();
                                        if(settings.masterdata.pagetimer)settings.masterdata.pagetimer.reset();

                                        if(oJson.bok){
                                            cell.getRow().delete();
                                            row_actual=0;
                                            //initForm(settings.masterdata.defaultvalues);
                                            if(!bnoform)newRecord(el_md,el_form);
                                        }else{
                                            alert(oJson.error);
                                        }
                                    })
                                    .fail(function(jqxhr, textStatus, error ) {
                                        var err = textStatus + ", " + error;
                                        //console.log( "Request Failed: " + err );
                                    });			
                                }
                            }
                        }
                    });
                  }
                  if(bnoform){
                      // ----------------- edit ----------------
                      var editIcon = function(cell, formatterParams, onRendered){ //plain text value
                          var rightuser_update=false;
                          if(settings.rightcheck!==0){
                              rightuser_update=Number(getfromArray(cell.getData(),'rightuser_update',false));
                          }
                          var html="";
                          if(settings.rightcheck!=0){
                              if(rightuser_update){
                                  html+='<img src="'+getfromArray(settings.masterdata,'root')+'masterdata/pic/icon_edit.png" alt="edit" title="edit">';
                              }
                          }
                          return html;
                      };
                      otable.columns.push({"headerSort":false,"formatter":editIcon, "width":25, "align":"center", 
                          "cellClick":function(e, cell){
                              if((settings.rightcheck!=0 && getfromArray(cell.getData(),'rightuser_update',false)) || settings.rightcheck==0){
                                  bdelclicked=true;
                                  row_actual=cell.getRow();
                                  //var url=settings.masterdata.url_edit+'&keyvalue='+cell.getData()[settings.key];
                                  if(settings.masterdata.url_edit){
                                      executeControl(cell.getData()[settings.key]);
                                      /* var url=path+settings.masterdata.url_edit+'&keyvalue='+cell.getData()[settings.key]+'&returnflag=2';
                                      row_stack=cell.getRow();
                                      var w=window.open(url,"Edit");
                                      w.focus();*/
                                  }else{
                                      alert('please set url_edit!');
                                  }
                              }
                          }
                      });
                  }
              }
            }
              
            if(menulefthtml || settings.masterdata.dataMenuleft){
                $(el_md).on("click",".js_menuleft",function(e){
                    var el=e.target;
                    var bselectable=false;
                    var el_multi=$(el_md).find('.js_selectmode')[0];
                    if(el_multi)bselectable=el_multi.checked;
                    
                    var selected;
                    // sorry, will be changed in future
                    if(isset(masterdata,'tableTab')){
                        selected=masterdata.tableTab.getSelectedRows();
                        if(row_actual && !bselectable)selected.push(row_actual);

                        if(el.classList.contains('js_transform') || el.classList.contains('js_docdelsig') || el.classList.contains('js_copy')){
                            if(selected.length==1){
                                if(el.classList.contains('js_transform')){

                                    //var dat=row_actual.getData();
                                    var dat=JSON.parse(JSON.stringify(selected[0].getData()));

                                    if(gbnull(dat['processID'])){
                                        dat['processID']=dat['docID'];
                                    }

                                    dat['docID']=0;
                                    dat['docnumber']='';
                                    dat['doctypeID']=0;
                                    dat['docdate']=new Date().asString();
                                    dat['deliverydate']=dat['docdate']
                                    dat['editorID']=userID;
                                    dat['signaturename']='';
                                    dat['signaturedate']='';
                                    dat['signaturesvg']='';
                                    dat['rightuser_update']=1;

                                    for(var i=0;i<dat['items'].length;i++){
                                        dat['items'][i]['docID']=0;
                                        dat['items'][i]['itemID']=0;
                                        // processitemID is already set
                                    }

                                    $(".row_selected").removeClass("row_selected");
                                    if(bnoform){
                                        k8datparent=dat;
                                        var url=path+settings.masterdata.url_edit+'&returnflag=2&returnopener=1&k8datparent=1&keyvalue='+keyvalue;
                                        var w=window.open(url,"Edit");
                                        w.focus();
                                    }else{
                                        display_record(dat);
                                        alert('please make your changes,\r attention to position prices and tax,\r and save it!');
                                        el_form.elements.namedItem('doctypeID').focus();
                                    }
                                    row_actual=0;
                                }else if(el.classList.contains('js_copy')){
                                    var dat=JSON.parse(JSON.stringify(selected[0].getData()));
                                    dat['processID']=0;
                                    dat['docID']=0;
                                    dat['docnumber']='';
                                    //dat['doctypeID']=0;
                                    dat['docdate']=new Date().asString();
                                    dat['deliverydate']=dat['docdate']
                                    dat['editorID']=userID;
                                    dat['signaturename']='';
                                    dat['signaturedate']='';
                                    dat['signaturesvg']='';
                                    dat['rightuser_update']=1;

                                    for(var i=0;i<dat['items'].length;i++){
                                        dat['items'][i]['docID']=0;
                                        dat['items'][i]['processitemID']=0;
                                        dat['items'][i]['itemID']=0;
                                        dat['items'][i]['servicetimes']=[];
                                    }

                                    $(".row_selected").removeClass("row_selected");
                                    if(bnoform){
                                        k8datparent=dat;
                                        var url=path+settings.masterdata.url_edit+'&returnflag=2&returnopener=1&k8datparent=1&keyvalue='+keyvalue;
                                        var w=window.open(url,"Edit");
                                        w.focus();
                                    }else{
                                        display_record(dat);
                                        alert('please choose document type,\rmake your changes and save it!');
                                        el_form.elements.namedItem('doctypeID').focus();
                                    }
                                    row_actual=0;
                                }else if(el.classList.contains('js_docdelsig')){
                                    var keyvalue=selected[0].getData()[settings.key];
                                    url="service/ServiceMethod.php?process_action=docdelsig&keyvalue="+keyvalue;
                                    $.getJSON(url, function(oJson) {
                                        //if(settings.masterdata.fninittimer)settings.masterdata.fninittimer();
                                        if(settings.masterdata.pagetimer)settings.masterdata.pagetimer.reset();
                                        if(oJson.bok){
                                            var dat=oJson.dat;
                                            row_actual.update(dat);
                                            row_actual.reformat();
                                            display_record(dat);
                                        }else{
                                            alert("no signature deleted: " + oJson.error);
                                        }
                                    })
                                    .fail(function(jqxhr, textStatus, error ) {
                                        var err = url+", Request Failed, "+ textStatus + ", " + error;
                                        console.log(err);
                                    });			
                                }else{
                                    alert("please select 1 row!");
                                }
                            }
                        }
                    }
                    selected=tableTab.getSelectedRows();
                    if(row_actual && !bselectable)selected.push(row_actual);
                    if(el.classList.contains('js_export_csv')){
                        //console.log("csv");
                        tableTab.download("csv", "data.csv",{"delimiter":";"});
                    }else if(el.classList.contains('js_export_xlsx')){
                        tableTab.download("xlsx", "data.xlsx", {decimal:",",sheetName:"My Data"});
                    }else if(el.classList.contains('js_export_pdf')){
                        tableTab.download("pdf", "data.pdf", {
                            orientation:"landscape", //set page orientation to portrait
                            title:settings.name //add title to report
                        });
                    }else if(el.classList.contains('js_datareadlimit')){
                        var datareadlimit=getfromArray(settings.masterdata,'datareadlimit',50);
                        datareadlimit = prompt("Please enter record read limit (0 for all)", datareadlimit);
                        if(datareadlimit==null){
                          //nothing
                        }else{
                          settings.masterdata.datareadlimit=datareadlimit;
                          settings.masterdata.data_readfilter.mytable_offset=0;
                          settings.masterdata.data_readfilter.mytable_limit=datareadlimit;
                          tableTab.setData(url,settings.masterdata.data_readfilter);
                        }
                    }else if(el.classList.contains('js_choosecolumns')){
                      $(el_md).find('.js_columnlist').toggle();
                    }else if(el.classList.contains('js_resetconfiguration')){
                      delete(settings.masterdata.tabcolumns);
                      otable.columns=JSON.parse(JSON.stringify(settings.masterdata.tabulator_columnsbackup));
                      tabulatorAddControls();
                      tableTab.setColumns(otable.columns);
                      if(isset(dat_user)){
                        if(gbnull(dat_user.settings))dat_user.settings={};
                        if(!isset(dat_user,'settings','datadefinitions'))dat_user['settings']['datadefinitions']={};
                        if(!isset(dat_user,'settings','datadefinitions',datadefID))dat_user['settings']['datadefinitions'][datadefID]={};
                        if(!isset(dat_user,'settings','datadefinitions',datadefID,"masterdata"))dat_user['settings']['datadefinitions'][datadefID]['masterdata']={};
                        dat_user.settings.datadefinitions[datadefID]['masterdata']['tabcolumns']={};
                        var record={"userID":userID,"settings":JSON.stringify(dat_user.settings)};
                        $.ajax(
                          {url:path+"masterdata/ProcessData.php?datadefID=5&process_action=Save&update_session=1",
                          data:record,
                          type:"POST",
                          success:function(ret){
                            console.log(ret);
                          }
                        })
                        .fail(function(jqxhr, textStatus, error ) {
                            var err = textStatus + ", " + error;
                            console.log( "Request Failed: " + err );
                        });			
                      }

                    }else if(el.classList.contains('js_saveconfiguration')){
                      //settings.masterdata.tabcolumns
                      delete(settings.masterdata.tabcolumns);
                      settings.masterdata.tabcolumns={};
                      for(var i=0;i<tableTab.getColumns().length;i++){
                        if(tableTab.getColumns()[i].isVisible() && tableTab.getColumns()[i].getDefinition().field){
                          var field=tableTab.getColumns()[i].getDefinition().field;
                          settings.masterdata.tabcolumns[field]={};
                          if(tableTab.getColumns()[i].getDefinition().width){
                            settings.masterdata.tabcolumns[field]["width"]=tableTab.getColumns()[i].getWidth();
                          }
                        }
                      }
                      if(!gbnull(userID) && !gbnull(datadefID)){
                        if(isset(dat_user)){
                          if(gbnull(dat_user.settings))dat_user.settings={};
                          if(!isset(dat_user,'settings','datadefinitions'))dat_user['settings']['datadefinitions']={};
                          if(!isset(dat_user,'settings','datadefinitions',datadefID))dat_user['settings']['datadefinitions'][datadefID]={};
                          if(!isset(dat_user,'settings','datadefinitions',datadefID,"masterdata"))dat_user['settings']['datadefinitions'][datadefID]['masterdata']={};
                          dat_user.settings.datadefinitions[datadefID]['masterdata']['tabcolumns']=settings.masterdata.tabcolumns;
                          var record={"userID":userID,"settings":JSON.stringify(dat_user.settings)};
                          $.ajax(
                            {url:path+getfromArray(settings.masterdata,"url_saveuser","masterdata/ProcessData.php?datadefID=5&process_action=Save"),
                            data:record,
                            type:"POST",
                            success:function(ret){
                              //console.log(ret);
                            }
                          })
                          .fail(function(jqxhr, textStatus, error ) {
                              var err = textStatus + ", " + error;
                              console.log( "Request Failed: " + err );
                          });			
                        }
                      }else{
                        if(!gbnull(datadefID))console.log("js_saveconfiguration, datadefID not set");
                      }
                    }else{
                        settings.masterdata.dataMenuleft(el_md,e,row_actual,this);
                    }
                });
            }

            /* -----------------------------------------------   Form   ------------------------------------------- */
            if(!bnoform){
                if(settings.masterdata.formmode==2){
                    /* ------------------------------------------- jsonForm ------------------------------------------- */

                    var oform={};
                    oform.schema=settings.jsonform.schema;

                    /* ----------------------------------------------- language support ------------------------------------------- */
                    if(blanguages){
                        for (var property in oform.schema) {
                          if (oform.schema.hasOwnProperty(property)) {
                            if(oform.schema[property].hasOwnProperty('title')){
                                oform.schema[property]['title']=getl(oform.schema[property]['title']);
                            }
                          }
                        }                
                    }

                    if(settings.jsonform.form){
                        oform['form']=settings.jsonform.form;
                    }else{
                        oform['form']=['*'];
                    }
                    if(settings.masterdata.message_position==2){
                        oform['form'].push(
                            {
                                "type":"section",
                                "htmlClass":"row",
                                "items":[
                                    {
                                        "type":"section",
                                        "htmlClass":"col-sm-12 k8-margin-bottom-normal",
                                        "items":[
                                            {
                                                "type":"section",
                                                "htmlClass":"js_message"
                                            }
                                        ]
                                    }
                                ]
                            }
                        )
                    }
                    var button_middle={
                            "type":"section",
                            "htmlClass":"col-xs-5 js_middle"
                        };
                    if(settings.masterdata.message_position==1){
                        button_middle={
                                "type":"section",
                                "htmlClass":"col-xs-5 js_middle",
                                "items":[
                                    {
                                        "type":"section",
                                        "htmlClass":"js_message"
                                    }
                                ]
                            };                    
                    }
                    oform['form'].push(
                        {
                            "type":"section",
                            "htmlClass":"row",
                            "items":[
                                {
                                    "type":"section",
                                    "htmlClass":"col-xs-1 js_dirty"
                                },
                                button_middle,
                                {
                                    "type":"section",
                                    "htmlClass":"col-xs-6",
                                    "items":[
                                        {
                                            "type": "actions",
                                            "htmlClass": "text-right",
                                            "items": [
                                                {
                                                    "type": "submit",
                                                    "name": "submit",
                                                    "title": getl("Save"),
                                                    "onClick": function (evt) {
                                                      console.log("submit onclick");
                                                      evt.preventDefault();
                                                     }
                                                },
                                                {
                                                    "type": "button",
                                                    "title": getl("Cancel"),
                                                    "htmlClass": "js_cancel",
                                                    "onClick": function (e) {
                                                        //console.log("cancel");
                                                        //cancel();
                                                    }                                  
                                                }
                                            ]
                                        }
                                    ]
                                }
                            ]
                        }                            
                    );
                    oform=$.extend(
                        oform,
                        {
                        onSubmit: function (errors, values) {
                            if(errors) {
                                message('errors occured!','alert');
                                return false;
                            }
                            $(el_form).find('input[type="submit"],button[type="submit"]').attr("disabled",true);
                            var binit=settings.masterdata.init_after_save;
                            if(settings.masterdata.auto_save)binit=false;
                            saveRecord(binit);
                            //saveRecord();
                        }
                    });
                    //oform.onSubmit=settings.jsonform.onSubmit;

                    $(el_form).jsonForm(oform);
                    $(el_form).find('.error').removeClass('error');

                    //el_form=this.getElementsByClassName('jsonform')[0];
                    if(settings.jsonform_conf){ //settings
                        //var labelHtmlClass=getfromArray(settings.jsonform_conf,"labelHtmlClass",'control-label col-sm-3');
                        //var fieldWrapClass=getfromArray(settings.jsonform_conf,"fieldWrapClass",'col-sm-9');
                        if(!gbnull(getfromArray(settings.jsonform_conf,'labelHtmlClass'))) $(el_form).find('.form-group:not(.noautocolumn)>label').addClass(settings.jsonform_conf.labelHtmlClass);
                        if(!gbnull(getfromArray(settings.jsonform_conf,'fieldWrapClass'))) $(el_form).find('.form-group:not(.noautocolumn) .controls').addClass(settings.jsonform_conf.fieldWrapClass);
                    }
                }else if(settings.masterdata.formmode==3){
                    var k8form=Object.create(k8);
                    /*
                    if(settings.html){
                      for(var i=0;i){
                        settings.k8form.html=settings.html;
                      }
                      settings.k8form.html={};
                      settings.k8form.html['items_container']=settings.html.items.container;
                    }
                    */
                    k8form.createform(settings.k8form);
                }else if(isset(settings,"html","masterdata","main") ){
                    $(el_form).append(settings.html.masterdata.main);
                    /*
                    $(el_form).submit(function(e){
                        e.preventDefault();
                        $(el_form).find('input[type="submit"],button[type="submit"]').attr("disabled",true);
                        var binit=settings.masterdata.init_after_save;
                        if(settings.masterdata.auto_save)binit=false;
                        saveRecord(binit);
                        //saveRecord();
                    });
                    */
                }else{
                    console.log("formmode not correctly");
                }

                if(settings.masterdata.formmode==1 || settings.masterdata.formmode==3){
                  el_form.addEventListener('submit', (e) => {
                    e.preventDefault();
                    $(el_form).find('input[type="submit"],button[type="submit"]').attr("disabled",true);
                    var binit=settings.masterdata.init_after_save;
                    if(settings.masterdata.auto_save)binit=false;
                    saveRecord(binit);
                  });                
                }
                
                if(bwithdirty){
                    var el=$(el_form).find('.js_dirty')[0];
                    if(el){
                        var el_dirty = document.createElement("IMG");
                        el_dirty.src=path+'masterdata/pic/icon_saved.png';
                        el.append(el_dirty);
                    }else{
                        bwithdirty=false;
                    }
                }

                // ------------  repair
                $(el_form).find('button[type=button]').on('click',function(e){
                    e.preventDefault();
                    if($(e.target).hasClass('js_cancel')){
                        console.log("repair cancel");
                        cancel();
                    }
                });
                $(el_form).find('button[type=submit]').on('click',function(e){
                    console.log("type=submit");
                    e.preventDefault();
                });
                
                /* this is NOT ALLOWED!!!
                if(blanguages)el_form.innerHTML=ReplacePlaceholder(el_form.innerHTML);
                */
                
                // disabled
                $(el_form).find('select:disabled,input:disabled').attr("aria-disabled",true);

                if(!settings.masterdata.notabulator && settings.masterdata.tabcolumns){
                  document.getElementById('js_close_columnlist').addEventListener('click', function(e) {
                    $(el_md).find('.js_columnlist').toggle();
                  });

                  const myForm = document.getElementById('columnlist_form');
                  if(myForm){
                      myForm.addEventListener('change', function(e) {
                          e.preventDefault();
                          if(e.target.tag='input'){
                              console.log('checkbox clicked');  // Expected Value: 'Data'
                              if(e.target.checked){
                                  tableTab.showColumn(e.target.name);
                              }else{
                                  tableTab.hideColumn(e.target.name);
                              }
                              tableTab.redraw(true);
                          }
                      });
                  }    
                  listcolumns();
                }

                function listcolumns(){
                    $(columnlist_form).empty();
                    var htmlcheckbox='<div class="checkbox">'+
                                        '<label class=""><input type="checkbox" name="{{field}}">{{label}}</label>'+
                                    '</div>';

                    var tablecolumns=tableTab.getColumns();
                    for(var i=0;i<tablecolumns.length;i++){
                      if(tablecolumns[i].getDefinition().field){
                        var node=document.createElement("div");
                        var temp=htmlcheckbox.replace('{{label}}',tablecolumns[i].getDefinition().title).replace('{{field}}',tablecolumns[i].getDefinition().field);
                        var el_div=$(temp).appendTo(columnlist_form);
                        var el_check=$(el_div).find("input")[0];
                        if(tablecolumns[i].getVisibility()){
                            el_check.checked=true;
                        }
                      }
                    }
                }

                $(el_form).on("click",".js_rec_new",function(){
                    if(!$(this).hasClass('js_disabled')){
                        if(getfromArray(settings.masterdata,'auto_save',0)){
                            saveRecord(false);
                        }
                        var el_rec_container;
                        var container_position=typeof this.dataset.container_position=="undefined" ? 0 : this.dataset.container_position;
                        var rec_object=typeof this.dataset.rec_object=="undefined" ? "" : this.dataset.rec_object;
                        
                        if(container_position==0){
                            el_rec_container=$(this).parents('.js_rec_container')[0];
                        }else{
                            if(container_position<0){
                                el_rec_container=$(this).prev('.js_rec_container[data-rec_object="'+rec_object+'"]')[0];
                            }else{
                                el_rec_container=$(this).next('.js_rec_container[data-rec_object="'+rec_object+'"]')[0];
                            }
                        }
                        if(el_rec_container){
                            addhtmlrecord(el_rec_container);
                        }else{
                            console.log(rec_object+' container not found!');
                        }
                    }
                });
                $(el_form).on("click",".js_rec_before",function(){
                    if(!$(this).hasClass('js_disabled')){
                        if(getfromArray(settings.masterdata,'auto_save',0)){
                            saveRecord(false);
                        }
                        var el_rec_container;
                        var container_position=typeof this.dataset.container_position=="undefined" ? 0 : this.dataset.container_position;
                        var rec_object=typeof this.dataset.rec_object=="undefined" ? "" : this.dataset.rec_object;
                        
                        if(container_position==0){
                            el_rec_container=$(this).parents('.js_rec_container')[0];
                        }else{
                            if(container_position<0){
                                el_rec_container=$(this).prev('.js_rec_container[data-rec_object="'+rec_object+'"]')[0];
                            }else{
                                el_rec_container=$(this).next('.js_rec_container[data-rec_object="'+rec_object+'"]')[0];
                            }
                        }
                        if(el_rec_container){
                            el_rec_record=$(this).parents('.js_rec_record')[0];
                            var before_rec_index=el_rec_record.dataset.rec_index;
                            addhtmlrecord(el_rec_container,before_rec_index);
                        }else{
                            console.log(rec_object+' container not found!');
                        }
                    }
                });
                
                $(el_form).on("click",".js_rec_delete",function(e){
                    if(!$(this).hasClass('js_disabled')){
                        if(confirm(getl('Delete')+'?')){
                            var el_rec_container=$(this).parents('.js_rec_container')[0];
                            $(this).parents('.js_rec_record')[0].remove();
                            if(settings.masterdata.ondelete){
                                settings.masterdata.ondelete(el_md,el_rec_container);
                            }
                        }
                    }
                });

                $(el_form).on("change","input,textarea,select",function(){
                    var name=getSubName('name',this.name);
                    var namestr=getSubName('namestr',this.name);
                    gFormatinputfordisplay(this,this.value);
                    if(bwithdirty)el_dirty.src=path+"masterdata/pic/icon_dirty.png";
                    if(settings.masterdata.dataChange) {
                        settings.masterdata.dataChange(el_md,this);
                    }
                });
            }
            
            if(settings.masterdata.dataCreateStructure) {
                settings.masterdata.dataCreateStructure(el_md,o,settings);
            }

            if(!bnoform){
                if(settings.masterdata.notabulator){
                    // load or init
                    if(settings.data && settings.data.length>0){
                        o=settings.data[0];
                        display_record(o);
                    }else if(getfromArray(Array_GET(),'k8datparent',0) && window.opener){
                        o=window.opener.k8datparent;
                        display_record(o);
                    }else{
                        var keyvalue=getfromArray(settings.masterdata,'keyvalue',0);
                        if(gbnull(keyvalue)){
                            newRecord(el_md,el_form);
                        }else{
                            o={};
                            var url=path+settings.masterdata.url_load;
                            o.keyvalue=keyvalue;
                            $.getJSON(url,o, function(oJson) {
                                //if(settings.masterdata.fninittimer)settings.masterdata.fninittimer();
                                if(settings.masterdata.pagetimer)settings.masterdata.pagetimer.reset();
                                if(oJson.bok){
                                    o=oJson.dat;
                                    display_record(o);
                                }else{
                                    console.log('record.'+settings.key+'='+keyvalue+', load.error='+oJson.error);
                                }
                            })
                            .fail(function(jqxhr, textStatus, error ) {
                                var err = url+", Request Failed, "+ textStatus + ", " + error;
                                console.log(err);
                            });			
                        }
                    }                
                }
            }

            if(settings.masterdata.bresize){
                $(el_md).find('.resize-s').resizable({handles:"s",distance:10});
            }
            
            if(!settings.masterdata.notabulator && !settings.masterdata.bnoform){
                //initForm(settings.masterdata.defaultvalues);
                newRecord(el_md,el_form);
            }
        }
         
        /* ----------- functions -----------  */
        function newRecord(el_md,el_form){
            //settings
            var dat=settings.masterdata.defaultvalues;
            if(settings.masterdata.dataNewbefore) {
                var obj={};
                obj.dat=dat
                settings.masterdata.dataNewbefore(obj);
            }
            initForm(dat);
            if(settings.masterdata.dataNew) {
                settings.masterdata.dataNew(el_md,dat);
            }
            $(el_form).find('input:not([type=hidden])').eq(0).focus();
        }
        
        function executeControl(keyvalue){
            settings.masterdata.window_mode=settings.masterdata.edittype;
            switch(settings.masterdata.edittype){
                case 0: // nothing
                    break;
                //case 1: // execute ajax and reload
                case 2: // opverlay
                case 3: // innerhtml 
                    var new_settings=JSON.parse(JSON.stringify(settings));
                    new_settings.masterdata.notabulator=true;
                    new_settings.masterdata.bnoform=false;
                    createOverlay(el_md,new_settings,keyvalue);
                    break;
                case 4: // new tab
                    if(settings.masterdata.url_edit){
                        console.log(row_actual);
                        //console.log(masterdata.getRow());
                        var url=path+settings.masterdata.url_edit+'&returnflag=2&returnopener=1&keyvalue='+keyvalue;
                        // set index for return
                        var w=window.open(url,"Edit");
                        w.focus();
                        //window.location.assign(url);
                    }else{
                        alert('please set url_edit!');
                    }
                    break;
                case 5: // new window
                    if(settings.masterdata.url_edit){
                        var url=path+settings.masterdata.url_edit+'&returnflag=2&returnopener=1&keyvalue='+keyvalue;
                        var parameter="width="+window.innerWidth.toString()+",height="+window.innerHeight.toString()+",resizable=yes,scrollbars=yes";
                        parameter="top="+(window.screenY).toString()+",left="+(window.screenX).toString()+","+parameter;
                        var w = window.open(url,'Edit', parameter);
                        w.focus();
                    }
                    break;
                //case 6: // own line, same template
                //case 7: // own line, plugin
                case 8: // like jsonform
                    break;
                case 9: // link in this window
                    url=path+settings.masterdata.url_edit+'&keyvalue='+keyvalue+'&returnflag=2';
                    window.location.href=url;
                    break;
                default:
                    console.log('edittype='+settings.masterdata.edittype+' not supported!');
            }
        }

        function createOverlay(el_list,settings,keyvalue){
            // window_mode 2:overlay, 3:innerHTML, 7 not supported
            //keyvalue==0 ->New
            var selector='';
            var selmain='*';
            if(settings.masterdata.window_mode==2){
                //overlay
                var width=Math.round(window.innerWidth*0.9);
                if(width>1170)width=1170;
                var html='<div id="k8-overlay">' +
                            '<div style="width: '+width+'px">' +
                                '<div style="text-align: right; padding-right: 6px"><a style="cursor:pointer;" id="btnOverlay">&times;</a></div>'+
                                '<div style="padding: 0 20px 20px 20px" id="overlay_content">'+
                                    '<div class="masterdata">' +
                                '</div>'+
                            '</div>'+
                        '</div>';
                $(el_list).append(html);
                var el_md=document.getElementById('k8-overlay');
                $(el_md).find('#btnOverlay').on('click',function(e){
                    e.preventDefault();
                    $("#k8-overlay").remove();
                });
                selector='.masterdata';
                selmain=el_md;
            }else if(settings.masterdata.window_mode==3){
                //innerhtml
                //template in line
                selector=settings.masterdata.edit_selector;
            }else{
                console.log(settings.masterdata.window_mode+' not valid!');
                return
            }
            // element, data, keyvalue, filters, clause
            var element='masterdata'; //!!!
            switch(element){
                case 'masterdata':
                    settings.masterdata.notabulator=true;
                    settings.return={'origin':'tabulator'};
                    if(gbnull(keyvalue)){
                        // insertRecord when New
                        settings.return.tableTab=tableTab;
                    }else{
                        settings.masterdata.keyvalue=keyvalue;
                        settings.return.row=row_actual;
                    }
                    $(selmain).find(selector).masterdata(settings);
                    break;
                case 'catalog':
                    //htmlout
                    $(el_md).find(selector).catalog(settings);
                    break;
                default:
                    console.log('element='+element+' not valid!');
            }
        }

        function cancel(){
            if(settings.masterdata.btnCancel){
                settings.masterdata.btnCancel(el_md,{},settings.return);
                return;
            }
            if(settings.masterdata.dataCancel){
                settings.masterdata.dataCancel(el_md,{});
            }

            if(returnflag){
                if(returnopener==1 && window.opener){ // window_mode 4 / 5
                    //close edit tab and 
                    window.close();
                    window.opener.focus();
                }else{            // window_mode 1
                    window.history.back();
                }
            }
            switch(settings.masterdata.window_mode){
            case 0:
                /*
                row_actual=0;	// delete tabulator record pointer 
                $(table).find(".row_selected").removeClass("row_selected");
                initForm(settings.masterdata.defaultvalues);
                */
                if(row_actual){
                    // new rowclick
                    var dat=row_actual.getData();
                    if(!bnoform){
                        if(bwithdirty)el_dirty.src=path+'masterdata/pic/icon_saved.png';
                        //display_record(row.getData());
                        display_record(dat);
                    }else if(settings.masterdata.dataLoad) {
                        settings.masterdata.dataLoad(el_md,dat,settings);
                    }
                }else{
                    //initForm(settings.masterdata.defaultvalues);
                    newRecord(el_md,el_form);
                }
            case 2: // overlay
                $('#k8-overlay').remove();
                break;
            case 3: // innerhtml
                if(settings.return.inittemplate){
                    $(settings.masterdata.edit_selector).html(settings.return.inittemplate);
                }else{
                    $(settings.masterdata.edit_selector).empty();
                }
                break;
            case 7: // in line
            case 8: // like masterdata json
                if(settings.return.replaceRecord) {
                    settings.return.replaceRecord(o,settings.return.selector);
                }
                // delete line by new
                break;
            case 9: // history back
                window.history.back();
            }
        }

        function saveRecord(binit){
            binit=typeof binit!=='undefined' ? binit:true; 
            binit=false
            o={};

            if(settings.masterdata.dataPrepareSave) {
                settings.masterdata.dataPrepareSave(el_md);
            }

            if(true){
            //if(getfromArray(settings.masterdata,'object_mode',0)==1){
                //o=DeleteEmptyStructure($(el_form).serializeJSON());
                var $disabledFields = $(el_form).find('[disabled]');
                $disabledFields.prop('disabled', false);
                o=$(el_form).serializeJSON({checkboxUncheckedValue: "0"});
                $disabledFields.prop('disabled', true);
                DeleteEmptyStructure(o);
            }else{
                /*
                for(var prop in oform.schema){
                    //o[prop]=el_form.getElementsByName(prop)[0].value;
                    if(el_form.elements.namedItem(prop)){
                        o[prop]=el_form.elements.namedItem(prop).value;
                    }
                }
                */
            }
            
            if(settings.masterdata.btnSave){
                settings.masterdata.btnSave(el_md,o,settings.return);
                return;
            }
            
            var bnew=gbnull(getfromArray(o,settings.key));
            var cancel=false;
            if(settings.masterdata.dataBeforeSave) {
              cancel=settings.masterdata.dataBeforeSave(el_md,o);
            }
            if(!cancel){
                //$.getJSON(settings.masterdata.url_save,o, function(oJson) {
                $.ajax({url:path+settings.masterdata.url_save,
                  data:o,
                  type:"POST",
                  success:function(ret){
                    //if(settings.masterdata.fninittimer)settings.masterdata.fninittimer();
                    if(settings.masterdata.pagetimer)settings.masterdata.pagetimer.reset();
                    
                    var oJson = JSON.parse(ret);
                    if(oJson.bok){
                        var changed2edit=gbnull(el_form.elements.namedItem(settings.key).value);
                        changed2edit=false;
                        if(!notabulator && binit){
                            //initForm(settings.masterdata.defaultvalues);
                            newRecord(el_md,el_form);
                        }else{
                            el_form.elements.namedItem(settings.key).value=oJson.bok;
                        }
                        message("Saved","saved");
                        if(bwithdirty)el_dirty.src=path+"masterdata/pic/icon_saved.png";

                        if(settings.masterdata.dataAfterSave) {
                            settings.masterdata.dataAfterSave(el_md,o,bnew);
                        }

                        if(!notabulator || returnflag || settings.return){
                            // load object because of rights new and add new record to tabulator
                            //o[keyfield]=oJson.bok;
                            //$.getJSON(path+settings.masterdata.url_load,{'keyvalue':o[keyfield]}, function(oJson) {
                                //if(oJson.bok){
                                    o=oJson.dat;
                                    if(changed2edit){
                                        if(settings.masterdata.upload.enabled && !bnoform){
                                            ProcessImage(o[settings.key],o['rightuser_update'],o);
                                        }
                                    }else{
                                        if(returnflag){
                                            if(returnopener==1 && window.opener){
                                                //close edit tab and 
                                                window.close();
                                                window.opener.focus();
                                                window.opener.InsertRecord(o,returnflag)
                                            }else{
                                                sessionStorage.setItem('keyvalue',o[keyfield]);
                                                window.history.back();
                                            }
                                        }
                                        switch(settings.masterdata.window_mode){
                                        case 0:
                                            if(typeof(row_actual)==='object'){
                                                if(!notabulator){
                                                    row_actual.update(o);
                                                    row_actual.reformat();
                                                    display_record(o);
                                                }
                                            }else{
                                                if(!notabulator){
                                                    tableTab.addRow(o, true)
                                                    .then(function(row){
                                                        row_actual=row;
                                                        display_record(o);
                                                        $(table).find(".row_selected").removeClass("row_selected");
                                                        $(row.getElement()).addClass("row_selected");
                                                    });
                                                }
                                            }
                                            break;
                                        /*case 1: // direct Link
                                            //keyvalue in window.name speichern, history aufrufen
                                            //storage.set("keyvalue",o[keyfield]);
                                            window.history.back();
                                            break;*/
                                        case 2:
                                            // overlay
                                            $('#k8-overlay').remove();
                                            if(getfromArray(settings.return,'origin','catalog')=='catalog'){
                                                if(settings.return.replaceRecord) {
                                                    settings.return.replaceRecord(o,settings.return.selector);
                                                }else if(settings.return.insertRecord){
                                                    settings.return.insertRecord(o,'','first');
                                                }else{
                                                    console.log('after Save: return.replaceRecord and return.insertRecord not set!')
                                                }
                                            }else{
                                                if(isset(settings,'return','row')){
                                                    settings.return.row.update(o);
                                                }else if(isset(settings,'return','tableTab')){
                                                    settings.return.tableTab.addRow(o, true);
                                                }else{
                                                    console.log('after Save: return.row and return.tableTab not set!')
                                                }
                                            }
                                            break;
                                        case 3:
                                            // innerhtml
                                            if(settings.masterdata.edit_selector){
                                                if(settings.return.inittemplate){
                                                    $(settings.masterdata.edit_selector).html(settings.return.inittemplate);
                                                }else{
                                                    $(settings.masterdata.edit_selector).empty();
                                                }
                                            }
                                            if(getfromArray(settings.return,'origin','catalog')=='catalog'){
                                                if(settings.return.replaceRecord) {
                                                    settings.return.replaceRecord(o,settings.return.selector);
                                                }else if(settings.return.insertRecord){
                                                    settings.return.insertRecord(o,'','first');
                                                }
                                            }else{
                                                if(isset(settings,'return','row')){
                                                  settings.return.row.update(o);
                                                }else{
                                                  settings.return.tableTab.addRow(o, true);
                                                }
                                            }
                                            break;
                                        /*case 4:
                                            // new tab
                                        case 5:
                                            // new popup window
                                            if(window.opener && binit){
                                                //close edit tab and 
                                                window.close();
                                                window.opener.focus();
                                                window.opener.InsertRecord(o,returnflag)
                                            }
                                            break;
                                        */
                                        case 6: 
                                            // nothing
                                            break;
                                        case 7:
                                        case 8:
                                            // in line
                                            if(getfromArray(settings.masterdata,'keyvalue',0)==0){
                                                if(settings.return.insertRecord){
                                                    settings.return.insertRecord(o,settings.return.selector);
                                                }else{
                                                    console.log('settings.return.insertRecord not set')
                                                }
                                            }else if(settings.return.replaceRecord) {
                                                settings.return.replaceRecord(o,settings.return.selector);
                                            }else{
                                                console.log('settings.return.replaceRecord not set')
                                            }
                                            break;
                                        case 9:
                                            window.history.back();
                                            break;
                                        }
                                    }
                                //}
                                if(binit)row_actual=0;				
                            //});
                        }
                    }else{
                        message(oJson.error,'alert');
                    }
                    $(el_form).find('input[type="submit"],button[type="submit"]').attr("disabled",false);
                }
              })
              .fail(function(jqxhr, textStatus, error ) {
                  var err = textStatus + ", " + error;
                  //console.log( "Request Failed: " + err );
                  message(err,'alert',10000);
                  $(el_form).find('input[type="submit"],button[type="submit"]').attr("disabled",false);
              });			
          }else{
              $(el_form).find('input[type="submit"],button[type="submit"]').attr("disabled",false);
          }
        }

        function display_record(dat){
            if(settings.rightcheck!=0){
                //var readonly=!Number(getfromArray(dat,'rightuser_update',true));
                var disabled=!Number(getfromArray(dat,'rightuser_update',true));
                if(!disabled) disableForm(disabled);
            }
            if(settings.masterdata.dataLoad) {
                settings.masterdata.dataLoad(el_md,dat,settings);
            }

            if(getfromArray(settings.masterdata,'object_mode',0)==1){
               // js_rec_records leeren entfernen
               $(el_form).find('.js_rec_records').empty();
               //$('.js_rec_container').data('rec_indexmax',"-1");
                var container=el_form.querySelectorAll('.js_rec_container');
                for(var i=0;i<container.length;i++){
                    container[i].dataset.rec_indexmax="-1";
                }

                gObject2FormBuild(el_form,0,dat);
                if(settings.masterdata.newContainer){
                    var containers=$(el_form).find('.js_rec_container')
                    for(var i=0;i<containers.length;i++) {
                        settings.masterdata.newContainer(containers[i]);
                    }
                }
                conditional_output(el_form);
            }else{
                obj2form(dat,el_form)
            }

            if(settings.rightcheck!=0){
                //var readonly=!Number(getfromArray(dat,'rightuser_update',true));
                var disabled=!Number(getfromArray(dat,'rightuser_update',true));
                if(disabled){
                    console.log("form disabled");
                    disableForm(disabled);
                }else{
                    console.log("form not disabled");
                }
            }

            /* -----------  add upload ------------- */
            if(settings.masterdata.upload.enabled && !bnoform){
                //var img_settings={"js_rec_container":{main:'<div class="k8-images">   <div class="js_rec_container rec_container k8-padding-6" data-rec_object="k8references" data-rec_indexmax="-1">     <div style="display: flex;">       <div>         <h3>Images</h3>       </div>       <div style="flex: 1 1 30%;text-align: right; padding-top: 10px;">         <button type="button" class="btn btn-primary js_DeleteSelected">Delete</button>       </div>     </div>         <div id="picutes">       <form action="masterdata/ProcessData.php?process_action=Save&datadefID=8" name="dropzone" class="dropzone k8-margin-bottom-normal">         <input type="hidden" name="basetype" value="">         <input type="hidden" name="baseID" value="">         <input type="hidden" name="type" value="image">       </form>     </div>          <div class="row js_rec_records">      </div>   </div> </div>'}};
                //img_settings.js_rec_noinput={main:'<div class="k8-images"><div class="js_rec_container rec_container k8-padding-6" data-rec_object="k8references" data-rec_indexmax="-1">     <div style="display: flex;"><div><h3>Images</h3></div>       <div style="flex: 1 1 30%;text-align: right; padding-top: 10px;"></div>     </div>         <div id="picutes">       After saving the record, you can add images here.</div><div class="row js_rec_records"></div>   </div> </div>'};
                //img_settings.js_rec_record={main:'<div class="js_rec_record col-sm-4" data-rec_index="index_main"  style="position: relative">   <div class="k8-checkbox"><input type="checkbox" class="js_selected"></div>   <div class="k8-box-square k8-margin-bottom-normal">       <div class="k8-box-content">         <img class="k8-image-[image_orientation]" src="[image_file]">       </div>   </div> </div>'};
                //img_settings.masterdata={url_del:'masterdata/ProcessData.php?process_action=Del&datadefID=8'};
                //img_settings['masterdata']["url_readfilter"]='masterdata/ProcessData.php?datadefID=8&process_action=ReadFilter';
                //img_settings.masterdata.data_readfilter={};
                //img_settings['key']='ID'

                ProcessImage(dat[settings.key],dat['rightuser_update'],dat);
            }
        }

        function ProcessImage(baseID,rightuser_update,dat){
            dat=typeof dat!=='undefined' ? dat:[];

            
            img_settings.baseID=baseID;
            //img_settings.data=dat['image_array'];
            img_settings.loaddata=true;
            img_settings.parent_rightuser_update=Number(rightuser_update);
            
            var el_picture=k8.displayImage(img_settings);
            /*
            var image_count=0;
            if(dat.image_array){
                image_count=dat.image_array.length;
            }

            var basetype=settings.table;
            var clause="basetype='"+basetype+"' and baseID="+baseID+" and type='image'";

            //'masterdata/ProcessData.php?process_action=Save&datadefID=8
            if(settings.masterdata.upload.singleimage){
                //uplaod_1_dropzone
                var html_db='';
                html_db=html_db+'  <div id="pictures">';
                html_db=html_db+'    <form action="'+path+settings.masterdata.url_save+'" class="dropzone">';
                html_db=html_db+'      <input type="hidden" name="basetype" value="'+basetype+'">';
                html_db=html_db+'      <input type="hidden" name="baseID" value="'+baseID+'">';
                html_db=html_db+'      <input type="hidden" name="type" value="image">';
                html_db=html_db+'    </form>';
                html_db=html_db+'  </div>';
                if(baseID==0){
                    // upload_1_blank
                    var html='<div style="height: 140px; border: 1px solid #bbb">'+
                            '<p class="text-center" style="padding: 10px; position: relative; top: 40px">please register first and upload a picture later</p>'+
                            '</div>';
                    $(el_md).find('.pic_ph').html(html);
                }else if(image_count==0){
                    // dropzone
                    $(el_md).find('.pic_ph').html(html_db);
                    $(el_md).find(".dropzone").dropzone({
                        init: function() {
                            var $this = this;
                            $("button#clear-dropzone").click(function() {
                                $this.removeAllFiles(true);
                            });
                        },
                        paramName: "file",
                        maxFilesize: 5,
                        maxFiles : 5,
                        autoProcessQueue : true
                    });
                }else{
                    // display image
                    var html='<div class="js_rec_container" data-rec_object="k8references" data-rec_indexmax="-1">'+
                      '<div class="js_rec_record" data-keyvalue="[image_ID]"  style="position: relative">'+
                        '<div class="k8-checkbox"><input type="checkbox" class="js_img_delete"></div>'+
                          '<div class="k8-box-square k8-margin-bottom-normal">'+
                            '<div class="k8-box-content">'+
                              '<img class="k8-image-[image_orientation]" src="[image_file]">'+
                            '</div>'+
                          '</div>'+
                        '</div>'+
                      '</div>';
                    var html=ReplacePlaceholder(html,dat);
                    $(el_md).find('.pic_ph').html(html);

                    // ----------- delete
                    $(el_md).on("click",".js_img_delete",function(){
                        if(!$(this).hasClass('js_disabled')){
                            if(confirm('delete?')){
                                var el_rec_record=$(this).parents('.js_rec_record')[0];
                                var index=el_rec_record.dataset.rec_index;
                                var keyvalue=el_rec_record.dataset.keyvalue;
                                var o={}
                                o['ID']=keyvalue;
                                $.getJSON('masterdata/ProcessData.php?datadefID=8&process_action=Del',o, function(oJson) {
                                    if(oJson.bok){
                                      $(el_md).find('.pic_ph').html(html_db);
                                      $(".dropzone").dropzone({
                                          init: function() {
                                              var $this = this;
                                              $("button#clear-dropzone").click(function() {
                                                  $this.removeAllFiles(true);
                                              });
                                          },
                                          paramName: "file",
                                          maxFilesize: 5,
                                          maxFiles : 5,
                                          autoProcessQueue : true
                                      });
                                        // put in dropbox
                                    }else{
                                        console.log('error by save: '+oJson.error);
                                    }
                                });
                            }
                        }
                    });
                }
            }else{

                if($(el_md).find('.k8-images').length>0){
                    $(el_md).find('.k8-images')[0].remove();
                }
                if(gbnull(baseID)){
                    $(el_md).find('.maindata').append(img_settings['js_rec_noinput']['main']);
                }else{
                    if(!rightuser_update && image_count==0){
                        // no upload and no picture to display
                    }else{
                        if($(el_md).find('.k8-images').length==0){
                            $(el_md).find('.maindata').append(img_settings['js_rec_container']['main']);
                            $(el_md).find(".dropzone").dropzone({
                                init: function() {
                                    var $this = this;
                                    $("button#clear-dropzone").click(function() {
                                        $this.removeAllFiles(true);
                                    });
                                },
                                paramName: "file",
                                maxFilesize: 5,
                                maxFiles : 5,
                                autoProcessQueue : true
                            });
                        }
                        displayImageArea('#resultarea',img_settings,basetype,baseID,clause,rightuser_update);
                    }
                }
            }
            */
        }

        function displayImageArea(selector,settings,basetype,baseID,clause,rightuser_update){
            //filter
            //loadJson
            //Schleife

            var data=[];
            var el_image=$(el_md).find('.k8-images')[0];
            var el_rec_container=$(el_image).find('.js_rec_container')[0];
            var el_records=$(el_image).find('.js_rec_records')[0];

            // ----------------- dropzone
            var el_dropzone_form=$(el_image).find('.dropzone')[0];
            if(rightuser_update){
              //el_dropzone_form..setAttribute("action", url_save)
              el_dropzone_form.elements.namedItem('basetype').value=basetype;
              el_dropzone_form.elements.namedItem('baseID').value=baseID;
            }else{
              $(el_dropzone_form).hide();
            }

            // ----------------- delete button
            var el_btndelete=$(el_rec_container).find('.js_DeleteSelected');
            if(rightuser_update){
                $(el_btndelete).on('click',function(){
                  var el_checked=$(el_rec_container).find('input:checked');
                  for(var n=0;n<el_checked.length;n++){
                    var el_record=$(el_checked[n]).parents('.js_rec_record')[0];
                    var o={};
                    o['ID']=el_record.dataset.keyvalue;
                    $.getJSON(path+settings.masterdata.url_del,o, function(oJson) {
                        //if(settings.masterdata.fninittimer)settings.masterdata.fninittimer();
                        if(settings.masterdata.pagetimer)settings.masterdata.pagetimer.reset();
                        if(oJson.bok){
                            var el_record=$(el_rec_container).find('.js_rec_record[data-keyvalue="'+oJson.bok+'"]')[0];
                            el_record.remove();
                        }else{
                            console.log('error by delete: '+oJson.error);
                        }
                    });
                  }
                });
            }else{
                $(el_btndelete).prop("disabled", true);
            }

            // ----------------------- load data
            var url=path+settings['masterdata']["url_readfilter"]+'&clause='+clause;
            $.getJSON(url,function(oJson) {
                //if(settings.masterdata.fninittimer)settings.masterdata.fninittimer();
                if(settings.masterdata.pagetimer)settings.masterdata.pagetimer.reset();
                data=oJson;
                for(var i=0;i<oJson.length;i++){
                    //var line=ReplacePlaceholder(settings['js_rec_record']['main'],{"index_ARRAY_NAME":i},false);
                    var line=ReplacePlaceholder(settings['js_rec_record']['main'],oJson[i],settings.masterdata.placeholder_mode,path);
                    //placeholder

                    var el_line=$(el_records).append(line);
                    var el_rec_record=$(el_records).children().last()[0];

                    el_rec_record.dataset['keyvalue']=oJson[i][settings['key']];
                    el_rec_record.dataset['rec_index']=i;

                    /*
                    if(settings.rightcheck){
                        if(!oJson[i]['rightuser_delete'])$(el_rec_record).find('.js_rec_delete').hide();
                        if(!oJson[i]['rightuser_update'])$(el_rec_record).find('.js_rec_edit').hide();
                    }
                    */
                }
                el_rec_container.dataset.rec_indexmax=i;

                // disable checkbox
                if(!rightuser_update){
                    $(el_rec_container).find(':checkbox').hide();
                }
                if(sessionStorage.getItem("keyvalue")){
                    console.log('keyvaule='+sessionStorage.getItem("keyvalue"));
                }
            })
            .fail(function(jqxhr, textStatus, error ) {
                var err = textStatus + ", " + error;
                console.log( "Request Failed: " + err );
            });
        }

        function disableFormControls(disabled){
            if(disabled){
                $(el_form).find('.js_rec_new, .js_rec_delete, .js_rec_control').addClass('js_disabled');
            }else{
                $(el_form).find('.js_rec_new, .js_rec_delete, .js_rec_control').removeClass('js_disabled');
            }
            /*
            if(disabled){
                $(el_form).off("click", ".js_rec_new");
                $(el_form).off("click", ".js_rec_delete");
            }else{
                $(el_form).on("click",".js_rec_new",function(){
                    var el_rec_container=$(this).parents('.js_rec_container')[0];
                    addhtmlrecord(el_rec_container);
                });
                $(el_form).on("click",".js_rec_delete",function(){
                    if(confirm('delete?')){
                        $(this).parents('.js_rec_record')[0].remove();
                        // call function
                        if(!gbnull(getfromArray(settings.masterdata.ondelete))){
                            settings.masterdata.ondelete(el_form);
                        }
                    }
                });

            }
            */
        }

        function gObject2FormBuild(form,el_object,obj,namestr){
            namestr=typeof namestr !== 'undefined' ? namestr : '';
            //console.log("namestr=" + namestr);
            if(gbnull(namestr)){
            }
            var el_form;
            if(typeof form=='string'){
                el_form = document.forms[form];
            }else if(typeof form=='object'){
                el_form=form;
            }else{

            }
            if(el_form){
                if(gbnull(obj)){

                }else{
                    var bnewrecord=false;
                    for(var prop in obj){
                        var name='';
                        if(gbnull(namestr)){
                            name=prop;
                        }else if(isNumeric(prop)){
                            name=namestr+'['+prop+']';
                        }else{
                            //name=namestr+prop;
                            name=namestr+'['+prop+']';
                        }

                        if(typeof(obj[prop])=='object' && obj[prop]!==null){
                            var el_objectsub;
                            var object;
                            var bsub=true;
                            if(isNumeric(prop)){
                                object=getobjectfromstr(namestr);
                                if(el_object){
                                    bnewrecord=true;
                                    el_objectsub=addhtmlrecord(el_object);
                                }else{
                                }
                            }else{
                                // array-name
                                object=prop;
                                if(typeof(el_object)=='object'){
                                    el_objectsub=$(el_object).find("div[data-rec_object='"+object+"']")[0];
                                    //console.log(" -> " + object); 
                                }else{
                                    el_objectsub=$(el_form).find("div[data-rec_object='"+object+"']")[0];
                                    //console.log("form -> " + object); 
                                }
                                if(Object.keys(obj[prop]).length==0){
                                    // empty record
                                    if(getfromArray(settings.masterdata,'add_empty_rec')){                                        
                                        addhtmlrecord(el_objectsub);
                                    }
                                    bsub=false;
                                }
                            }
                            if(bsub)gObject2FormBuild(el_form,el_objectsub,obj[prop],name);
                        }else if(typeof(obj[prop])=='function'){ 
                            
                        }else if (obj.hasOwnProperty(prop)) { 
                            //console.log("prop: " + prop + " = " + obj[prop]);
                            //console.log(name + " -> " + obj[prop]);
                            el=el_form.elements.namedItem(name);
                            if(el!=undefined){
                                if(el.length){
                                    var type=el[el.length-1].type;
                                    if(el.tagName=='SELECT'){
                                        // multiselect
                                        var value=obj[prop];
                                        if(gbnull(value)){
                                            $(el).val("");
                                        }else{
                                            $(el).val(obj[prop]);
                                        }
                                    }else if(type=="checkbox"){
                                        el=el[el.length-1];
                                        if(Number(obj[prop])){
                                            el.checked=true;
                                        }else{
                                            el.checked=false;
                                        }
                                    }else if(type=="radio"){
                                        $(el_form).find("input[name='"+name+"'][value='"+obj[prop]+"']").prop('checked', true);
                                    }else{
                                        //console.log('fill out form, new type='+type);
                                        $(el).val(obj[prop]);
                                    }
                                }else{
                                    if(el.disabled){
                                        el.disabled=false;
                                        //el.value=obj[prop];
                                        gFormatinputfordisplay(el,obj[prop]);
                                        el.disabled=true;
                                    }else{
                                        //el.value=obj[prop];
                                        //$(el).val(obj[prop]);
                                        gFormatinputfordisplay(el,obj[prop]);
                                    }
                                }
                            }else{
                                //console.log('element: '+name+ " don't exist!"); 
                            }
                        }else{
                            //console.log(name + " no OwnProperty");
                        }
                    }
                    // add empty record
                    if(bnewrecord && getfromArray(settings.masterdata,'add_empty_rec')){
                        addhtmlrecord(el_object);
                    }
                }
            }
        }

        function addhtmlrecord(el_rec_container,before_rec_index){
            var indexmax=[];
            var nest=Number(el_rec_container.dataset.rec_nest);
            var object=el_rec_container.dataset.rec_object;
            var index_obj={};

            //indexmax[nest]=Number(el_rec_container.dataset.rec_indexmax);
            //indexmax[nest]++;
            //el_rec_container.dataset.rec_indexmax=indexmax[nest];

            // add record in the actual container
            index_obj['index_'+object]=Number(el_rec_container.dataset.rec_indexmax);
            index_obj['index_'+object]++;
            el_rec_container.dataset.rec_indexmax=index_obj['index_'+object];

            // getting parent record
            var el_rec_record_lfd=$(el_rec_container).parents('.js_rec_record')[0];

            while(el_rec_record_lfd){
                //indexmax[i]=Number(el_rec_record_lfd.dataset.rec_index);
                el_rec_container_lfd=$(el_rec_record_lfd).parents('.js_rec_container')[0];
                if(el_rec_container_lfd){
                    var object_lfd=el_rec_container_lfd.dataset.rec_object;
                    index_obj['index_'+object_lfd]=Number(el_rec_record_lfd.dataset.rec_index);
                    el_rec_record_lfd=$(el_rec_record_lfd).parents('.js_rec_record')[0];
                }
            }

            var line="";
            if(gbnull(settings['js_rec_record'][object])){
                console.log('js_rec_record.'+object+' is empty!');
            }else{
                line=ReplacePlaceholder(settings['js_rec_record'][object],index_obj,0,path);    //settings.masterdata.placeholder_mode
            }

            var el_records=$(el_rec_container).find('.js_rec_records')[0];
            if(typeof before_rec_index !== 'undefined'){
                el_rec_before=$(el_rec_container).find('.js_rec_record[data-rec_index="'+before_rec_index+'"]')[0];
                if(el_rec_before){
                    $(line).insertBefore(el_rec_before);
                }else{
                    console.log(el_rec_before+' not found!');
                }
            }else if($(el_records).children().length>0){
                $(el_records).children().last().after(line);
            }else{
                $(el_records).append(line);
            }
            
            var el_rec_record=$(el_records).children().last()[0];
            // defaultvalues
            if(isset(settings.masterdata,'defaultvalues',object)){
                var elements=$(el_rec_record).find("input,select,textarea");
                for(var i=0;i<elements.length;i++){
                    var name=getSubName('columnname',elements[i].name)
                    if(isset(settings.masterdata.defaultvalues,object,name)){
                        elements[i].value=settings.masterdata.defaultvalues[object][name];
                    }
                }
            }
            
            if(settings.masterdata.newRecord) {
                settings.masterdata.newRecord(el_rec_record,o);
            }
            if(settings.masterdata.newContainer){
                var containers=$(el_rec_record).find('.js_rec_container')
                for(var i=0;i<containers.length;i++) {
                    settings.masterdata.newContainer(containers[i],o);
                }
            }                               
            conditional_output(el_rec_record);

            // focus in last field?
            $(el_rec_record).on('focus','input:not(:disabled):last,select:not(:disabled):last',function(){
                console.log('check last');
                var el_records=$(this).parents('.js_rec_records')[0];
                var el=$(el_records).find('input:not(:disabled),select:not(:disabled)').last()[0];
                if(el==this){
                    //console.log('last');
                    var el=$(el_rec_record).find('input:not(:disabled):not([type=hidden]),select:not(:disabled)').first()[0];
                    if(el){
                        if(!gbnull(el.value))addhtmlrecord(el_rec_container);
                        if(getfromArray(settings.masterdata,'auto_save',0)){
                            saveRecord(false);
                        }
                    }
                }
            });
            return el_rec_record;
        }

        function message(text,myclass,delay){
            delay=typeof delay==='undefined'?4000:delay;
            //var el=el_md.getElementsByClassName('footline')[0].getElementsByTagName('div')[0];
            var el=el_md.getElementsByClassName('js_message')[0];
            if(settings.masterdata.message_position==3){
                el=$(el_md).find('.k8-browser-bottom')
                $(el).show();
                var el_child=$(el).children()[0];
                el_child.innerHTML=text;
                el_child.classList.remove('alert');
                el_child.classList.remove('saved');
                el_child.classList.add(myclass);
            }else{
                el.innerHTML=text;
                el.classList.remove('alert');
                el.classList.remove('saved');
                el.classList.add(myclass);
            }
            $(el).show();
            if(delay>0){
                setTimeout(function(){
                    $(el).fadeOut("slow");
                }, delay);
            }
        }

        function initForm(defaultvalues){
            defaultvalues=typeof defaultvalues !== 'undefined' ? defaultvalues : {};
            if(typeof(el_form)!=='undefined'){
                if(bwithdirty && el_dirty)el_dirty.src=path+'masterdata/pic/icon_saved.png';
                
                if(getfromArray(settings.masterdata,'object_mode',0)==1 || settings.masterdata.formmode==1){
                    obj2form(defaultvalues,el_form);
                    /*
                    for(var i=0;i<el_form.elements.length;i++){
                        var prop=el_form.elements[i].name;
                        if(defaultvalues[prop]){
                            el_form.elements.namedItem(prop).value=defaultvalues[prop];
                        }else if(el_form.elements[i].type!=="button" && el_form.elements[i].type!=="submit"){
                            //el_form.elements[i].value='';
                            $(el_form.elements[i]).val('');
                        }
                    }
                    */
                    conditional_output(el_form);
                }else{
                    obj2form(defaultvalues,el_form);
                    /*
                    if(typeof(oform)!=='undefined'){
                        for(var prop in oform.schema){
                            //if(Object.keys(defaultvalues).length>0){
                            if(defaultvalues[prop]){    
                                el_form.elements.namedItem(prop).value=defaultvalues[prop];
                            }else if(el_form.elements.namedItem(prop)){
                                el_form.elements.namedItem(prop).value='';
                            }
                        }
                    }
                    */
                }

                if(settings.rightcheck!=0){
                    disableForm(false);
                }
                $(el_form).find('.js_rec_records').empty();
                var containers=$(el_form).find('.js_rec_container');
                for(var i=0;i<containers.length;i++){
                    // set record counter -1
                    containers[i].dataset.rec_indexmax=-1;
                    if(getfromArray(settings.masterdata,'add_empty_rec',0)==1){
                        addhtmlrecord(containers[i]);
                    }
                }
                if(settings.masterdata.upload.enabled && !bnoform){
                    ProcessImage(0,false);
                }
            }
        }
        
        function update(o){
            /*
            var trows=tableTab.getRows();
            var bin=false;
            var result=tableTab.getRow(o[settings.key]);
            */
           var result=false;
            if(row_actual){
                result=(row_actual.getData()[settings.key]==o[settings.key]);
            }
            if(result){
                console.log('update: '+o[settings.key]);
                row_actual.update(o).then(function(row){
                    if(!bnoform)display_record(o);
                });
            }else{
                tableTab.addRow(o, true);
            }

            /*
            if(tableTab.options.index!="undefined"){
                var result=tableTab.updateRow(o[settings.key],o);
                if(trows.length>0){
                  for(var i=0;i<trows.length;i++){
                    if(trows[i].getData()[settings_list.key]==o[settings_list.key]){
                      //trows[i].update(o);
                      tableTab.updateRow(i,o);
                      bin=true;
                      break;
                    }
                  }
                }
                if(!bin){
                  tableTab.addRow(o, true);
                }
                */
            //}else{
            //}
        }

        function getRow(){
            return row_actual;
        }

        function gettableTab(){
            return tableTab;
        }

        function disableForm(disabled){
            // all fields
            for(var i=0;i<el_form.length;i++){
              /*
              if(el_form.elements[i].id=="tinymce"){
              }else{
              if(!el_form.elements[i].getAttribute("aria-disabled"))el_form.elements[i].disabled = disabled;
              }
              */
              if(!el_form.elements[i].getAttribute("aria-disabled"))el_form.elements[i].disabled = disabled;
            }

            // all button
            disableFormControls(disabled);
        }
        function changes(o){
            settings=$.extend(true,settings,o);
        }
        //});
        
        function conditional_output(el){
            var i=0;
            var data=[];
            data[i]={};
            if(row_actual){
                data[i]=row_actual.getData();
            }else{
                data[i]=o;
            }
            var dat=data[i];
            el_conditions=$(el).find('*[data-v_if]');
            for(var j=0;j<el_conditions.length;j++){
                var str=el_conditions[j].dataset.v_if;
                var mode=el_conditions[j].dataset.v_mode;
                mode=typeof mode !== 'undefined' ? mode : "empty";

                //console.log("str=" + str);
                var bhide=true;
                try{
                  bhide=!eval(str);
                }
                catch(e){
                  // error
                  console.log('error by expression: '+str);
                }
                if(bhide){
                    switch(mode){
                        case 'hide':
                            $(el_conditions[j]).hide();
                            break;
                        case 'hidechildren':
                            $(el_conditions[j]).children().hide();
                            break;
                        case 'remove':
                            $(el_conditions[j]).remove();
                            break;
                        case 'empty':
                            $(el_conditions[j]).empty();
                            break;
                    }
                }
            }
        }        
        
        function insertRecord(dat){
            tableTab.addRow(dat,true)
            .then(function(row){
                row_actual=row;
                if(!bnoform)display_record(o);
                $(table).find(".row_selected").removeClass("row_selected");
                $(row.getElement()).addClass("row_selected");
            });
        }

        function setDirty(dirty){
          dirty= typeof dirty !== 'undefined' ? dirty : true;
          if(bwithdirty){
            el_dirty.src=path+"masterdata/pic/icon_dirty.png";
          }else{
            el_dirty.src=path+"masterdata/pic/icon_saved.png";
          }
        }

        function setElementValue(element,value){
          var el=el_form.elements.namedItem(element);
          if(el){
            gFormatinputfordisplay(el,value);
            setDirty();
          }
        }

        this.test=function(){
            console.log('this.test');
        }
        
        return {"el_md":el_md,"update":update,"gettableTab":gettableTab,"tableTab":tableTab,"changes":changes,"getRow":getRow,"message":message,"insertRecord":insertRecord,"gObject2FormBuild":gObject2FormBuild,"setDirty":setDirty,"setElementValue":setElementValue};
    };

    $.fn.searchbox = function( options ) {
        var width=Math.round(window.innerWidth*0.9);
        if(width>1170)width=1170;
        var datadefID;
        var mydefault={
            "width": width,
            "tabulator":
              {
                  ajaxFiltering:true,
                  headerFilterPlaceholder:"",
                  height:205, 
                  layout:"fitColumns"
              }
            };
        if(options.hasOwnProperty('datadefID')){
            datadefID=options.datadefID;
            mydefault=$.extend(true,mydefault,{
                masterdata:{
                    "url_readfilter": "masterdata\/ProcessData.php",
                    "data_readfilter": {
                        "datadefID": datadefID,
                        "process_action": "ReadFilter"
                    }
                }
            });
        }
        var settings = $.extend(true,mydefault,options);

        /*
        var settings = $.extend(true,
        {
            "width": width
        }, options );
        */

        var url='';
        var path='../'.repeat(settings.masterdata.script_depth);

        return this.each(function(){
          //$(this).addClass('searchbox');
          var selector='k8-overlay';
          if(document.getElementById('k8-overlay'))selector='k8-overlay1';
          var overlay=document.getElementById(selector);
          if(!overlay){
            //html erstellen
            var html='<div id="'+selector+'" class="masterdata">' +
                        '<div style="width: '+settings.width+'px">' +
                            '<div style="text-align: right; padding-right: 6px"><a style="cursor:pointer;" id="btnOverlay">&times;</a></div>'+
                            '<div style="padding: 0 20px 20px 20px" id="overlay_content">'+
                                '<div class="headline">' +
                                '<div>'+'<h3>Searchbox</h3></div>'+
                                '</div>'+
                                '<div class="searchdata">'+
                                    '<div class="tabulator"></div>'+
                                '</div>'+
                                '<div class="footline">'+
                                    '<div></div>'+
                                '</div>'+
                            '</div>'+
                        '</div>'+
                    '</div>';
            $(this).append(html);
            //var el_md=this;
            var el_md=document.getElementById(selector);
            $(el_md).off();
            var table=el_md.getElementsByClassName('tabulator')[0];

            $(el_md).find('#btnOverlay').on('click',function(e){
                e.preventDefault();
                $("#"+selector).remove();
            });
            
            // ------------------------------------------ Masterdata -------------------------------------------
            $(el_md).find('.headline').find('div').eq(0).html('<h3>'+getl(settings.name)+'</h3>');
        
            //tabulator setzen
            // ------------------------------------------ Tabulator -------------------------------------------
            var row_actual=0;
            var bdelclicked=false;
            var keyfield=settings['key'];
            var otable=$.extend(
                {
                    rowClick:function(e, row){ //trigger an alert message when the row is clicked
                        var obj={};
                        obj.data=row.getData();
                        obj.js_return=settings.js_return;
                        obj.js_return.displaycolumn=settings.displaycolumn;
                        obj.js_return.key=settings.key;
                        //$(el_md).empty();
                        $("#"+selector).remove();
                        if(typeof settings.js_return.function_name === 'function') {
                            settings.js_return.function_name(obj);
                        }else{
                            var fn=window[settings.js_return.function_name];
                            if(typeof fn === 'function') {
                              fn(obj);
                            }else{
                              console.log(func_name+' is not a function!');
                            }
                        }
                    }
                },
                settings.tabulator
            );

            //-------------------------------- Define Table Columns
            //otable.columns=settings.tabulator.columns;
            
            /* -------- tabcolarr ----------- */
            if(settings.masterdata.tabcolarr){
                for (var i=0;i<otable.columns.length;i++) {
                  if (settings.masterdata.tabcolarr.indexOf(otable.columns[i]['field'])<0){
                      delete otable.columns[i];
                  }
                }                
            }
            
            var tableTab = new Tabulator(table, otable);

            //-------------------------------- tabledata
            var filters=[];
            if(settings.masterdata.filters){
                filters=settings.masterdata.filters;
            }
            if(settings.tabulator.initialHeaderFilter){
                filters=filters.concat(settings.tabulator.initialHeaderFilter);
            }
            if(filters.length>0){
                settings.masterdata.data_readfilter=$.extend(settings.masterdata.data_readfilter,{"filters":filters},true);
            }
            
            tableTab.setData(path+settings.masterdata.url_readfilter,settings.masterdata.data_readfilter);
            //$(this).find('.resize-s').resizable({handles:"s"});
          };
        });
      };
//}( jQuery ));


    $.fn.catalog=function(options,datain){
        var datadefID;
        var data=[];
        var mydefault={
                masterdata:{
                    htmlout:'catalog',
                    loaddata: true,
                    rightcheck:false,
                    rightuser_create:true,
                    paginationsize:0,
                    pagination:'',
                    paginationscale:["2","5","10"],
                    paginationalways: false,
                    paginationcontainer:'<div class="js_rec_pagination"></div>',
                    paginationtemplate:'<div class="row"><div class="k8-padding-top-normal k8-padding-bottom-normal col-xs-3 js_pag_recordcount"></div><div class="k8-padding-top-bottom-small col-xs-6 js_pag_buttons text-center"></div><div class="k8-padding-top-bottom-small col-xs-3 js_pag_pagerows text-right"></div></div>',
                    paginationtemplatebtn:'<a href="#" class="btn btn-default k8-margin-side-6"></a>',
                    edittype:0,
                    placeholder_mode:1,
                    defaultvalues:[],
                    lineeditsubmit:'<button type="submit" class="js_rec_save btn btn-primary k8-glyph-btn" aria-label="Left Align"><span class="glyphicon glyphicon-ok" aria-hidden="true"></span></button>',
                    nodata:""
                    /*nodata:'<h1>System message</h1><div style="min-height: 300px">your request has no result!</div>'*/
                },
                tabulator:{
                    columns:[]
                }
            };
        if(options.hasOwnProperty('datadefID')){
            datadefID=options.datadefID;
            mydefault=$.extend(true,mydefault,{
                masterdata:{
                    "url_new":  "index.php?page=form&page_mode=1&datadefID="+datadefID,
                    "url_edit": "index.php?page=form&page_mode=1&process_action=Edit&datadefID="+datadefID,
                    "url_getR": "masterdata\/ProcessData.php?process_action=getRecords&datadefID="+datadefID,
                    "url_init": "masterdata\/ProcessData.php?process_action=Init&datadefID="+datadefID,
                    "url_load": "masterdata\/ProcessData.php?process_action=Load&datadefID="+datadefID,
                    "url_save": "masterdata\/ProcessData.php?process_action=Save&datadefID="+datadefID,
                    "url_del":  "masterdata\/ProcessData.php?&process_action=Del&datadefID="+datadefID,
                    "url_readfilter": "masterdata\/ProcessData.php",
                    "data_readfilter": {
                        "datadefID": datadefID,
                        "process_action": "ReadFilter"
                    }
                }
            });
        }
        var settings = $.extend(true,mydefault,options );
        if(settings.masterdata.tabcolumns){
          settings.tabulator['movableColumns']=true;
          settings.tabulator['columnMoved']=function(column, columns){listcolumns();};
        }
        // create childfieldnames
        var childfieldnames={};
        if(settings.childs){
            for(i=0;i<settings.childs.length;i++){
                var child=settings.childs[i];
                childfieldnamesAdd(child);
            }
        }
        function childloop(childs){
            for(i=0;i<childs.length;i++){
                var child=childs[i];
                childfieldnamesAdd(child);
            }
        }
        function childfieldnamesAdd(child){
            childfieldnames[child.fieldname]={};
            childfieldnames[child.fieldname].key=child.key;
            if(child.childs){
                childloop(child.childs);
            }
        }
        settings.childfieldnames=childfieldnames;

        //return this.each(function(){
        //this.each(function(){
        var edittype=Number(settings.masterdata.edittype);
        if(settings.masterdata.listedit || settings.masterdata.lineedit){
            edittype=6;
        }else if(settings.masterdata.newtabedit){
            edittype=4;
        }
        var url='';
        var path='../'.repeat(settings.masterdata.script_depth);
        
        var el_pagination;
        var pageno=1;
        var mytable_offset=0;
        var mytable_limit=getfromArray(Array_GET(),'mytable_limit',settings.masterdata.paginationsize);
        var k8_recordcount;
        var el_list;
        var error='';
        var plugin=this;
        var $plugin=$(this);
        
        if(this.length==1){
            // create listbox
            el_list=this[0];
            $(el_list).off();
            
            if(typeof datain!=='undefined'){
                data=datain.slice();
            }else if(typeof settings.data!=='undefined'){
                data=settings.data.slice();
            }
            $plugin.data("data",data);
            k8_recordcount=data;

            var object=settings.masterdata.htmlout;
            var berror=false;

            // history
            if(!isset(settings,'html')){
                settings.html={};
                settings.html[object]={};
                if(isset(settings,'js_rec_container',object)){
                    settings.html[object]['container']=settings['js_rec_container'][object];
                }
                if(isset(settings,'js_rec_record',object)){
                    settings.html[object]['record']=settings['js_rec_record'][object];
                }
                if(isset(settings,'js_rec_nodata',object)){
                    settings.html[object]['nodata']=settings['js_rec_nodata'][object];
                }
            }            
            
            //if(!isset(settings,'js_rec_container',object)){
            if(!isset(settings,'html',object,'container')){
                console.log('container invalid: '+object);
                berror=true;
            }
            //if(!isset(settings,'js_rec_record',object)){
            if(!isset(settings,'html',object,'record')){
                console.log('record invalid: '+object);
                berror=true;
            }
            if(berror)return;
            
            var html='';
            //html=ReplacePlaceholder(settings['js_rec_container'][object],{},settings.masterdata.placeholder_mode,path);
            html=ReplacePlaceholder(settings.html[object]['container'],{},settings.masterdata.placeholder_mode,path,k8formatter,settings.tabulator.columns);
            el_list.innerHTML=html;
            conditional_output(el_list);
            
            if(settings.rightcheck!=0 && !settings.masterdata.rightuser_create){
                $(el_list).find('.js_rec_new,.js_rec_newsearch').hide();
            }
            
            var el_records=$(el_list).find('.js_rec_records')[0];
            if(!el_records){
                console.log('container has no class: js_rec_records');
                return;
            }
            if(settings.masterdata.edittype==6){
                $(el_records).replaceWith('<form class="form-horizonal" method="get" action="masterdata/ProcessData.php" name="lineedit">'+el_records.outerHTML+'</form>');
                var el_records=$(el_list).find('.js_rec_records')[0];
            }
            
            var el_container=$(el_list).find('.js_rec_container')[0];
            if(!el_container){
                console.log('container has no class: js_rec_container');
                return;
            }
            if(settings.masterdata.paginationsize>0){
                var el=$(el_container).find('.js_rec_pagination')[0];
                if(!el){
                    var el_foot=$(el_container).find('.js_rec_foot')[0];
                    if(el_foot){
                        if(getfromArray(settings.masterdata,'paginationprepend',true)){
                            $(el_foot).prepend(settings.masterdata.paginationcontainer);
                        }else{
                            $(el_foot).append(settings.masterdata.paginationcontainer);
                        }
                    }else{
                        $(el_container).append('<div class="js_rec_foot">'+settings.masterdata.paginationcontainer+'</div>');
                    }
                }
            }
            if(settings.masterdata.heartbeat){
                setInterval(function(){
                    $.getJSON('masterdata/ProcessData.php');
                    //if(settings.masterdata.fninittimer)settings.masterdata.fninittimer();
                }, settings.masterdata.heartbeat);
            }
            var el_form=$(el_list).find('form[name="lineedit"]')[0];
            
            /* ---------- controls ------------ */
            if(settings.masterdata.edittype==6){
                $(el_form).on("change","input,textarea,select",function(){
                    var name=getSubName('name',this.name);
                    var namestr=getSubName('namestr',this.name);
                    gFormatinputfordisplay(this,this.value);
                    //if(bwithdirty)el_dirty.src=path+"masterdata/pic/icon_dirty.png";
                    if(settings.masterdata.dataChange) {
                        settings.masterdata.dataChange(el_md,this);
                    }
                });
            }
            
            if(true){
                $(el_list).on("click",".js_image_click",function(){
                    var el_record=$(this).parents('.js_rec_record')[0];
                    if(el_record){
                        el_target=$(el_record).find('img')[0];
                        el_target.src=this.src;
                        $(el_target).removeClass('k8-image-landscape')
                        $(el_target).removeClass('k8-image-potrait');
                        if(this.classList.contains('k8-image-landscape')){
                            $(el_target).addClass('k8-image-landscape')
                        }else{
                            $(el_target).addClass('k8-image-portrait')
                        }
                    }else{
                        console.log('js_image_click, no js_rec_recrd defined!');
                    }
                });
            }

            /*
            $(el_list).on("click",".js_rec_new_search",function(){
                if(!$(this).hasClass('js_disabled')){
                    var el_rec_container=$(this).parents('.js_rec_container')[0];
                    var indexmax=el_rec_container.dataset.rec_indexmax;
                    indexmax++;
                    el_rec_container.dataset.rec_indexmax=indexmax;
                    var index_obj={};
                    index_obj['index']=indexmax;
                    index_obj['keyvalue']=0;
                    var line=ReplacePlaceholder(settings['js_rec_record'][object],index_obj,settings.masterdata.placeholder_mode,path);
                    $(el_records).append(line);

                    el_rec_record=$(el_list).find('.js_rec_record[data-rec_index="'+indexmax+'"]')[0];
                    $(el_rec_record).find('.js_rec_delete').hide();
                    $(el_rec_record).find('.js_rec_edit').hide();
                    $(el_rec_record).find('.js_rec_cancel').show();
                    $(el_rec_record).find('.js_rec_save').show();
                    $(el_rec_record).find('.js_rec_save').prop("disabled",false);
                }
            });
            */

            $(el_list).on("click",".js_rec_new",function(){
                if(!$(this).hasClass('js_disabled')){
                    if(edittype==6 || edittype==7 || edittype==8){
                        controlDisabled(true);
                    }
                    var el_rec_contmain=$(el_list).find(this).parents('.js_rec_container').last()[0];
                    var el_rec_container=$(this).parents('.js_rec_container')[0];
                    settings.masterdata.window_mode=edittype;
                    switch(edittype){
                        case 0: // nothing / no buttons / link in this window
                            break;
                        case 1: // execute ajax and reload
                            break;
                        case 2: // opverlay
                            createOverlay(0);
                            break;
                        case 3: // innerhtml
                            createOverlay(0);
                            break;
                        case 4: // new tab
                        case 5: // new window
                            var parameter="";
                            if(settings.masterdata.window_mode=edittype==5){
                                parameter="width="+window.innerWidth.toString()+",height="+window.innerHeight.toString()+",resizable=yes,scrollbars=yes";
                            }
                            if(settings.masterdata.url_new){
                                //var url='index.php?page=form&datadefID='+settings.datadefID+'&page_mode=1&keyvalue='+cell.getData()[settings.key];
                                var url=path+settings.masterdata.url_new+'&returnflag=3&returnopener=1&keyvalue=0';
                                // set index for return
                                var w=window.open(url,"Edit",parameter);
                                w.focus();
                                //window.location.assign(url);
                            }else{
                                alert('please set url_new!');
                            }
                            break;
                        case 6: // own line
                            addrecord(el_rec_container);
                            break;
                        case 7: // this line new template
                            addrecord(el_rec_container);
                            break;
                        case 8: // like masterdata form
                            
                            // !!! insert top or bottom
                            
                            var keyvalue=0;
                            var indexmax=el_container.dataset.rec_indexmax;
                            indexmax++;
                            el_container.dataset.rec_indexmax=indexmax;
                            var index_obj={};
                            if(settings.masterdata.defaultvalues){
                                index_obj=settings.masterdata.defaultvalues;
                            }
                            index_obj['index']=indexmax;
                            index_obj['keyvalue']=0;
                            var line=ReplacePlaceholder('<div class="js_rec_record rec_record" data-keyvalue="{{keyvalue}}" data-rec_index="{{index}}"></div>',index_obj,2,path,k8formatter,settings.tabulator.columns);
                            //$(el_records).append(line);
                            //var el_rec_record=$(el_records).find('.js_rec_record').last()[0];
                            
                            $(el_records).prepend(line);
                            var el_rec_record=$(el_records).find('.js_rec_record').first()[0];
                            
                            settings.masterdata.keyvalue=keyvalue;
                            settings.masterdata.notabulator=true;
                            settings.return={};
                            settings.return.replaceRecord=replaceRecord;
                            settings.return.selector='.js_rec_record[data-keyvalue="'+keyvalue+'"]';
                            
                            //var el_rec_record=$(el_list).find(settings.return.selector);
                            
                            $(el_rec_record).empty();
                            $(el_rec_record).append('<div class="masterdata"></div>');
                            $(el_rec_record).find('.masterdata').masterdata(settings);
                            break;
                        case 9: // link in this window
                            url=path+settings.masterdata.url_edit+'&returnflag=3&keyvalue=0';
                            window.location.href=url;
                            break;
                       case 10: // call back function
                            if(settings.masterdata.dataNew){
                                var el_rec_recmain=$(el_list).find(this).parents('.js_rec_record').last()[0];
                                var indexes={};
                                var dat={};
                                if(el_rec_recmain){
                                    var index=el_rec_recmain.dataset.rec_index;
                                    dat=data[index];
                                    var el_rec_lfd=$(el_rec_container).parents('.js_rec_record')[0];
                                    do{
                                        var el_rec_contlfd=$(el_rec_lfd).parents('.js_rec_container')[0];
                                        var indexlfd=el_rec_lfd.dataset.rec_index;
                                        var arrayname=el_rec_contlfd.dataset.rec_object;
                                        indexes[arrayname]=indexlfd;
                                        el_rec_lfd=$(el_rec_contlfd).parents('.js_rec_record')[0];
                                    }while(typeof(el_rec_lfd)!=="undefined")
                                }
                                settings.masterdata.dataNew(el_rec_container,dat,indexes);
                            }
                        default:
                            console.log('type not defined');
                    }
                }
            });

            $(el_list).on("click",".js_rec_edit",function(){
                if(!$(this).hasClass('js_disabled')){
                    if(edittype==6 || edittype==7 || edittype==8)controlDisabled(true);
                    var el_rec_contmain=$(el_list).find(this).parents('.js_rec_container').last()[0];
                    var el_rec_recmain=$(el_list).find(this).parents('.js_rec_record').last()[0];
                    var index=el_rec_recmain.dataset.rec_index;
                    var el_rec_container=$(this).parents('.js_rec_container')[0];
                    var el_rec_record=$(this).parents('.js_rec_record')[0];
                    var keyvalue=el_rec_record.dataset.keyvalue; //data[index][settings.key]
                    settings.masterdata.window_mode=edittype;
                    switch(edittype){
                        case 0: // deprecated link in this window
                            url=path+settings.masterdata.url_edit+'&keyvalue='+keyvalue+'&returnflag=2';
                            window.location.href=url;
                            break;
                        case 1: // execute ajax and reload
                            break;
                        case 2: // opverlay
                            createOverlay(keyvalue);
                            break;
                        case 3: // innerhtml
                            if(settings.masterdata.edit_selector){
                                var selector=settings.masterdata.edit_selector;
                                var element='masterdata'; //!!!
                                switch(element){
                                    case 'masterdata':
                                        settings.masterdata.keyvalue=keyvalue;
                                        settings.masterdata.notabulator=true;
                                        settings.return={};
                                        settings.return.replaceRecord=replaceRecord;
                                        settings.return.selector='.js_rec_record[data-keyvalue="'+keyvalue+'"]';
                                        $(selector).masterdata(settings);
                                        break;
                                    case 'catalog':
                                        //htmlout
                                        $(el_md).find(selector).catalog(settings);
                                        break;
                                    default:
                                        console.log('element='+element+' not valid!');
                                }
                            }else{
                                console.log('masterdata.edit_selector is not set!');
                            }
                            break;
                        case 4: // new tab
                            if(settings.masterdata.url_edit){
                                //var url='index.php?page=form&datadefID='+settings.datadefID+'&page_mode=1&keyvalue='+cell.getData()[settings.key];
                                var url=path+settings.masterdata.url_edit+'&returnflag=3&returnopener=1&keyvalue='+keyvalue;
                                // set index for return
                                var w=window.open(url,"Edit");
                                w.focus();
                                //window.location.assign(url);
                            }else{
                                alert('please set url_edit!');
                            }
                            break;
                        case 5: // new window
                            if(settings.masterdata.url_edit){
                                var url=path+settings.masterdata.url_edit+'&returnflag=3&returnopener=1&keyvalue='+keyvalue;
                                var parameter="width="+window.innerWidth.toString()+",height="+window.innerHeight.toString()+",resizable=yes,scrollbars=yes";
                                parameter="top="+(window.screenY).toString()+",left="+(window.screenX).toString()+","+parameter;
                                var w = window.open(url,'Edit', parameter);
                                w.focus();
                            }
                            break;
                        case 6: // own line, same template
                            var dat=getData()[index];
                            dat['index']=index;
                            dat['keyvalue']=keyvalue;
                            
                            replaceline(el_rec_record,settings.html[object]['record'],dat,index,keyvalue);
                              
                            /*  
                            var line=ReplacePlaceholder(settings.html[object]['record'],dat,settings.masterdata.placeholder_mode,path,k8formatter,settings.tabulator.columns);
                            //$(el_rec_record).replaceWith(line);
                            //el_rec_record=$(el_list).find('.js_rec_record[data-rec_index="'+index+'"]')[0];
                            el_rec_record=replaceElWith(el_rec_record,line);
                            
                            if(el_rec_record){
                                el_rec_record.dataset.rec_index=index;
                                el_rec_record.dataset.keyvalue=keyvalue;
                                obj2form(dat,$(el_list).find('form')[0]);
                                
                                $(el_rec_record).find('input:visible,select:visible,textarea:visible').first().focus();
                                $(el_rec_record).find('.js_rec_delete').hide();
                                $(el_rec_record).find('.js_rec_edit').hide();
                                $(el_rec_record).find('.js_rec_cancel').show();
                                //$(el_rec_record).find('.js_rec_save').show();
                                //$(el_rec_record).find('.js_rec_save').prop("disabled",false);
                                var el_marker=$(el_rec_record).find('.js_contain_submit')[0];
                                if(!el_marker){
                                    el_marker=$(el_rec_record).find('.recordmarker')[0];
                                }
                                if(el_marker){
                                    $(el_marker).append(settings.masterdata.lineeditsubmit);
                                }
                                
                                if(settings.masterdata.dataLoad) {
                                    settings.masterdata.dataLoad(el_rec_record,dat,'record');
                                }
                            }else{
                                console.log('.js_rec_record[data-rec_index="'+index+'"] not found');
                            }
                            */                                      
                            break;
                        case 7: // own line, plugin
                            msgbox("pending");
                            break;
                        case 8: // like jsonform
                            settings.masterdata.keyvalue=keyvalue;
                            settings.masterdata.notabulator=true;
                            settings.return={};
                            settings.return.replaceRecord=replaceRecord;
                            settings.return.selector='.js_rec_record[data-keyvalue="'+keyvalue+'"]';
                            
                            $(el_rec_record).empty();
                            $(el_rec_record).append('<div class="masterdata"></div>');
                            $(el_rec_record).find('.masterdata').masterdata(settings);
                            break;
                        case 9: // link in this window
                            url=path+settings.masterdata.url_edit+'&returnflag=3&keyvalue='+keyvalue;
                            window.location.href=url;
                            break;
                        case 10: // call back function
                            if(settings.masterdata.dataEdit){
                                //var dat=getData()[index];
                                var dat=data[index];
                                var indexes={};
                                var el_rec_lfd=el_rec_record;
                                do{
                                    var el_rec_contlfd=$(el_rec_lfd).parents('.js_rec_container')[0];
                                    var indexlfd=Number(el_rec_lfd.dataset.rec_index);
                                    var arrayname=el_rec_contlfd.dataset.rec_object;
                                    indexes[arrayname]=indexlfd;
                                    el_rec_lfd=$(el_rec_contlfd).parents('.js_rec_record')[0];
                                }while(typeof(el_rec_lfd)!=="undefined")
                                //dat['index']=index;
                                //dat['keyvalue']=keyvalue;
                                settings.masterdata.dataEdit(el_rec_container,el_rec_record,dat,indexes);
                            }
                            break
                        default:
                            console.log('type not defined');
                    }
                }
            });

            $(el_form).submit(function( e ) {
                e.preventDefault();
                var el=$(e.target).find('input,select,textarea').first()[0];
                var el_record=$(el).parents('.js_rec_record')[0];
                saverecord(el_record);
            });
            
            /*
            $(el_list).on("click",".js_rec_save",function(e){
                e.preventDefault();
                var el_record=$(this).parents('.js_rec_record')[0];
                saverecord(el_record);
            });
            */

            $(el_list).on("click",".js_rec_cancel",function(){
                if(edittype==10){
                    if(settings.masterdata.dataCancel){
                        var el_rec_record=$(this).parents('.js_rec_record')[0];
                        var el_form=$(this).parents('form')[0];
                        var el_rec_recmain=$(el_list).find(this).parents('.js_rec_record').last()[0];
                        var index=el_rec_recmain.dataset.rec_index;
                        var dat=data[index];
                        var indexes={};
                        var el_rec_lfd=el_rec_record;
                        do{
                            var el_rec_contlfd=$(el_rec_lfd).parents('.js_rec_container')[0];
                            var indexlfd=Number(el_rec_lfd.dataset.rec_index);
                            var arrayname=el_rec_contlfd.dataset.rec_object;
                            indexes[arrayname]=indexlfd;
                            el_rec_lfd=$(el_rec_contlfd).parents('.js_rec_record')[0];
                        }while(typeof(el_rec_lfd)!=="undefined")
                        settings.masterdata.dataCancel(el_form,dat,indexes);
                    }else{
                        console.log('masterdata.dataCamceö not defined');
                    }
                }else{
                    var el_rec_record=$(this).parents('.js_rec_record')[0];
                    var el_records=$(this).parents('.js_rec_records')[0];
                    var keyvalue=el_rec_record.dataset.keyvalue;
                    if(isNaN(keyvalue))keyvalue=0;
                    var rec_index=Number(el_rec_record.dataset.rec_index);
                    if(rec_index==-1){
                        el_rec_record.remove();
                    }else{
                        var index=el_rec_record.dataset.rec_index;
                        var dat=getData()[index];
                        dat['keyvalue']=keyvalue;
                        dat['index']=index;
                        var template='record';
                        if(settings.html[object]['recdisp']){
                            template='recdisp';
                            var line=ReplacePlaceholder(settings.html[object][template],dat,settings.masterdata.placeholder_mode,path,k8formatter,settings.tabulator.columns);
                            $(el_rec_record).replaceWith(line)[0];
                            el_rec_record=$(el_records).find('.js_rec_record[data-keyvalue="'+keyvalue+'"]')[0];
                        }else{
                            input2display(el_rec_record,dat);
                        }
                        $(el_rec_record).find('.js_rec_delete').show();
                        $(el_rec_record).find('.js_rec_edit').show();
                        $(el_rec_record).find('.js_rec_cancel').hide();
                        //$(el_rec_record).find('.js_rec_save').hide();
                        //$(el_rec_record).find('.js_rec_save').prop("disabled",true);
                        $(el_rec_record).find('.js_rec_save').remove();

                        if(settings.masterdata.dataLoad) {
                            settings.masterdata.dataLoad(el_rec_record,dat,template);
                        }

                    }
                    if(edittype==6 || edittype==7)controlDisabled(false);
                }
            });

            $(el_list).on("click",".js_rec_test",function(){
                if(!$(this).hasClass('js_disabled')){
                  var el_rec_record=$(this).parents('.js_rec_record')[0];
                  var indexes=getIndexesfrom(el_rec_record);
                  console.log(indexes);
                  /*
                  if(indexes.length>0){
                    var onew=[];
                    onew[indexes.length-1]=data;
                    for(var i=indexes.length-2;i>=0;i--){
                      console.log(indexes[i]);
                      onew[i]=onew[i+1][indexes[i]];
                    }
                    console.log('found:');
                    console.log(onew[0]);
                    delete(onew[0]);
                    console.log(data);
                  }
                  */
                  objdelete(data,indexes,indexes.length-1);
                  console.log(data);
                  
                  function objdelete(obj,indexes,i){
                    if(i>1){
                      i--;
                      objdelete(obj[indexes[i]],indexes,i);
                    }else{
                      delete obj[indexes[i+1]];
                    }
                  }
                  function objedit(obj,indexes,i){
                    if(i>1){
                      i--;
                      objedit(obj[indexes[i]],indexes,i);
                    }else{
                      console.log(obj[indexes[i+1]]);
                      
                      var index=el_rec_recmain.dataset.rec_index;
                      var keyvalue=el_rec_record.dataset.keyvalue; 
                      var record="";
                      var dat=obj[indexes[i+1]];
                      var dat=getData()[index];
                      dat['index']=index;
                      dat['keyvalue']=keyvalue;
                      
                      replaceline(el_rec_record,settings.html[object][record],dat,index,keyvalue);

                    }
                  }
                }
            });

            $(el_list).on("click",".js_rec_delete",function(){
                if(!$(this).hasClass('js_disabled')){
                    if(confirm('delete?')){
                        var el_rec_containers=$(el_list).find(this).parents('.js_rec_container');
                        var el_rec_record=$(this).parents('.js_rec_record')[0];
                        if(el_rec_containers.length==1){
                            deleteRecord(el_rec_record);
                        }else if(edittype==10){
                            if(settings.masterdata.dataDeldata){
                              var el_rec_record=$(this).parents('.js_rec_record')[0];
                              settings.masterdata.dataDeldata(el_rec_record,data);
                            }else if(settings.masterdata.dataDelete){
                                var el_rec_record=$(this).parents('.js_rec_record')[0];
                                var el_rec_recmain=$(el_list).find(this).parents('.js_rec_record').last()[0];
                                var index=el_rec_recmain.dataset.rec_index;
                                var dat=data[index];
                                var indexes={};
                                var el_rec_lfd=el_rec_record;
                                do{
                                    var el_rec_contlfd=$(el_rec_lfd).parents('.js_rec_container')[0];
                                    var indexlfd=Number(el_rec_lfd.dataset.rec_index);
                                    var arrayname=el_rec_contlfd.dataset.rec_object;
                                    indexes[arrayname]=indexlfd;
                                    el_rec_lfd=$(el_rec_contlfd).parents('.js_rec_record')[0];
                                }while(typeof(el_rec_lfd)!=="undefined")
                                settings.masterdata.dataDelete(el_rec_record,dat,indexes);
                            }else{
                                console.log('masterdata.dataDelete not defined');
                            }
                        }else{
                           var indexes=getIndexesfrom(el_rec_record);
                           conole.log(indexes);
                        }
                    }
                }
            });

            // ----------------------- load data
            if(data.length>0){
                displaydata();
            }else if(settings.masterdata.loaddata) {
                loaddata();
            }else{
                displaydata();
            }

            function replaceline(el_rec_record,html,dat,index,keyvalue){
              var line=ReplacePlaceholder(settings.html[object]['record'],dat,settings.masterdata.placeholder_mode,path,k8formatter,settings.tabulator.columns);
              el_rec_record=replaceElWith(el_rec_record,line);

              if(el_rec_record){
                  el_rec_record.dataset.rec_index=index;
                  el_rec_record.dataset.keyvalue=keyvalue;
                  obj2form(dat,$(el_list).find('form')[0]);

                  $(el_rec_record).find('input:visible,select:visible,textarea:visible').first().focus();
                  $(el_rec_record).find('.js_rec_delete').hide();
                  $(el_rec_record).find('.js_rec_edit').hide();
                  $(el_rec_record).find('.js_rec_cancel').show();
                  //$(el_rec_record).find('.js_rec_save').show();
                  //$(el_rec_record).find('.js_rec_save').prop("disabled",false);
                  var el_marker=$(el_rec_record).find('.js_contain_submit')[0];
                  if(!el_marker){
                      el_marker=$(el_rec_record).find('.recordmarker')[0];
                  }
                  if(el_marker){
                      $(el_marker).append(settings.masterdata.lineeditsubmit);
                  }

                  if(settings.masterdata.dataLoad) {
                      settings.masterdata.dataLoad(el_rec_record,dat,'record');
                  }
              }else{
                  console.log('.js_rec_record[data-rec_index="'+index+'"] not found');
              }
            }
            
            function reachbottom(){
                var scrollable=document.documentElement.scrollHeight-window.innerHeight;
                var scrolled=window.scrollY;
                if(scrolled=scrollable){
                    window.removeEventListener('scroll',reachbottom);
                    alert('You ve reached the bottom');
                    // offset lesen nachladen
                }
            }
            
            function controlDisabled(disabled){
                if(disabled){
                    $(el_list).find('.js_rec_delete, .js_rec_new, .js_rec_edit').addClass('js_disabled');
                    $(el_list).find('.js_rec_delete, .js_rec_new, .js_rec_edit').attr('disabled',true);
                }else{
                    //$(el_form).find('.js_rec_new, .js_rec_edit').removeClass('js_disabled');
                    $(el_list).find('.js_rec_delete, .js_rec_new, .js_rec_edit').removeClass('js_disabled');
                    $(el_list).find('.js_rec_delete, .js_rec_new, .js_rec_edit').attr('disabled',false);
                }
            }

            function disableFormControls(disabled){
                if(disabled){
                    $(el_form).find('.js_rec_new, .js_rec_delete, .js_rec_control').addClass('js_disabled');
                }else{
                    $(el_form).find('.js_rec_new, .js_rec_delete, .js_rec_control').removeClass('js_disabled');
                }
            }            
            
            function createOverlay(keyvalue){
                //keyvalue==0 ->New
                var selector='';
                if(settings.masterdata.window_mode==2){
                    //overlay
                    var width=Math.round(window.innerWidth*0.9);
                    if(width>1170)width=1170;
                    var html='<div id="k8-overlay">' +
                                '<div style="width: '+width+'px">' +
                                    '<div style="text-align: right; padding-right: 6px"><a style="cursor:pointer;" id="btnOverlay">&times;</a></div>'+
                                    '<div style="padding: 0 20px 20px 20px" id="overlay_content">'+
                                        '<div class="masterdata">' +
                                    '</div>'+
                                '</div>'+
                            '</div>';
                    $(el_list).append(html);
                    var el_md=document.getElementById('k8-overlay');
                    $(el_md).find('#btnOverlay').on('click',function(e){
                        e.preventDefault();
                        $("#k8-overlay").remove();
                    });
                    selector='.masterdata';
                }else if(settings.masterdata.window_mode==3){
                    //innerhtml
                    //template in line
                    selector=settings.masterdata.edit_selector;
                }else if(settings.masterdata.window_mode==7){
                    // nothing
                    var el_record;
                    if(gbnull(keyvalue)){
                        // prepend empty record
                        // data[] vorsehen
                        //var line=ReplacePlaceholder(settings['js_rec_record'][object],index_obj,settings.masterdata.placeholder_mode,path)                    
                        var line=ReplacePlaceholder(settings.html[object]['record'],index_obj,settings.masterdata.placeholder_mode,path,k8formatter,settings.tabulator.columns)                    
                        $(el_records).prepend(line);
                        el_record=$(el_md).find('.js_rec_record[data-keyvalue="[keyvalue]"')[0];
                    }else{
                        el_record=$(el_md).find('.js_rec_record[data-keyvalue="'+keyvalue+'"]')[0];
                    }
                    $(el_record).empty();
                    $(el_record).append('<div class="masterdata"></div>');
                    selector=".masterdata";
                }else{
                    console.log(settings.masterdata.window_mode+' not valid!');
                    return
                }
                // element, data, keyvalue, filters, clause
                var element='masterdata'; //!!!
                switch(element){
                    case 'masterdata':
                        settings.masterdata.notabulator=true;
                        settings.return={};
                        if(gbnull(keyvalue)){
                            // insertRecord when New
                            settings.return.insertRecord=insertRecord;
                        }else{
                            settings.return.replaceRecord=replaceRecord;
                            settings.masterdata.keyvalue=keyvalue;
                            settings.return.selector='.js_rec_record[data-keyvalue="'+keyvalue+'"]';
                        }
                        //$(el_md).find(selector).masterdata(settings);
                        $(selector).masterdata(settings);
                        break;
                    case 'catalog':
                        //htmlout
                        $(el_md).find(selector).catalog(settings);
                        break;
                    default:
                        console.log('element='+element+' not valid!');
                }
            }
            
            function loaddata(ppageno,pmytable_limit){
                if(isset(settings,'masterdata','url_readfilter') && isset(settings,'masterdata','data_readfilter')){
                    url=path+settings.masterdata.url_readfilter;
                    //var clause=getfromArray(settings.masterdata,'clause');
                    //url=gsclauseand(url,'clause='+clause,!gbnull(clause),'&');
                    var params=settings.masterdata.data_readfilter;
                    params.filters=[];
                    params.clause=getfromArray(settings.masterdata,'clause');
                    if(isset(settings,'masterdata','filters')){
                        params.filters=settings.masterdata.filters;
                    }
                    if(settings.masterdata.paginationsize>0){
                        if(settings.masterdata.pagination=='internal'){
                            if(typeof pmytable_limit!=='undefined') mytable_limit=pmytable_limit;
                            if(typeof ppageno!=='undefined'){
                                pageno=ppageno;
                                mytable_offset=(pageno-1)*mytable_limit;
                            }
                            params.mytable_offset=mytable_offset;
                            params.mytable_limit=mytable_limit;
                        }else{
                            pageno=getfromArray(Array_GET(),'pageno',1);
                            params.mytable_limit=getfromArray(Array_GET(),'mytable_limit',settings.masterdata.paginationsize);
                            var t=(getfromArray(Array_GET(),'pageno',1)-1)*params.mytable_limit;
                            //params.mytable_offset=getfromArray(Array_GET(),'mytable_offset',0);
                            params.mytable_offset=t;
                        }
                    }else if(settings.masterdata.sql_limit){
                        params.mytable_offset=0;
                        params.mytable_limit=settings.masterdata.sql_limit;
                    }
                    $.getJSON(url,params,function(oJson) {
                        data=oJson.slice();
                        $plugin.data("data",data);
                        console.log( "loaddata.data.length: " + data.length);
                        displaydata();
                    })
                    .fail(function(jqxhr, textStatus, error ) {
                        var err = textStatus + ", " + error;
                        console.log( "data load, Request Failed: " + err );
                    });
                }else{
                    console.log('settings.masterdata.url_readfilters not set');
                }
            }

            function displaydata(){
                if(data.length>0){
                    var template='record';
                    if(settings.html[object]['recdisp'])template='recdisp';
                    for(var i=0;i<data.length;i++){
                        var line=ReplacePlaceholder(settings.html[object][template],data[i],settings.masterdata.placeholder_mode,path,k8formatter,settings.tabulator.columns);
                        $(el_records).append(line);
                        var el_record=$(el_records).children().last()[0];
                        displaydat(el_record,data[i],i,template);
                        el_container.dataset.rec_indexmax=i;
                        el_subcontainer=$(el_record).find('.js_rec_container')[0];
                        if(el_subcontainer)gObject2htmlBuild(object,el_record,data[i]);
                    }
                }else{
                    //if(isset(settings,'js_rec_nodata',object)){
                    //    var line=ReplacePlaceholder(settings['js_rec_nodata'][object],{},settings.masterdata.placeholder_mode,path);
                    if(isset(settings,'html',object,'nodata')){
                        var line=ReplacePlaceholder(settings.html[object]['nodata'],{},settings.masterdata.placeholder_mode,path,k8formatter,settings.tabulator.columns);
                        $(el_records).append(line);
                        //conditional_output(el_line);
                    }else{
                        $(el_records).append(settings.masterdata.nodata);
                    }
                }
                if(settings.masterdata.paginationsize>0){
                    if(data.length>0){
                        k8_recordcount=getfromArray(data[0],'k8_recordcount',0);
                    }
                    el_pagination=$(el_container).find(".js_rec_pagination")[0];
                    setPagination(el_pagination,k8_recordcount,settings.masterdata.pagination);
                }
                if(settings.masterdata.dataAfterLoadAll) {
                    settings.masterdata.dataAfterLoadAll(el_list,data);
                }
                console.log( "loaddata.end.data.length: " + data.length);
            }

            function displaydat(el_line,dat,index,template){
                // recursive
               
                //-----------  conditional output  -------------
                conditional_output(el_line,dat);

                //-----------  data-loop-object  -------------
                el_loops=$(el_line).find('*[data-loop_object]');
                for(var j=0;j<el_loops.length;j++){
                    var subsarr=el_loops[j].dataset.loop_object;
                    if(dat[subsarr]){
                        var loop_html=el_loops[j].dataset.loop_html;
                        var itm = el_loops[j].children[0];
                        var el_new;
                        for(var n=0;n<dat[subsarr].length;n++){
                            if(loop_html){
                                var line=ReplacePlaceholder(settings.html[object][loop_html],dat[subsarr][n],2,path,k8formatter,settings.tabulator.columns);
                                //$(el_loops).append(line);
                                el_new=$(line).appendTo(el_loops)[0];
                            }else{
                                var cln = itm.cloneNode(true);
                                cln.innerHTML=ReplacePlaceholder(cln.innerHTML,dat[subsarr][n],3,path,k8formatter,settings.tabulator.columns);
                                el_new=el_loops[j].appendChild(cln);
                            }
                            el_new.dataset['keyvalue']=dat[subsarr][n][settings['key']];
                            el_new.dataset['rec_index']=index;
                            if(edittype==0){
                                $(el_line).find('.js_rec_delete').hide();
                                $(el_line).find('.js_rec_edit').hide();
                            }else if(settings.rightcheck){
                                if(!Number(dat['rightuser_delete']))$(el_new).find('.js_rec_delete').hide();
                                if(!Number(dat['rightuser_update'])){
                                    $(el_new).find('.js_rec_edit').hide();
                                }
                            }
                            
                            //-----------  conditional output  -------------
                            conditional_output(el_new,dat[subsarr][n]);
                            
                        }
                        if(itm)itm.remove();
                        
                        // src for images
                        el_srcs=$(el_line).find('*[data-src]');
                        for(var n=0;n<el_srcs.length;n++){
                            el_srcs[n].src=el_srcs[n].dataset.src;
                        }                            
                        
                    }
                    //console.log("str=" + str);
                }

                el_line.dataset['keyvalue']=dat[settings['key']];
                el_line.dataset['rec_index']=index;
                
                if(settings.masterdata.edittype==6){
                    if(template=='record')input2display(el_line,dat);
                }
                $(el_line).find('.js_rec_delete').show();
                $(el_line).find('.js_rec_edit').show();
                $(el_line).find('.js_rec_cancel').hide();
                
                if(edittype==0){
                    $(el_line).find('.js_rec_delete').hide();
                    $(el_line).find('.js_rec_edit').hide();
                }else if(settings.rightcheck){
                    if(!Number(dat['rightuser_delete']))$(el_line).find('.js_rec_delete').hide();
                    if(!Number(dat['rightuser_update'])){
                        $(el_line).find('.js_rec_edit').hide();
                    }
                }
               
                if(settings.masterdata.dataLoad) {
                    settings.masterdata.dataLoad(el_line,dat,template);
                }
            }

            function gObject2htmlBuild(area,el_object,obj,namestr){
                namestr=typeof namestr !== 'undefined' ? namestr : '';
                //console.log("namestr=" + namestr);
                if(gbnull(namestr)){
                }
                if(gbnull(obj)){
                }else{
                    var bnewrecord=false;
                    for(var prop in obj){
                        var name='';
                        if(gbnull(namestr)){
                            name=prop;
                        }else if(isNumeric(prop)){
                            name=namestr+'['+prop+']';
                        }else{
                            //name=namestr+prop;
                            name=namestr+'['+prop+']';
                        }

                        if(typeof(obj[prop])=='object' && obj[prop]!==null){
                            var el_objectsub;
                            var arrayname;
                            var bsub=true;
                            if(isNumeric(prop)){
                                arrayname=getobjectfromstrCatalog(namestr);
                                if(el_object){
                                    bnewrecord=true;
                                    var key=settings.key;
                                    var key_preset='';
                                    if(settings.childfieldnames[arrayname]){
                                        key=settings.childfieldnames[arrayname].key;
                                        key_preset=arrayname;
                                    }
                                    el_objectsub=addhtmlrecord(area,el_object,undefined,obj[prop],key_preset,key);
                                }else{
                                }
                            }else{
                                // array-name
                                arrayname=prop;
                                if(typeof(el_object)=='object'){
                                    el_objectsub=$(el_object).find("div[data-rec_object='"+arrayname+"']")[0];
                                    //console.log(" -> " + arrayname); 
                                }else{
                                    el_objectsub=$(el_form).find("div[data-rec_object='"+arrayname+"']")[0];
                                    //console.log("form -> " + arrayname); 
                                }
                                if(Object.keys(obj[prop]).length==0){
                                    bsub=false;
                                }
                            }
                            if(bsub)gObject2htmlBuild(area,el_objectsub,obj[prop],name);
                        //}else if(typeof(obj[prop])=='function'){ 
                        //}else if (obj.hasOwnProperty(prop)) { 
                        //}else{
                            //console.log(name + " no OwnProperty");
                        }
                    }
                }
            }

            function addhtmlrecord(area,el_rec_container,before_rec_index,dat,key_preset,key){
                // arrayname=hauptcontainer?
                
                var indexmax=[];
                var arrayname=el_rec_container.dataset.rec_object;
                //var dat={};
                dat=typeof dat !== 'undefined' ? dat :{};

                // add record in the actual container
                dat['index_'+arrayname]=Number(el_rec_container.dataset.rec_indexmax);
                dat['index_'+arrayname]++;
                el_rec_container.dataset.rec_indexmax=dat['index_'+arrayname];

                /*
                // getting parent record
                var el_rec_record_lfd=$(el_rec_container).parents('.js_rec_record')[0];

                while(el_rec_record_lfd){
                    //indexmax[i]=Number(el_rec_record_lfd.dataset.rec_index);
                    el_rec_container_lfd=$(el_rec_record_lfd).parents('.js_rec_container')[0];
                    if(el_rec_container_lfd){
                        var object_lfd=el_rec_container_lfd.dataset.rec_object;
                        dat['index_'+object_lfd]=Number(el_rec_record_lfd.dataset.rec_index);
                        el_rec_record_lfd=$(el_rec_record_lfd).parents('.js_rec_record')[0];
                    }
                }
                */
               
                var line="";
                var template;
                //if(gbnull(settings['js_rec_record'][arrayname])){
                if(gbnull(settings['html'][area][arrayname])){
                    if(gbnull(settings['html'][area]['record'])){
                        console.log('js_rec_record.'+arrayname+' is empty!');
                    }else{
                        // for recursive
                        template=settings['html'][area]['record'];
                    }
                }else{
                    template=settings['html'][area][arrayname];
                }
                if(gbnull(template)){
                    console.log('js_rec_record.'+arrayname+' no template!');
                }else{
                    line=ReplacePlaceholder(template,dat,settings.masterdata.placeholder_mode,path);    //settings.masterdata.placeholder_mode
                }

                var el_records=$(el_rec_container).find('.js_rec_records')[0];
                if(typeof before_rec_index !== 'undefined'){
                    el_rec_before=$(el_rec_container).find('.js_rec_record[data-rec_index="'+before_rec_index+'"]')[0];
                    if(el_rec_before){
                        $(line).insertBefore(el_rec_before);
                    }else{
                        console.log(el_rec_before+' not found!');
                    }
                }else if($(el_records).children().length>0){
                    $(el_records).children().last().after(line);
                }else{
                    $(el_records).append(line);
                }

                // el_rec_record  bei before !!!!!!!!!
                var el_rec_record=$(el_records).children().last()[0];
                el_rec_record.dataset['rec_index']=dat['index_'+arrayname];
                if(gbnull(key_preset)){
                    el_rec_record.dataset['keyvalue']=dat[key];
                }else{
                    el_rec_record.dataset['keyvalue']=key_preset+'_'+dat[key];
                }
                
                // ---------------------- controls -----------------------
                $(el_rec_record).find('.js_rec_delete').show();
                $(el_rec_record).find('.js_rec_edit').show();
                $(el_rec_record).find('.js_rec_cancel').hide();
                
                if(settings.rightcheck){
                    if(!Number(dat['rightuser_delete']))$(el_rec_record).find('.js_rec_delete').hide();
                    if(!Number(dat['rightuser_update'])){
                        $(el_rec_record).find('.js_rec_edit').hide();
                    }
                }
                
                if(settings.masterdata.newRecord) {
                    settings.masterdata.newRecord(el_rec_record,o);
                }
                conditional_output(el_rec_record,dat);

                return el_rec_record;
            }

            function replaceRecord(dat,selector){
                var el_record=$(el_records).find(selector)[0];
                var index=el_record.dataset.rec_index;
                //var line=ReplacePlaceholder(settings['js_rec_record'][object],dat,settings.masterdata.placeholder_mode,path);
                var line=ReplacePlaceholder(settings.html[object]['record'],dat,settings.masterdata.placeholder_mode,path,k8formatter,settings.tabulator.columns);
                $(el_records).find(selector).replaceWith(line);
                
                var el_line=$(el_records).find('.js_rec_record[data-keyvalue="[keyvalue]"]')[0];
                if(el_line){
                    displaydat(el_line,dat,index);
                    data[index]=dat;
                }else{
                    var el_line=$(el_records).find('.js_rec_record[data-keyvalue="{{keyvalue}}"]')[0];
                    if(el_line){
                        displaydat(el_line,dat,index);
                        data[index]=dat;
                    }else{
                        console.log('replace record not identified!');
                    }
                }
                controlDisabled(false);
            }
            
            function insertRecord(dat,selector,method){
                selector=typeof selector!=='undefined' ? selector:'';        
                method=typeof method!=='undefined' ? method:"last";        
                var el_reference;
                var template='record';
                if(settings.html[object]['recdisp'])template='recdisp';

                //var line=ReplacePlaceholder(settings['js_rec_record'][object],dat,settings.masterdata.placeholder_mode,path);
                var line=ReplacePlaceholder(settings.html[object][template],dat,settings.masterdata.placeholder_mode,path,k8formatter,settings.tabulator.columns);
                if(!gbnull(selector)){
                    el_reference=$(el_records).find(selector)[0];
                    if(!el_reference){
                        console.log('reference='+selector+' not found');
                        return false;
                    }
                }else if(method!="first" && method!="last"){
                    console.log('insertRecord: pls specify selector');
                    return false;
                }
                if(method=="first"){
                    el_line=$(el_records).prepend(line)[0];
                }else if(method=="before"){
                    $(el_records).find(selector).before(line);
                }else if(method=="after"){
                    $(el_records).find(selector).after(line);
                }else if(method=="last"){
                    el_line=$(el_records).append(line)[0];
                }else{
                    console.log('method '+method+'not valid!');
                    return false;
                }
                var el_record;
                if(settings.masterdata.placeholder_mode==2){
                    el_record=$(el_records).find('.js_rec_record[data-keyvalue="{{keyvalue}}"]')[0];
                }else{
                    el_record=$(el_records).find('.js_rec_record[data-keyvalue="[keyvalue]"]')[0];
                }
                if(el_record){
                    var index=Number(el_container.dataset.rec_indexmax)+1;
                    el_container.dataset.rec_indexmax=index;
                    data[index]=dat;
                    displaydat(el_record,dat,index,template);
                }else{
                    console.log('insertRecord, record not inserted!');
                    return false
                }
                controlDisabled(false);

                if(settings.masterdata.dataAfterinsert) {
                    settings.masterdata.dataAfterInsert(el_record,o);
                }
            }

            function deleteRecord(el_record,selector){
                if(!el_record){
                    if(typeof selector!=='undefined'){
                        el_record=$(el_list).find(selector)[0];
                    }else{
                        console.log('deleteRecord.selector='+selector+' not declared!');
                    }
                }
                if(el_record){
                    if(isset(settings.masterdata,'url_del')){
                        var index=el_record.dataset.rec_index;
                        var keyvalue=el_record.dataset.keyvalue;
                        var o={}
                        o[settings.key]=keyvalue;
                        $.getJSON(path+settings.masterdata.url_del,o, function(oJson) {
                            if(oJson.bok){
                                el_record.remove();
                                if(settings.masterdata.ondelete){
                                    settings.masterdata.ondelete(el_record,data[index]);
                                }
                                delete data[index];
                            }else{
                                console.log('error by delete: '+oJson.error);
                            }
                        });
                    }else{
                        console.log('url_del not defined!');
                        el_record.remove();
                        if(settings.masterdata.ondelete){
                            settings.masterdata.ondelete(el_record,data[index]);
                        }
                        delete data[index];
                    }
                }else{
                    console.log('no record!, selector='+selector);
                }
            }
            
            function setPagination(el_parent,$recordcount, mode){ //pagination
                /*
                 * @type @var;mydefault|String|getfromArray.arr|@var;mytable_offset
                var $offset=getfromArray(Array_GET(),'mytable_offset',0);
                var $limit=getfromArray(Array_GET(),'mytable_limit',settings.masterdata.paginationsize); //rows/page
                if(mode=='internal'){
                    $offset=mytable_offset;
                    $limit=mytable_limit;
                }*/
              
                // pageno
              
                var $offset=mytable_offset;
                var $limit=mytable_limit;
                
                var $pagedispmin=0;
                var $pagedispmax=0;
                var $maxchoice=5;

                var el_pag=$(settings.masterdata.paginationtemplate).appendTo(el_parent); 
                var $_GET=Array_GET();
                
                if(($recordcount>$limit && $limit>0) | settings.masterdata.paginationalways){
                    // show 5 pages, actual should be in the middle
                    //$output+='Records: '+$recordcount+', '+getl("pages")+': ';
                    var pagemax=Math.round($recordcount/$limit+0.49);
                    pageno = Math.max(1,Math.min(pagemax,pageno));
                    
                    //var $page=parseInt($offset/$limit)+1;
                    var $url=window.location.pathname.substring(window.location.pathname.lastIndexOf("/")+1);
                    var $delimiter='?'; //iif(gbnull($_SERVER['QUERY_STRING']),'?','&');
                    if(!gbnull(window.location.search)){
                        $delimiter='&';
                    }
                    if(pageno-parseInt($maxchoice/2)>0){
                        //echo 'page: '+pageno+' page+maxchoice: '+(pageno+$maxchoice)+' $pagedispmax: '+$pagedispmax+' pagemax: '+pagemax+'<br>';
                        if((pageno+parseInt($maxchoice/2))<pagemax){
                            $pagedispmin=pageno-parseInt($maxchoice/2);
                        }else{
                            if(pageno-parseInt($maxchoice/2)+1>=1){
                                $pagedispmin=pageno-parseInt($maxchoice/2)+1;
                            }else{
                                $pagedispmin=1;
                            }
                        }
                    }else{
                        $pagedispmin=1;
                    }
                    if(($pagedispmin+$maxchoice-1)>pagemax){
                        $pagedispmax=pagemax;
                    }else{
                        $pagedispmax=$pagedispmin+$maxchoice-1;
                    }
                    //echo 'pageno: '+pageno+' $pagedispmin: '+$pagedispmin+' $pagedispmax: '+$pagedispmax+' pagemax: '+pagemax+'<br>';

                    // ---------------- recordno
                    var el=$(el_pag).find('.js_pag_recordcount')[0];
                    if(el) $('<span>'+getl('Records')+': '+$recordcount+'</span>').appendTo(el)[0];

                    var el_btn=$(el_pag).find('.js_pag_buttons')[0];
                    if(el_btn){
                        
                        // ---------------- < Prev
                        el=$(settings.masterdata.paginationtemplatebtn).appendTo(el_btn)[0];
                        el.innerHTML=getl('Prev');
                        var pageprev=pageno-1;
                        if(pageno<=1)pageprev=1;
                        if(mode=='internal'){
                            el.dataset.pageno=pageprev;
                        }else{
                            $_GET['pageno']=pageprev;
                            el.href=$url+'?'+array2str($_GET);
                        }
                        if(pageno<=1){
                            el.disabled=true;
                            el.classList.add("disabled");
                        }

                        // ------------- generate page numbers
                        for($n=$pagedispmin;$n<=$pagedispmax;$n++){
                            $mytable_offset=($n-1)*$limit;
                            var el=$(settings.masterdata.paginationtemplatebtn).appendTo($(el_pag).find('.js_pag_buttons')[0])[0];
                            el.innerHTML=$n;
                            if(mode=='internal'){
                                el.dataset.pageno=$n;
                            }else{
                                $_GET['pageno']=$n;
                                el.href=$url+'?'+array2str($_GET);
                            }
                            if($n==pageno){
                                el.disabled=true;
                                el.classList.add("disabled");
                            }
                        }

                        // ------------- > next
                        var el=$(settings.masterdata.paginationtemplatebtn).appendTo($(el_pag).find('.js_pag_buttons')[0])[0];
                        el.innerHTML=getl('Next');
                        var pagenext=pageno+1;
                        if(pageno>=pagemax)pagenext=pagemax;
                        if(mode=='internal'){
                            el.dataset.pageno=pagenext;
                        }else{
                            $_GET['pageno']=pagenext;
                            el.href=$url+'?'+array2str($_GET);
                        }
                        if(pageno>=pagemax){
                            el.disabled=true;
                            el.classList.add("disabled");
                        }

                        if(settings.masterdata.pagination=="internal"){
                            $(el_list).find('.js_rec_pagination .js_pag_buttons a').on('click',function(e){
                                e.preventDefault();
                                console.log('pagination');
                                $(el_records).empty();
                                $(el_pagination).empty();
                                loaddata(this.dataset.pageno);
                            });
                        }
                    }

                    // -------------- paginationsize
                    var el=$(el_pag).find('.js_pag_pagerows')[0];
                    if(el){
                        el.classList.add('dropdown');
                        var value_selected=$limit.toString();
                        var obj={"class_ul":"dropdown-menu dropdown-menu-right text-right",
                            "class_li":"text-right",
                            "pretext":getl("Count")+": ",
                            "value_selected":value_selected,
                            "items":[]
                        };
                        var paginationscale=settings.masterdata.paginationscale;
                        for(var i=0;i<paginationscale.length;i++){
                            obj.items[i]={"value":paginationscale[i],"label":paginationscale[i],"href":$url+'?'+array2str($.extend($_GET,{"mytable_limit":paginationscale[i],"pageno":pageno}))};
                        }

                        //displayDropdown(el,obj)
                        obj['el_dd']=el;
                        displayDropdownel(obj);
                        if(settings.masterdata.pagination=="internal"){
                            $(el).find('ul').on("click","a",function(e){
                                e.preventDefault();
                                console.log('paginationsize: '+pageno+' / '+this.dataset.value);
                                $(el_records).empty();
                                $(el_pagination).empty();
                                loaddata(pageno,this.dataset.value);
                            });
                            /*
                            obj['onClick']=function(){
                                    $(el_ul).on("click","a",function(e){
                                        e.preventDefault();
                                        console.log('paginationsize: '+pageno+' / '+this.dataset.value);
                                        $(el_records).empty();
                                        $(el_pagination).empty();
                                        loaddata(pageno,this.dataset.value);
                                    });
                                };
                            */
                        }                    
                    }                    
                }else{
                    console.log("recordcount="+$recordcount);
                }
                return;
            }
            
            // deprecated not used any more
            function TableNavigation($recordcount, mode){ //pagination
                // $gdatareadlimitpage;
                // mytable_limit

                $gdatareadlimitpage=settings.masterdata.paginationsize;
                $ajxfunction='';
                $maxchoice=5;
                if(mode=='internal'){
                    $offset=mytable_offset;
                    $limit=mytable_limit;
                }else{
                    $offset=getfromArray(Array_GET(),'mytable_offset',0);
                    $limit=getfromArray(Array_GET(),'mytable_limit',$gdatareadlimitpage); //rows/page
                }
                
                $output='<div>';
                $pagedispmin=0;
                $pagedispmax=0;
                // pages start count: 1
                // offset start count: 0
                // 
                // with $_GET
                //echo $_SERVER['QUERY_STRING']+'offset: '+$offset+' $limit: '+$limit+' $recordcount: '+$recordcount+' $gdatareadlimitpage: '+$gdatareadlimitpage+'<br>';

                if($recordcount>$limit && $limit>0){
                    // show 5 pages, actual should be in the middle
                    $output+=getl('Records')+': '+$recordcount+', '+getl("pages")+': ';
                    $pagemax=Math.round($recordcount/$limit+0.49);
                    $page=parseInt($offset/$limit)+1;
                    $url=window.location.pathname.substring(window.location.pathname.lastIndexOf("/")+1);
                    $delimiter='?'; //iif(gbnull($_SERVER['QUERY_STRING']),'?','&');
                    if($page-parseInt($maxchoice/2)>0){
                        //echo 'page: '+$page+' page+maxchoice: '+($page+$maxchoice)+' $pagedispmax: '+$pagedispmax+' $pagemax: '+$pagemax+'<br>';
                        if(($page+parseInt($maxchoice/2))<$pagemax){
                            $pagedispmin=$page-parseInt($maxchoice/2);
                        }else{
                            if($page-parseInt($maxchoice/2)+1>=1){
                                $pagedispmin=$page-parseInt($maxchoice/2)+1;
                            }else{
                                $pagedispmin=1;
                            }
                        }
                    }else{
                        $pagedispmin=1;
                    }
                    if(($pagedispmin+$maxchoice-1)>$pagemax){
                        $pagedispmax=$pagemax;
                    }else{
                        $pagedispmax=$pagedispmin+$maxchoice-1;
                    }
                    //echo '$page: '+$page+' $pagedispmin: '+$pagedispmin+' $pagedispmax: '+$pagedispmax+' $pagemax: '+$pagemax+'<br>';


                    // <
                    if($pagedispmin>1){
                        $mytable_offset=($pagedispmin-2)*$limit;
                        //echo getParameter('add',$_SERVER['QUERY_STRING'],'mytable_offset='+$mytable_offset)+'<br>';
                        if(mode=='internal'){
                            $output+='<a data-offset="'+$mytable_offset+'" href="#">'+htmlspecialchars('<')+'</a> ';
                        }else if(gbnull($ajxfunction)){
                            $urldisp=$url+$delimiter+$.param($.extend(Array_GET(),{'mytable_offset':$mytable_offset}));
                            $output+='<a href="'+$urldisp+'">'+htmlspecialchars('<')+'</a> ';
                        }else{
                            $temp=str_replace(')',iif(instr($ajxfunction,'()')>=0,'',',')+gsstr2sql('&mytable_offset='+$mytable_offset)+')',$ajxfunction);
                            $output+='<a style="text-decoration: underline; cursor: pointer;" onclick="'+$temp+'">'+htmlspecialchars('<')+'</a> ';
                        }
                    }else{
                        //$output+=htmlspecialchars('< ');
                    }

                    // generate page numbers
                    for($n=$pagedispmin;$n<=$pagedispmax;$n++){
                        if($n==$page){
                            $output+=$page+' ';
                        }else{
                            $mytable_offset=($n-1)*$limit;
                            if(mode=='internal'){
                                $output+='<a data-offset="'+$mytable_offset+'" href="#">'+$n+'</a> ';
                            }else if(gbnull($ajxfunction)){
                                $urldisp=$url+$delimiter+$.param($.extend(Array_GET(),{'mytable_offset':$mytable_offset}));
                                $output+='<a href="'+$urldisp+'">'+$n+'</a> ';
                            }else{
                                //$temp=str_replace(')',gsstr2sql('&mytable_offset='+$mytable_offset)+')',$ajxfunction);
                                $temp=str_replace(')',iif(instr($ajxfunction,'()')>=0,'',',')+gsstr2sql('&mytable_offset='+$mytable_offset)+')',$ajxfunction);
                                $output+='<a style="text-decoration: underline; cursor: pointer;" onclick="'+$temp+'">'+$n+'</a> ';
                            }
                        }
                    }

                    // >
                    if($pagedispmax<$pagemax){
                        $mytable_offset=($pagedispmax)*$limit;
                        if(gbnull($ajxfunction)){
                            $urldisp=$url+$delimiter+getParameter('add',$_SERVER['QUERY_STRING'],'mytable_offset='+$mytable_offset);
                            $output+='<a href="'+$urldisp+'">'+htmlspecialchars('>')+'</a> ';
                        }else{
                            $temp=str_replace(')',iif(instr($ajxfunction,'()')>=0,'',',')+gsstr2sql('&mytable_offset='+$mytable_offset)+')',$ajxfunction);
                            $output+='<a style="text-decoration: underline; cursor: pointer;" onclick="'+$temp+'">'+htmlspecialchars('>')+'</a> ';
                        }
                    }else{
                        //$output+=htmlspecialchars('> ');
                    }

                    if(mode="internal"){
                    }else{
                        $output+='<form style="float: left;" method="GET" name="navigationbar" id="navigationbar">';
                        //$output+='<input type="hidden" name="mytable_offset" value="'+$offset+'">';
                        //if($page>1){
                        if(1){
                            $output+='<input type="hidden" name="mytable_limit" value="'+$limit+'">';
                        }else{
                            $output+='<select name="mytable_limit" onchange="document+forms[\'navigationbar\']+submit()">'+
                                    '<option value="10"'+iif($limit==10,' selected','')+'>10</option>'+
                                    '<option value="25"'+iif($limit==25,' selected','')+'>25</option>'+
                                    '<option value="50"'+iif($limit==50,' selected','')+'>50</option>'+
                                    '<option value="100"'+iif($limit==100,' selected','')+'>100</option>'+
                                    '</select>';
                        }
                        $output+='</form>';
                    }
                    
                }
                return $output;
            }
            
        }else{
            console.log('selector undefined');
        }

        function addrecord(el_rec_container){
            var index_obj={};
            if(settings.masterdata.defaultvalues){
                index_obj=settings.masterdata.defaultvalues;
            }
            index_obj['index']=-1;
            index_obj['keyvalue']=0;
            //var line=ReplacePlaceholder(settings['js_rec_record'][object],index_obj,settings.masterdata.placeholder_mode,path);
            var line=ReplacePlaceholder(settings.html[object]['record'],index_obj,settings.masterdata.placeholder_mode,path,k8formatter,settings.tabulator.columns);
            var el_records=$(el_rec_container).find('.js_rec_records')[0];
            var el_record=$(line).appendTo(el_records)[0];
            //$(el_records).append(line);
            //el_record=$(el_records).find('.js_rec_record').last()[0];
            //el_record=replaceElWith(el_record,line);
            el_record.dataset.rec_index=-1;
            
            // default values
            if(isset(settings,'masterdata','defaultvalues')){
                el_form=$(el_records).parents('form')[0];
                if(Array.isArray(settings.masterdata.defaultvalues)){
                    if(settings.masterdata.defaultvalues.length>0){
                        for(var i=0;i<settings.masterdata.defaultvalues.length;i++){
                            var name=settings.masterdata.defaultvalues[i]['name'];
                            if(el_form.elements.namedItem(name)){
                                el_form.elements.namedItem(name).value=settings.masterdata.defaultvalues[i]['value'];
                            }
                        }
                    }
                    
                }else{
                    obj2form(settings.masterdata.defaultvalues,el_form);
                }
            }
            
            // conditional output !!
            // loop !!!!!

            //el_record=$(el_list).find('.js_rec_record[data-rec_index="'+indexmax+'"]')[0];
            if(el_record){
                $(el_record).find('input:visible,select:visible,textarea:visible').first().focus();
                $(el_record).find('.js_rec_delete').hide();
                $(el_record).find('.js_rec_edit').hide();
                $(el_record).find('.js_rec_cancel').show();
                //$(el_record).find('.js_rec_save').show();
                //$(el_record).find('.js_rec_save').prop("disabled",false);
                var el_marker=$(el_record).find('.js_contain_submit')[0];
                if(!el_marker){
                    el_marker=$(el_record).find('.recordmarker')[0];
                }
                if(el_marker){
                    $(el_marker).append(settings.masterdata.lineeditsubmit);
                }
                
            }else{
                console.log('el_record not found!');
            }
            return el_record
        }
        
        function data2form(dat){
            var el_form=$(el_list).find('form')[0];
            for(var i=0;i<el_form.elements.length;i++){
                //var columnname=getSubName('columnname',el_form.elements[i].name);
                var columnname=el_form.elements[i].name;
                if(isset(dat,columnname))el_form.elements[i].value=getfromArray(dat,columnname);
            }
        }
        
        function saverecord(el_record){
            var el_form=$(el_record).parents('form')[0];
            var index=Number(el_record.dataset.rec_index);
            var keyvalue=el_record.dataset.keyvalue;
            //if(data[index])dat=data[index];
            var dat=form2obj(el_form);
            if(settings.masterdata.dataBeforeSave) {
                settings.masterdata.dataBeforeSave(el_record,dat);
            }
            if(isset(settings.masterdata,'url_save')){
                if(settings.displaycolumn)console.log("saverecord="+dat[settings.displaycolumn]);
                dat[settings.key]=keyvalue;
                $.getJSON(path+settings.masterdata.url_save,dat, function(oJson) {
                    if(oJson.bok){
                        if(gbnull(dat[settings.key])){
                            keyvalue=oJson.bok;
                            dat[settings.key]=oJson.bok;
                            el_record.dataset.keyvalue=keyvalue;
                        }
                        dat=oJson.dat;
                        _saverecord(el_record,dat);
                        /*
                        data[index]=dat;
                        if($plugin.data("data")){
                            $plugin.data("data")[index]=dat;
                        }
                        dat['keyvalue']=keyvalue;
                        dat['index']=index;
                        var template='record';
                        if(settings.html[object]['recdisp']){
                            template='recdisp';
                            var line=ReplacePlaceholder(settings.html[object][template],dat,settings.masterdata.placeholder_mode,path,k8formatter,settings.tabulator.columns);
                            $(el_record).replaceWith(line)[0];
                            el_record=$(el_records).find('.js_rec_record[data-keyvalue="'+keyvalue+'"]')[0];
                        }else{
                            input2display(el_record,dat);
                        }
                        $(el_record).find('.js_rec_delete').show();
                        $(el_record).find('.js_rec_edit').show();
                        $(el_record).find('.js_rec_cancel').hide();
                        //$(el_record).find('.js_rec_save').hide();
                        //$(el_record).find('.js_rec_save').prop("disabled",true);
                        $(el_record).find('.js_rec_save').remove();
                        if(edittype==6 || edittype==7)controlDisabled(false);

                        if(settings.masterdata.dataLoad){
                            settings.masterdata.dataLoad(el_record,dat,template);
                        }
                        */
                    }else{
                        console.log('error by save: '+oJson.error);
                    }
                })
                .fail(function(jqxhr, textStatus, error ) {
                    var err = textStatus + ", " + error;
                    console.log("saverecord.Request Failed: " + err );
                });
            }else{
                console.log("url_save not set!");
                _saverecord(el_record,dat)
            }
        }
        
        function _saverecord(el_record,dat){
            var el_rec_container=$(el_record).parents('.js_rec_container')[0];
            var index=Number(el_record.dataset.rec_index);
            var bnew=false;
            if(index==-1){
                index=Number(el_rec_container.dataset.rec_indexmax)+1;
                bnew=true;
                el_rec_container.dataset.rec_indexmax=index;
            }
            var keyvalue=0;
            if(isset(settings,'key'))keyvalue=getfromArray(dat,settings.key);
            data[index]=dat;
            if($plugin.data("data")){
                $plugin.data("data")[index]=dat;
            }
            //dat['keyvalue']=keyvalue;
            dat['index']=index;
            var template='record';
            if(settings.html[object]['recdisp']){
                template='recdisp';
                var line=ReplacePlaceholder(settings.html[object][template],dat,settings.masterdata.placeholder_mode,path,k8formatter,settings.tabulator.columns);
                //$(el_record).replaceWith(line)[0];
                //el_record=$(el_records).find('.js_rec_record[data-keyvalue="'+keyvalue+'"]')[0];
                el_record=replaceElWith(el_record,line);
            }else{
                input2display(el_record,dat);
            }
            if(bnew || settings.html[object]['recdisp']){
                el_record.dataset.rec_index=index;
                el_record.dataset.keyvalue=keyvalue;
            }
            $(el_record).find('.js_rec_delete').show();
            $(el_record).find('.js_rec_edit').show();
            $(el_record).find('.js_rec_cancel').hide();
            //$(el_record).find('.js_rec_save').hide();
            //$(el_record).find('.js_rec_save').prop("disabled",true);
            $(el_record).find('.js_rec_save').remove();
            if(edittype==6 || edittype==7)controlDisabled(false);
            if(settings.masterdata.dataLoad) {
                settings.masterdata.dataLoad(el_record,dat,template);
            }
        }
        
        //window.addEventListener('scroll',reachbottom);
        
        function conditional_output(el,dat){
            el_conditions=$(el).find('*[data-v_if]');
            for(var j=0;j<el_conditions.length;j++){
              var str=el_conditions[j].dataset.v_if;
              var mode=el_conditions[j].dataset.v_mode;
              mode=typeof mode !== 'undefined' ? mode : "empty";

              //console.log("str=" + str);
              try{
                if(!eval(str)){
                    switch(mode){
                        case 'hide':
                            $(el_conditions[j]).hide();
                            break;
                        case 'remove':
                            $(el_conditions[j]).remove();
                            break;
                        case 'empty':
                            $(el_conditions[j]).empty();
                            break;
                    }
                }
              }
              catch(e){
                // error
                console.log('error by expression: '+str);
              }
            }
          /*  
          el_conditions=$(el).find('*[data-v_if]');
          for(var i=0;i<el_conditions.length;i++){
            var str=el_conditions[i].dataset.v_if;
            //console.log("str=" + str);
            try{
              if(!eval(str)){
                //$(el_conditions[i]).hide();
                //el_conditions[i].remove();
                $(el_conditions[i]).empty();
              }
            }
            catch(e){
              // error
              console.log('error by expression: '+str);
            }
          }
           */
        }   

        function input2display(el_record,dat){
            var fields=$(el_record).find('input,select,textarea');
            for(var n=0;n<fields.length;n++){
                if(fields[n].type=="hidden"){
                    //$(fields[n]).replaceWith("");
                    $(fields[n]).remove();
                }else if(fields[n].tagName=="SELECT"){
                    // selected
                    var value=getfromArray(dat,fields[n].name);
                    var text="";
                    var options=fields[n].options;
                    for(var i=0;i<options.length;i++){
                        if(options[i].value==value){
                            text=options[i].text;
                            break;
                        }
                    }
                    var html='<div class="k8-label-table">'+text+'</div>';
                    $(fields[n]).replaceWith(html);
                }else{
                    //var columnname=getSubName('columnname',fields[n].name);
                    var columnname=fields[n].name;
                    var value=getfromArray(dat,columnname);
                    if(typeof k8formatter !=='undefined' && isset(settings,"tabulator","columns")){
                        var index=getArrayIndexfromValue(settings.tabulator.columns,'field',columnname);
                        if(index>-1){
                            if(isset(settings.tabulator.columns[index])){
                                value=k8formatter.format(settings.tabulator.columns[index],value);
                            }   
                        }
                    }

                    var html='<div class="k8-label-table">'+value+'</div>';
                    $(fields[n]).replaceWith(html);
                }
            }
            //var fields=$(el_record).find('.k8-field-icon');
            var fields=$(el_record).find('.js_rec_control');
            for(var n=0;n<fields.length;n++){
                $(fields[n]).css("display","none");
            }   
            /*
            var fields=$(el_record).find('.glyphicon');
            for(var n=0;n<fields.length;n++){
                $(fields[n]).css("display","none");
            }
            */
        }
            
        function getData(){
            /*
            console.log( "$data.length: " + $plugin.data("data").length);
            console.log( "getData.length: " + data.length);
            for(var n;n<data.length;n++){
                console.log(data[settings.displaycolumn]);
            }
            */
            return $plugin.data("data");
        }
        return{"listedit":el_list,"addrecord":addrecord,"input2display":input2display,"data2form":data2form,"saverecord":saverecord,"replaceRecord":replaceRecord,"insertRecord":insertRecord,"deleteRecord":deleteRecord,"getData":getData,"data":getData};
    };
}(jQuery ));


(function ($) {
    $.fn.tabulatoredit = function( options ) {
        // settings['js_rec_record'][object]
        
        var settings = $.extend({
        }, options );

        return this.each(function(){
            // create listbox
            var el_list=this;
            // ------------------------------------------ Tabulator -------------------------------------------
            var row_actual=0;
            var bdelclicked=false;
            var keyfield=settings['key'];
            var otable=$.extend({
                rowClick:function(e, row){ //trigger an alert message when the row is clicked
                    if(!bdelclicked){
                        //console.log("Row " + row.getPosition() +' ID='+row.getData().ID + " Clicked");
                    }
                    bdelclicked=false;
                }
            },
            {
                ajaxFiltering:true,
                height:205, 
                layout:"fitColumns"
            });

            //-------------------------------- Define Table Columns
            //custom formatter definition
            var printIcon = function(cell, formatterParams, onRendered){ //plain text value
                var rightuser_delete=true;
                var rightuser_update=false;
                if(settings.rightcheck!=0){
                    rightuser_update=Number(getfromArray(cell.getData(),'rightuser_update',false));
                    rightuser_delete=Number(getfromArray(cell.getData(),'rightuser_delete',false));
                }
                var html="";
                if(rightuser_delete)html+='<img src="'+getfromArray(settings.masterdata,'root')+'masterdata/pic/icon_delete.png" alt="delete" title="delete">  ';
                if(settings.rightcheck!=0){
                    if(rightuser_update){
                        //html+='<img src="'+getfromArray(settings.masterdata,'root')+'masterdata/pic/icon_edit.png" alt="edit" title="edit">';
                    }else{
                        html+='<img src="'+getfromArray(settings.masterdata,'root')+'masterdata/pic/icon_no_edit.png" alt="edit" title="edit">';
                    }
                }
                return html;
            };
            otable.columns=settings.tabulator.columns;
            for(var i=0;i<otable.columns.length;i++){
                if(!otable.columns[i].hasOwnProperty('editor')){
                    otable.columns[i]['editor']=true;
                }
            }
            otable.columns.unshift({"headerSort":false,"formatter":printIcon, "width":50, "align":"center", 
                "cellClick":function(e, cell){
                    //console.log('event.delete');
                    if((settings.rightcheck!=0 && Number(getfromArray(cell.getData(),'rightuser_update',false))) || settings.rightcheck==0){
                        if(confirm('Delete really?')){
                            bdelclicked=true;
                            var o={};
                            o[keyfield]=cell.getData()[keyfield];
                            $.getJSON(path+settings.masterdata.url_del,o, function(oJson) {
                                if(oJson.bok){
                                    cell.getRow().delete();
                                    row_actual=0;
                                    initForm();
                                }else{
                                    // !!!!!!!!!! el_form.getElementById('res').innerHTML=oJson.error;
                                }
                            })
                            .fail(function(jqxhr, textStatus, error ) {
                                var err = textStatus + ", " + error;
                                    //console.log( "Request Failed: " + err );
                            });			
                        }
                    }
                }
            });

            //create Tabulator on DOM element with id "example-table"
            var tableTab = new Tabulator(el_list, otable);

            //-------------------------------- tabledata
            tableTab.setData(path+settings.masterdata.url_readfilter,settings.masterdata.data_readfilter);
            //$(this).find('.resize-s').resizable({handles:"s"});
            
            
        });
    };
}(jQuery ));